

public class TaskEaterImpl extends
      java.rmi.server.UnicastRemoteObject implements TaskEater,Runnable{

	private State state = new State();
	private TaskManager tm;
	private long lastTimeGoal;
	private long lastElapsedTime;
	private Object lastParam;
	private ThiefVictimAgent tva;
	private Task t;
	private int timeOut;

	private static int taskEaterWorking;
	private static int taskEaterWaitSon;
	private static int taskEaterWaitStealing;
	private static int nTaskEater;
	private static int taskEaterDone;

	public TaskEaterImpl(TaskManager tm,ThiefVictimAgent tva,int timeOut) throws java.rmi.RemoteException{

		super();
		this.tm = tm;
		this.tva = tva;
		this.t = null;
		this.timeOut = timeOut;
		setnTaskEater();
    }

	 public TaskEaterImpl(TaskManager tm,ThiefVictimAgent tva,int timeOut,Task root) throws java.rmi.RemoteException{

		super();
		this.tm = tm;
		this.tva = tva;
		this.t = root;
		this.timeOut = timeOut;
		setnTaskEater();
    }

	private synchronized static int getnTaskEater(){
	//return the total number of activated TE
		return nTaskEater;
	}

		private synchronized static void setnTaskEater(){
	//a new Task Eater was created so TEworking++ and nTE++
		nTaskEater++;
		taskEaterWorking++;
		//System.out.println("nTE= "+nTaskEater+" done = "+taskEaterDone);
	}

	private synchronized static int getTaskEaterDone(){
	//return the total number of activated TE
		return taskEaterDone;
	}

	private synchronized static int getTaskEaterWorking(){
	//return the number of working TE
		return taskEaterWorking;
	}

	private synchronized static int getTaskEaterWaitSon(){
	//return the number of waiting sons TE
		return taskEaterWaitSon;
	}

	private synchronized static int getTaskEaterWaitStealing(){
	//return the number of waiting stealing TE
		return taskEaterWaitStealing;
	}

	private synchronized static void stateTransition(State from, int to){
	//transition from state "from" to state "to"
	//modify the object state and the statics variables
		switch(from.value){ //update statics variables
		case State.working :
			taskEaterWorking--;
			break;
		case State.waitStealing :
			taskEaterWaitStealing--;
			break;
		case State.waitSon :
			taskEaterWaitSon--;
			break;
		}

		from.value = to;

		switch(to){//update statics variables
		case State.working :
			taskEaterWorking++;
			break;
		case State.waitStealing :
			taskEaterWaitStealing++;
			break;
		case State.waitSon :
			taskEaterWaitSon++;
			break;
		case State.done :
			taskEaterDone++;
			break;
		}
	}

	public void run(){
		if (t!=null){ //start the application with root Task
			//insert a lazy task (son) in taskManager
			Task son = (Task) t.clone();//get a copy
			//set internal variables
			son.setFather(this);//set father -> this TaskEater
			son.setFatherID(t.getID());
			Interval inter = t.getNewInterval();
			son.setID(inter.begin,inter.limit);//set ID
			son.setTimeGoal(t.getTimeGoal());
			try{
				WorkCriteria wc = (WorkCriteria) (t.getWorkCriteria()).clone();
				son.setWorkCriteria(wc);
			}catch(CloneNotSupportedException e){
				System.out.println("Unable to clone Task's WorkCriteria :" + e);
			}
			tm.insertTask(son);
			//execute
			t.run();
			//clean taskmanager, erasing task's son
			tm.clearSon(t.getID());
			//join
			if (t.someActivated()){
				TaskEaterImpl.stateTransition(this.state,State.waitSon);
				while(t.sonsWorking() !=0){//wait all sons sent their results
					if (getnTaskEater() == getTaskEaterWaitSon())//create a new TE if any other is not working
						newTaskEater();
					try{
						synchronized(this){
							wait(1000);
						}
					}catch(InterruptedException ie){
						System.out.println("Error trying to wait() : "+ie);
					}
				}
			}
			TaskEaterImpl.stateTransition(this.state,State.working);
			//merge
			t.merge();
			//store the last timegoal, elapsedtime and param for getting a estimation of its capacity
			lastTimeGoal = t.getTimeGoal();
			lastElapsedTime = t.getElapsedTime();
			lastParam = t.getParam();						
		}
		//stay in a infinite loop getting and executing tasks
		while(true){
			t = tm.getTask(new Who(-1,lastElapsedTime,lastTimeGoal,lastParam)); //get a task
			if (t==null){ //there aren't any task
				TaskEaterImpl.stateTransition(this.state,State.waitStealing);
				//trigger stealing mechanism
				int count = 1;
				do{ //repeat until there are task or timeOut
						t = ((ThiefVictimAgentImpl) tva).stealTask(new Who(-1,lastElapsedTime,lastTimeGoal,lastParam));
						count++;						
				}while(t == null & count <= timeOut);
				if (t==null){ //couldn't get a task
					TaskEaterImpl.stateTransition(this.state,State.done);
					System.out.println("There aren't task/work to do anymore !!!!");
					if (getnTaskEater()==getTaskEaterDone()){
						System.out.println("There aren't any task eater working on this node => halt");
						System.exit(0);
					}
					break;
				}
			}
			System.out.println("#### A tarefa "+t.getFatherID()+":"+t.getID()+" comecou com NS= "+((MCflex) t).getNStotal());
			//insert a lazy task (son) in taskManager
			Task son = (Task) t.clone();//get a copy
			//set internal variables
			son.setFather(this);//set father -> this TaskEater
			son.setFatherID(t.getID());
			Interval inter = t.getNewInterval();
			son.setID(inter.begin,inter.limit);//set ID
			son.setTimeGoal(t.getTimeGoal());
			try{
				WorkCriteria wc = (WorkCriteria) (t.getWorkCriteria()).clone();
				son.setWorkCriteria(wc);
			}catch(CloneNotSupportedException e){
				System.out.println("Unable to clone Task's WorkCriteria :" + e);
			}
			tm.insertTask(son);
			TaskEaterImpl.stateTransition(this.state,State.working);
			//execute
			t.run();
			//clean taskmanager, erasing task's son
			tm.clearSon(t.getID());
			//join
			if (t.someActivated()){
				TaskEaterImpl.stateTransition(this.state,State.waitSon);
				while(t.sonsWorking() != 0){//wait all sons sent their results
					if (getnTaskEater() == getTaskEaterWaitSon())//create a new TE if any other is not working
						newTaskEater();
					try{
						synchronized(this){
							wait(1000);
						}
					}catch(InterruptedException ie){
							System.out.println("Error trying to wait() : "+ie);
					}
				}
			}
   		TaskEaterImpl.stateTransition(this.state,State.working);
			//merge
			t.merge();
			//store the last timegoal, elapsedtime and param for getting a estimation of its capacity
			lastTimeGoal = t.getTimeGoal();
			lastElapsedTime = t.getElapsedTime();
			lastParam = t.getParam();
			}
	}

	public synchronized Object getWork(Who who){
	//set control variables and call task's  getWork
		if (t == null)
			return null;
		Object obj = t.getWork(who);
		if (obj != null){//there are work to do
			t.sonsWorking();
			t.sonActivated();
		}
		return obj;
	}

	public synchronized void sendResults(Object param, long who) throws java.rmi.RemoteException {
	//set control variables and call task's  sendResults

		t.sonDone();
		notifyAll();
		t.sendResults(param,who);
	}

	private void newTaskEater(){
	//create a new TEImpl
		try{
			TaskEaterImpl te = new TaskEaterImpl(this.tm,this.tva,this.timeOut);
			Thread t = new Thread(te);
			t.start();
		}catch(java.rmi.RemoteException re){
			System.out.println("Error trying to create a new TaskEater: "+re);
		}
	}

	public Interval getNewInterval(){
		return (t.getNewInterval());
	}

}
