// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda;



/**
 * Super-class of resource constraints that operate over a given resource attribute.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-05-04 10:26:55 -0300 (Wed, 04 May 2005) $ $Revision: 845 $
 */
public abstract class AttributeConstraint
    extends StaticResourceConstraint
{
        /**
         * Creates a new <code>AttributeConstraint</code> instance.
         *
         * @param attr a <code>String</code> value
         */
    protected AttributeConstraint(String attr)
        {
            if ( attr == null || "".equals(attr.trim())) {
                throw new IllegalArgumentException(
                    "Invalid attribute name: \""+attr+"\"");
            }
            
            this.attrName = attr;
        }
    
        /**
         * Returns the name of the attribute being checked by the constraint.
         *
         * @return a <code>String</code> value
         */
    public String
    getAttributeName()
        {
            return this.attrName;
        }
    

    protected String attrName;
}
