// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.HostId;
import org.isam.exehda.ApplicationId;
import java.util.Date;


public interface Gateway
{
    public static final String SERVICE_NAME = "gateway";

    public static class GwPermission
    {
            /**
             * Creates a new <code>GwPermission</code> instance.
             *
             * @param key an <code>Object</code> value
             * @param app an <code>ApplicationId</code> value
             * @param targets a <code>HostId[]</code> value
             * @param lease a <code>Date</code> value
             */
        public GwPermission( Object key, ApplicationId app, HostId[] targets, Date lease )
            {
                throw new NullPointerException("Not yet implemented.");
            }
     
            /**
             * Describe <code>getKey</code> method here.
             *
             * @return an <code>Object</code> value
             */
        public Object getKey()
            {
                throw new NullPointerException("Not yet implemented.");
            }
        
            /**
             * Describe <code>getApplication</code> method here.
             *
             * @return an <code>ApplicationId</code> value
             */
        public ApplicationId getApplication()
            {
                throw new NullPointerException("Not yet implemented.");
            }
            
            /**
             * Describe <code>getTargets</code> method here.
             *
             * @return a <code>HostId[]</code> value
             */
        public HostId[] getTargets()
            {
                throw new NullPointerException("Not yet implemented.");
            }
        
            /**
             * Describe <code>getExpirationTime</code> method here.
             *
             * @return a <code>Date</code> value
             */
        public Date getExpirationTime()
            {
                throw new NullPointerException("Not yet implemented.");
            }
    }
    
        /**
         * Describe <code>grant</code> method here.
         *
         * @param app an <code>ApplicationId</code> value
         * @param targets a <code>HostId[]</code> value
         * @param leaseMinutes a <code>long</code> value
         * @return a <code>GwPermission</code> value
         */
    public GwPermission grant ( ApplicationId app, HostId[] targets, long leaseMinutes );

        /**
         * Describe <code>drop</code> method here.
         *
         * @param perm a <code>GwPermission</code> value
         */
    public void drop ( GwPermission perm );

        /**
         * Describe <code>renew</code> method here.
         *
         * @param perm a <code>GwPermission</code> value
         * @param leaseMinutes a <code>long</code> value
         * @return a <code>GwPermission</code> value
         */
    public GwPermission renew ( GwPermission perm, long leaseMinutes );
}

