//  
// PRIMOS - Primitives for Object Scheduling 
//  
// Copyright (C) 2002 Luciano Cavalheiro da Silva  <lucc@inf.ufrgs.br> 
//                    Claudio Fernando Resin Geyer <geyer@inf.ufrgs.br>
//  
// This file is part of PRIMOS. 
//  
// PRIMOS is free software; you can redistribute it and/or 
// modify it under the terms of the GNU General Public License 
// as published by the Free Software Foundation; either version 2 
// of the License, or any later version. 
//  
// PRIMOS is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//  
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
//

/**
* @file  MonitorImpl.icc
* @brief Selects the appropriated monitor implementation.
*
* @cvsid $Id: MonitorImpl.cc 359 2004-11-03 18:15:28Z lucc $
*/

#ifdef HAVE_CONFIG_H
#  include <acconfig.h>
#endif

#if (defined PROCFS_LINUX_2_4 || defined PROCFS_LINUX_2_6)
#  include <LinuxMonitorImpl.cc>
#elif defined HAVE_KSTAT_H
#  include <SolarisMonitorImpl.cc>
#else
#  error "Unsupported /proc version."
#endif

