// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.worb;


import org.isam.perv.IsamClassLoader;


/**
 * An object input stream that uses the IsamClassLoader to resolve classes.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-04-08 15:31:37 -0300 (Fri, 08 Apr 2005) $ $Revision: 738 $
 */
class WorbObjectInputStream
    extends java.io.ObjectInputStream
{
    public WorbObjectInputStream(java.io.InputStream in)
        throws java.io.IOException
        {
            super(in);
        }
    
        /**
         * Resolves the given class definitition using the IsamClassLoader
         *
         * @param v a <code>java.io.ObjectStreamClass</code> value
         * @return a <code>Class</code> value
         * @exception java.io.IOException if an error occurs
         * @exception ClassNotFoundException if an error occurs
         */
    protected Class 
    resolveClass(java.io.ObjectStreamClass v)
        throws java.io.IOException, ClassNotFoundException
        {
            return IsamClassLoader.getInstance().loadClass(v.getName());
        }
}
