package  org.isam.exehda.services.dhc;

import java.net.*;

/*
 * UDPServer - Listen for UDP broadcasts and responds with server location
 */

public class UDPClient {
    
   
    int length;
    byte[] buf;
    InetAddress group;
    int timeout;
    MulticastSocket s;
    
    //creates client and binds to defined address
    public UDPClient(int timeout){
	
	length = 5;
	buf = new byte[1000];
	this.timeout = timeout;

	try{
	    //229.5.6.7 is the magic address
	    group = InetAddress.getByName("229.5.6.7");
	    s = new MulticastSocket(6789);
	    s.joinGroup(group);
	}catch(Exception e){e.printStackTrace();}
    }

    //sends multicast messages trying to find host location
    // returns the host ip or null if none is found
    public String queryHost(){
	
	//standar query message
	String msg = "Host Query";
	String host = "";

	try{
	    //if there is no response in timeout ms aborts
	    s.setSoTimeout(timeout);
	    DatagramPacket packet = new DatagramPacket(msg.getBytes(), msg.getBytes().length,group, 6789);
	    s.send(packet);
	   
	    
	    packet = new DatagramPacket(buf, buf.length);
	    // the server(or another client) should respond with addres
	    s.receive(packet);
	    
	    String data = new String(packet.getData(),0,packet.getLength());
	    //System.out.println("Come again -- "+data);
	    //tests wheter it is a response message
	    while(!data.startsWith("Host Query Result:")){
	
		s.receive(packet);
		
		data = new String(packet.getData(),0,packet.getLength());
		//System.out.println("Come again 2 -- "+data);
	    }
	    
	    //get the substring where the address is in
	    host = data.substring(18);
	    
	    //we are done here
	     s.leaveGroup(group);
	}catch(SocketTimeoutException se){return(null);}catch(Exception e){e.printStackTrace();}

	return(host);
    }
    
    
    
}
