import dimi.configuration.DisseminationUnitConfiguration;
import dimi.DisseminationUnit;
import dimi.util.indexer.Indexer;
import dimi.message.Message;
import dimi.message.MessageContent;
import dimi.ProducerEntryPoint;
import dimi.name.DBaseName;
import dimi.gui.simple.DBaseGUI;
import dimi.DBaseImpl;

import java.net.InetAddress;
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.net.MalformedURLException;
import java.util.Timer;
import java.util.TimerTask;

public class RunDBase {

    public static void main(String[] args) {
System.out.println("main - STARTING");
        DBaseImpl dbase = null;
        try{
            DisseminationUnitConfiguration dconf = new DisseminationUnitConfiguration(args[0]);
            Indexer indexer = (Indexer)Naming.lookup("//"+InetAddress.getLocalHost().getHostName()+"/"+Indexer.class.getName());
            long dissIndex = indexer.getNext();
            dbase = new DBaseImpl(new DBaseName("//"+InetAddress.getLocalHost().getHostName()+"/dbase"+String.valueOf(dissIndex)),dconf);
System.out.println("service name: "+dbase.getName());
            (new DBaseGUI(dbase)).show();
        }
        catch(Exception exc){
            exc.printStackTrace();
            System.exit(1);
        }
        try{
            Naming.rebind(dbase.getName().toString(),dbase);
        }
        catch(RemoteException re){
            re.printStackTrace();
            System.exit(1);
        }
        catch(MalformedURLException mfue){
            mfue.printStackTrace();
            System.exit(1);
        }
    }
    
}