
import dimi.configuration.DisseminationUnitConfiguration;
import dimi.DisseminationUnit;
import dimi.util.indexer.Indexer;
import dimi.message.Message;
import dimi.message.MessageContent;
import dimi.ProducerEntryPoint;
import dimi.name.DNodeName;
import dimi.gui.simple.DNodeGUI;
import dimi.DNodeImpl;
import dimi.DBase;

import java.net.InetAddress;
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.net.MalformedURLException;
import java.util.Timer;
import java.util.TimerTask;

public class RunDNode {

    public static void main(String[] args) {
System.out.println("main - STARTING");
        DNodeImpl dnode = null;
        try{
            DisseminationUnitConfiguration dconf = new DisseminationUnitConfiguration(args[0]);
            DBase dbase = (DBase)Naming.lookup("//"+InetAddress.getLocalHost().getHostName()+"/dbase"+args[1]);
            DNodeName dnodeName = dbase.getDNodeName();
            dnode = new DNodeImpl(dnodeName,dconf,dbase);
System.out.println("service name: "+dnode.getName());
            (new DNodeGUI(dnode)).show();
        }
        catch(Exception exc){
            exc.printStackTrace();
            System.exit(1);
        }
        try{
            Naming.rebind(dnode.getName().toString(),dnode);
        }
        catch(RemoteException re){
            re.printStackTrace();
            System.exit(1);
        }
        catch(MalformedURLException mfue){
            mfue.printStackTrace();
            System.exit(1);
        }
    }

}