package dimi;

import java.rmi.RemoteException;

import dimi.configuration.DisseminationUnitConfiguration;
import dimi.configuration.ChannelConfiguration;
import dimi.name.ChannelName;
import dimi.channel.ChannelData;

/**
 * Interface de Unidade de Disseminacao.
 * @author mcmoraes
 */
public interface DisseminationUnit extends Disseminator{
    
    /**
     * Obtem a configuracao de um canal.
     * @param channelName o nome do canal
     * @throws RemoteException if failed to export object
     * @return a configuracao do canal
     */    
    public ChannelData getChannelData(ChannelName channelName) throws RemoteException;
    
    /**
     * Obtem a configuracao da unidade de disseminacao
     * @throws RemoteException if failed to export object
     * @return a configuracao da unidade de disseminacao
     */    
    public DisseminationUnitConfiguration getConfiguration() throws RemoteException;
    
    /**
     * Termina o servico.
     * @throws RemoteException
     */    
    public void destroy() throws RemoteException;

}
