package dimi.channel;

import java.io.Serializable;

import dimi.name.ChannelName;
import dimi.configuration.ChannelConfiguration;

/**
 * Classe auxiliar para agrupar os dados relevantes de um canal para a execucao
 * dos protocolos
 * @author mcmoraes
 */
public class ChannelData implements Serializable{
    
    private ChannelName channelRootName = null;
    private ChannelConfiguration channelConfiguration = null;
    
    /**
     * Creates a new instance of ChannelData
     * @param channelRootName o nome da raiz do canal
     * @param channelConfiguration a configuracao do canal
     */
    public ChannelData(ChannelName channelRootName,ChannelConfiguration channelConfiguration){
        this.channelRootName = channelRootName;
        this.channelConfiguration = channelConfiguration;
    }
    
    /**
     * Getter for property channelConfiguration.
     * @return Value of property channelConfiguration.
     */
    public ChannelConfiguration getChannelConfiguration() {
        return channelConfiguration;
    }
    
    /**
     * Getter for property channelRootName.
     * @return Value of property channelRootName.
     */
    public ChannelName getChannelRootName() {
        return channelRootName;
    }
        
}
