package dimi.name;

/**
 * Um nome de ponto de entrada de consumo
 * @author mcmoraes
 */
public class ConsumerEntryPointName extends DimiName{
    
    private ChannelName channelName = null;
    private String consumerLocalName = null;
    
    /**
     * Creates a new instance of ConsumerEntryPointName
     * @param name o nome desejado para o ponto de entrada de consumo
     * @throws BadformedDimiNameException se o nome nao estiver bem-formado
     */
    public ConsumerEntryPointName(String name) throws BadformedDimiNameException{
        super(name);
        // '//host:port/disseminator/channel/consumer'
        int index_aux = name.indexOf("/", 2);
        if(index_aux<0){
            throw new BadformedDimiNameException();
        }
        if((index_aux = name.indexOf("/", (index_aux+1)))<0){
            throw new BadformedDimiNameException();
        }
        if((index_aux = name.indexOf("/", (index_aux+1)))<0){
            throw new BadformedDimiNameException();
        }
        channelName = new ChannelName(name.substring(0,index_aux));
        if(name.indexOf("/", (index_aux+1)) > 0){
            throw new BadformedDimiNameException();
        }
        consumerLocalName = name.substring(index_aux+1);
    }
    
    /**
     * Getter for property channelName.
     * @return Value of property channelName.
     */
    public dimi.name.ChannelName getChannelName() {
        return channelName;
    }
    
    /**
     * Getter for property consumerLocalName.
     * @return Value of property consumerLocalName.
     */
    public java.lang.String getConsumerLocalName() {
        return consumerLocalName;
    }
    
}
