package dimi.name;

import dimi.DBase;
import dimi.exception.CantFindDBaseException;

import java.rmi.RemoteException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.net.MalformedURLException;

/**
 * Um nome de unidade de disseminacao
 * @author mcmoraes
 */
public abstract class DisseminationUnitName extends DimiName{
    
    public DisseminationUnitName(String name) throws BadformedDimiNameException{
        super(name);
    }
    
    public boolean contains(DisseminationUnitName disseminationUnitName){
        if(getName().startsWith(disseminationUnitName.getName())){
            return true;
        }
        return false;
    }
    
    public final DBase getDBase() throws RemoteException,CantFindDBaseException{
        DBase dbase = null;
        try{
            dbase = (DBase)Naming.lookup(getName());
        }
        catch(NotBoundException nbe){
            throw new CantFindDBaseException();
        }
        catch(MalformedURLException mue){
            throw new CantFindDBaseException();
        }
        return dbase;
    }

}
