/*
 * UserComponentVisualEditing.java
 *
 * Created on 27 de Setembro de 2004, 12:51
 */



package org.isam.exehda.services.perdis;


import org.isam.util.xml.XmlElement;
import java.util.Vector;

import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.WindowListener;
import java.awt.event.WindowFocusListener;
import java.awt.event.WindowStateListener;
import java.awt.event.ActionListener;
import java.awt.Insets;

import javax.swing.SwingUtilities;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/**
 *
 * @author  guilherme
 */

class ButtonBranches extends JButton {

    private JPanel father;
    private JPanel son;

    private QueryBuilder queryBuilder;

    boolean hasBranches;
    int numBranches;

    /**
     * Creates a new instance of ButtonBranches
     */
    public ButtonBranches(String label, JPanel father, JPanel son,QueryBuilder queryBuilder){

       super(label);
       this.father = father;
       this.son = son;

       this.queryBuilder = queryBuilder;

       this.hasBranches = false;
       this.numBranches = 0;
    }
    
    public ButtonBranches(JPanel father, JPanel son, QueryBuilder queryBuilder){

        this("Add Branches",father, son, queryBuilder);
    }
    
    /**
     * getFather
     */
    public JPanel getFather(){

        return this.father;
    }
    
    /**
     * getSon
     */
    public JPanel getSon(){

        return this.son;
    }
    
    /**
     * getQuery
     */
    public QueryBuilder getQuery(){

        return this.queryBuilder;
    }
    
    /**
     * setBranches
     */    
    public void setBranches(boolean hasBranches){

        this.hasBranches = hasBranches;
    }

    /**
     * clear
     */
    public void clear(){

        this.queryBuilder = new QueryBuilder();
        this.numBranches = 0;
        this.father = null;
        this.son = null;
        this.hasBranches = false;
    }
}


class ButtonCriteria extends JButton{

    private JPanel father;
    private JPanel son;

    private QueryBuilder queryBuilder;

    private JTextArea jTextArea1;

    /**
     * Creates a new instance of ButtonCriteria
     */
    public ButtonCriteria(String label, JPanel father, JPanel son, QueryBuilder queryBuilder, JTextArea text){

       super(label);
       this.father = father;
       this.son = son;

       this.queryBuilder = queryBuilder;

       this.jTextArea1 = text;
    }

    public ButtonCriteria(JPanel father, JPanel son, QueryBuilder queryBuilder, JTextArea text){
        this("Add Criteria",father,son, queryBuilder, text);
    }
    
    /**
     * getfather
     */
    public JPanel getFather(){
        return this.father;
    }

    /**
     * getSon
     */
    public JPanel getSon(){
        return this.son;
    }
    
    /**
     * getQuery
     */
    public QueryBuilder getQuery(){
        return this.queryBuilder;
    }
    
    /**
     * getTextArea
     */
    public JTextArea getTextArea(){
        return this.jTextArea1;
    }
}


class BranchesDialog extends JDialog{
    
    private JButton jButtonOK;
    private JButton jButtonCancel;
    private JLabel jLabelBranches;
    private JPanel jPanelMain;
    private JSpinner jSpinnerBranches;
    private SpinnerNumberModel spinModel;

    private int control;
    
    private QueryBuilder branches;
    
    private GridBagLayout layout;
    private GridBagConstraints c;

    /**
     * Creates a new instance of BranchesDialog
     */
    private BranchesDialog(boolean hasBranches){

        setTitle("Add Branches");
        setModal(true);
        this.control=0;

        this.layout = new GridBagLayout();
        this.c = new GridBagConstraints();

        this.jButtonOK = new JButton("OK");
        this.jButtonCancel = new JButton("Cancel");
        this.jLabelBranches = new JLabel("Provide the number of branches :");

        this.jPanelMain = new JPanel();
        this.jPanelMain.setLayout(this.layout);
        this.jPanelMain.setMinimumSize(new java.awt.Dimension(350, 350));
        this.jPanelMain.setPreferredSize(new java.awt.Dimension(350, 350));
       
        if (hasBranches){
            this.spinModel = new SpinnerNumberModel(1,1,65536,1);
        }
        else {
            this.spinModel = new SpinnerNumberModel(2,2,65536,1);
        }
        
        this.jSpinnerBranches = new JSpinner(this.spinModel);
        this.jSpinnerBranches.setDoubleBuffered(true);

        c.fill = c.BOTH;
        c.insets = new Insets(4,2,4,2);
        c.gridx = 0;
        c.gridy = 0;
        this.layout.setConstraints(jLabelBranches, c);
        this.jPanelMain.add(jLabelBranches);        

        c.gridx = 1;
        c.gridy = 0;
        this.layout.setConstraints(jSpinnerBranches, c);
        this.jPanelMain.add(jSpinnerBranches);        

        this.c.fill = c.NONE;
        this.c.gridx = 0;
        this.c.gridy = 2;
        this.layout.setConstraints(jButtonOK, c);        
        this.jPanelMain.add(jButtonOK);     
        
        c.gridx = 1;
        c.gridy = 2;
        this.layout.setConstraints(jButtonCancel, c);
        this.jPanelMain.add(jButtonCancel);        
        
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKMouseClicked();
            }
        });
        jButtonOK.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                if (evt.getKeyChar() == 10){
                    jButtonOKMouseClicked();
                }
            }
        });

        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelMouseClicked();
            }
        });
        jButtonCancel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                if (evt.getKeyChar() == 10){                
                    jButtonCancelMouseClicked();
                }
            }
        });
        
        getContentPane().setLayout(this.layout);
        getContentPane().add(jPanelMain);                
        setSize(350,350);
        show();
        pack();

        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(/*evt*/);
            }
        });
    }

    /**
     * jButtonOKMouseClicked
     */
    private void jButtonOKMouseClicked() {
        this.control = 1;
        this.dispose();
    }

    /**
     * jButtonCancelMouseClicked
     */
    private void jButtonCancelMouseClicked() {

        this.control = 2;
        this.dispose();
        
    }
    
    /**
     * getValueS
     */
    private int getValueS(){

        if (this.control == 1){
            return Integer.parseInt(this.jSpinnerBranches.getValue().toString());
        }
            else return 0;
    }
    
    /**
     * getValue
     */
    public static int getValue(boolean hasBranches){

        BranchesDialog bDial = new BranchesDialog(hasBranches);
        return  bDial.getValueS();
    }

    /**
     * addBranches
     */
    public static void addBranches(QueryBuilder branches){

        int iter = getValue(false);
        for (int i = 0; i < iter;i++){
            branches.addNewBranch();
        }
    }
    
    /**
     * getQuery
     */
    public QueryBuilder getQuery(){

        return this.branches;
    }
    
    /**
     * exitForm
     */
    private void exitForm(/*java.awt.event.WindowEvent evt*/){

        this.control=2;
        this.dispose();
    }
}


class CriteriaDialog extends JDialog{
    
    private JPanel jPanelMain;
    private JComboBox jComboBoxOperator;
    private JButton jButtonOK;
    private JButton jButtonCancel;
    private JTextField jTextFieldName;
    private JTextField jTextFieldValue;
    private JLabel jLabelName;
    private JLabel jLabelOperator;
    private JLabel jLabelValue;
    private int control;
    
    private QueryBuilder criterias;
    
    private GridBagLayout layout;
    private GridBagConstraints c;
    
    /**
     * Creates a new instance of CriteriaDialog
     */
    private CriteriaDialog(){

        setTitle("Add Criteria");
        setModal(true);
        
        this.layout = new GridBagLayout();
        this.c = new GridBagConstraints();
        
        this.control = 0;
        this.jPanelMain = new JPanel();
        this.jPanelMain.setLayout(this.layout);
        this.jPanelMain.setMinimumSize(new java.awt.Dimension(350, 350));
        this.jPanelMain.setPreferredSize(new java.awt.Dimension(350, 350));
        
        this.jComboBoxOperator = new JComboBox();
        this.jButtonOK = new JButton("OK");
        this.jButtonCancel = new JButton("Cancel");
        this.jTextFieldName = new JTextField();
        this.jTextFieldValue = new JTextField();
        this.jLabelName = new JLabel("Name");
        this.jLabelOperator = new JLabel("Operator");
        this.jLabelValue = new JLabel("Value");
        
        this.jComboBoxOperator.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Equal", "Inequal", "Greater", "GreaterOrEqual", "Less", "LessOrEqual", "MultiValue", "Range" }));

        c.fill = c.BOTH;
        c.insets = new Insets(4,2,4,2);
        c.gridx = 0;
        c.gridy = 0;
        this.layout.setConstraints(this.jLabelName, c);
        this.jPanelMain.add(this.jLabelName);

        c.gridx = 1;
        c.gridy = 0;
        this.layout.setConstraints(this.jTextFieldName, c);
        this.jPanelMain.add(this.jTextFieldName);
        
        c.gridx = 0;
        c.gridy = 1;
        this.layout.setConstraints(this.jLabelOperator, c);
        this.jPanelMain.add(this.jLabelOperator);        
        
        c.gridx = 1;
        c.gridy = 1;
        this.layout.setConstraints(this.jComboBoxOperator, c);
        this.jPanelMain.add(this.jComboBoxOperator);

        c.gridx = 0;
        c.gridy = 2;
        this.layout.setConstraints(this.jLabelValue, c);
        this.jPanelMain.add(this.jLabelValue);        
        
        c.gridx = 1;
        c.gridy = 2;
        this.layout.setConstraints(this.jTextFieldValue, c);
        this.jPanelMain.add(this.jTextFieldValue);        

        this.c.fill = c.NONE;
        c.gridx = 0;
        c.gridy = 3;
        this.layout.setConstraints(this.jButtonOK, c);
        this.jPanelMain.add(this.jButtonOK);
        
        c.gridx = 1;
        c.gridy = 3;
        this.layout.setConstraints(this.jButtonCancel, c);
        this.jPanelMain.add(this.jButtonCancel);

        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKMouseClicked();
            }
        });
        jButtonOK.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                if (evt.getKeyChar() == 10){
                    jButtonOKMouseClicked();
                }
            }
        });

        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelMouseClicked();
            }
        });
        jButtonCancel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                if (evt.getKeyChar() == 10){                
                    jButtonCancelMouseClicked();
                }
            }
        });

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        getContentPane().setLayout(this.layout);        
        c.gridx = 0;
        c.gridy = 0;
        this.layout.setConstraints(this.jPanelMain, c);
        getContentPane().add(jPanelMain);
        setSize(350,350);
        show();
        pack();
    }

    /**
     * jButtonOkMouseClicked
     */
    private void jButtonOKMouseClicked() {

        this.control = 1;
        if (getValueS()[0].equals("") || getValueS()[2].equals("")){
            javax.swing.JOptionPane.showMessageDialog(this,"You must provide data","Error", javax.swing.JOptionPane.WARNING_MESSAGE);
            this.control = 0;
        }
        else if (getValueS()[1].equals("Range")){
            if (getValueS()[2].split(";").length!=2){
                javax.swing.JOptionPane.showMessageDialog(this,"Range criteria must have 2 values","Error", javax.swing.JOptionPane.WARNING_MESSAGE);
                this.control = 0;
            }
            else{
                this.dispose();
            }
        }
        else {
            this.dispose();
        }
    }
    
    /**
     * jButtonCancelMouseClicked
     */
    private void jButtonCancelMouseClicked() {

        this.control = 2;
        this.dispose();
    }
    
    /**
     * getValueS
     */
    private String[] getValueS(){

        if (this.control==1){
            String[] valueS = new String[3];
            valueS[0]=this.jTextFieldName.getText();
            valueS[1]=this.jComboBoxOperator.getSelectedItem().toString();
            valueS[2]=this.jTextFieldValue.getText();
            return valueS;
        }
        else {
            return null;
        }
    }
    
    /**
     * getValue
     */
    public static String[] getValue(){

        CriteriaDialog cDial = new CriteriaDialog();
        return cDial.getValueS();
    }

    /**
     * getQuery
     */
    public QueryBuilder getQuery(String resourceType){
        return this.criterias;
    }    
    
    /**
     * exitForm
     */
    private void exitForm(java.awt.event.WindowEvent evt){
        this.control=2;
        this.dispose();
    }
}


public class VisualUserComponent extends JFrame{

    // Variables declaration
    private ButtonCriteria buttonCriteria;
    private ButtonBranches buttonBranches;
    private JButton buttonRequest;
    private JButton buttonClear;
    private JButton buttonBack;
    private JCheckBox jCheckBoxMaxResults;
    private JLabel jLabelTTL;
    private JLabel jLabelResource;
    private JLabel jLabelMaxResults;
    private JMenu jMenuFile;
    private JMenu jMenuHelp;
    private JMenuBar jMenuBar1;
    private JMenuItem jMenuItemExit;
    private JMenuItem jMenuItemAbout;
    private JPanel jPanelMain;
    private JPanel jPanelTab;
    private JPanel jPanelResults;
    private JPanel jPanelQuery;
    private JPanel jPanelReturnedResults;
    private JScrollPane jScrollPaneQuery;
    private JScrollPane jScrollPaneResults;
    private JTabbedPane jTabbedPane1;
    private JTextArea jTextAreaCriterias;
    private JTextArea jTextAreaResults;
    private JSpinner jSpinnerMaxResults;
    private JSpinner jSpinnerTTL;
    private SpinnerNumberModel spinModel;
    private SpinnerNumberModel spinModelMaxResults;
    private JTextField jTextFieldResource;

    private BranchesDialog bDialog;
    private CriteriaDialog cDialog;

    private GridBagLayout layout;    
    private GridBagConstraints c;
    private GridBagLayout lSon;
    
    private int numBranches;
    private int totBranches;
    
    private QueryBuilder queryB;
    private UserComponent uC;
    private boolean control;
    // End of variables declaration
    
    /**
     * Creates a new instance of VisualUserComponent
     */
    public VisualUserComponent() {

        super("Visual User Component");
        this.uC = new UserComponent();
        initComponents();
    }
    
    /** 
     * initComponents
     */
    private void initComponents() {

        this.control = true;
        this.queryB = new QueryBuilder();        
        this.c = new GridBagConstraints();
        this.layout = new GridBagLayout();
        this.lSon = new GridBagLayout();
        this.totBranches = 0;
        this.numBranches = 0;
        
        this.jCheckBoxMaxResults = new JCheckBox("Max Results");
        
        this.jLabelTTL = new JLabel("Search TTL");
        this.jLabelTTL.setVisible(true);
        this.jLabelResource = new JLabel("Resource Type");
        this.jLabelResource.setVisible(true);
        this.jLabelMaxResults = new JLabel("Number of Max Results");
        
        this.jMenuFile = new JMenu("File");
        this.jMenuHelp = new JMenu("Help");        
        this.jMenuBar1 = new JMenuBar();        
        this.jMenuItemExit = new JMenuItem("Exit");
        this.jMenuItemAbout = new JMenuItem("About...");
        
        this.jPanelMain = new JPanel();
        this.jPanelMain.setVisible(true);
        this.jPanelTab = new JPanel();
        this.jPanelResults = new JPanel();        
        this.jPanelResults.setVisible(true);
        this.jPanelQuery = new JPanel();
        this.jPanelQuery.setVisible(true);
        this.jPanelReturnedResults = new JPanel();
        this.jPanelReturnedResults.setVisible(true);
        
        this.jScrollPaneQuery = new JScrollPane();        
        this.jScrollPaneQuery.setVisible(true);
        this.jScrollPaneResults = new JScrollPane();        
        this.jScrollPaneResults.setVisible(true);
        
        this.jTabbedPane1 = new JTabbedPane();        
        this.jTabbedPane1.setVisible(true);
        this.jTextAreaCriterias = new JTextArea();
        this.jTextAreaCriterias.setVisible(true);
        this.jTextAreaResults = new JTextArea();
        this.jTextAreaResults.setVisible(true);
        this.jTextFieldResource = new JTextField();
        this.jTextFieldResource.setVisible(true);
        
        this.spinModel = new SpinnerNumberModel(1,1,999,1);
        this.spinModelMaxResults = new SpinnerNumberModel(1,1,99,1);
        
        this.jSpinnerTTL = new JSpinner(this.spinModel);
        this.jSpinnerTTL.setVisible(true);
        this.jSpinnerTTL.setDoubleBuffered(true);
        this.jSpinnerMaxResults = new JSpinner(this.spinModelMaxResults);
        this.jSpinnerMaxResults.setEnabled(false);
        
        this.jPanelQuery.setLayout(this.layout);
        
        this.buttonCriteria = new ButtonCriteria(this.jPanelTab, this.jPanelQuery, this.queryB, this.jTextAreaCriterias);
        
        this.buttonBranches = new ButtonBranches(this.jPanelTab, this.jPanelQuery, this.queryB);
        
        this.buttonRequest = new JButton("Request");
        this.buttonClear = new JButton("Clear");
        this.buttonBack = new JButton("<< Back");
        
        this.jMenuFile.setMnemonic('F');
        this.jMenuFile.add(this.jMenuItemExit);        

        this.jMenuHelp.setMnemonic('H');                
        this.jMenuHelp.add(this.jMenuItemAbout);        

        this.jMenuBar1.add(this.jMenuFile);
        this.jMenuBar1.add(this.jMenuHelp);

        this.jMenuItemExit.setMnemonic('x');
        this.jMenuItemAbout.setMnemonic('b');        

        this.jScrollPaneQuery.setViewportView(this.jPanelQuery);
        //this.jScrollPaneResults.setViewportView(this.jPanelReturnedResults);

        this.jPanelMain.setLayout(this.layout);
        this.jPanelMain.setPreferredSize(new java.awt.Dimension(500,540));        
        this.jPanelTab.setLayout(this.layout);
        this.jPanelTab.setPreferredSize(new java.awt.Dimension(500,510));
        this.jPanelResults.setLayout(this.layout);        
        this.jPanelResults.setPreferredSize(new java.awt.Dimension(500,510));
        this.jPanelQuery.setLayout(this.layout);        
        //this.jPanelReturnedResults.setLayout(this.layout);

        this.jTabbedPane1.setPreferredSize(new java.awt.Dimension(500,530));
        
        c.insets = new Insets(3,3,3,3);
        
        c.fill = c.BOTH;
        
        c.gridx = 0;
        c.gridy = 0;
        this.layout.setConstraints(this.jTabbedPane1, c);
        this.jPanelMain.add(this.jTabbedPane1);        

        c.fill = c.NONE;
        c.gridx = 1;
        c.gridy = 3;
        this.layout.setConstraints(this.buttonCriteria, c);
        this.jPanelTab.add(this.buttonCriteria);        

        c.gridx = 2;
        c.gridy = 3;
        this.layout.setConstraints(this.buttonBranches, c);
        this.jPanelTab.add(this.buttonBranches);
        
        c.gridx = 2;
        c.gridy = 5;
        this.layout.setConstraints(this.buttonClear, c);
        this.jPanelTab.add(this.buttonClear);                

        c.gridx = 1;
        c.gridy = 5;
        this.layout.setConstraints(this.buttonRequest, c);
        this.jPanelTab.add(this.buttonRequest);

        c.fill = c.BOTH;
        c.gridx = 0;
        c.gridy = 4;
        c.gridwidth = 4;
        c.ipady = 250;
        c.ipadx = 450;
        this.layout.setConstraints(this.jScrollPaneQuery, c);
        this.jPanelTab.add(this.jScrollPaneQuery);
        
        c.gridx = 1;
        c.gridy = 0;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.ipady = 0;
        c.ipadx = 0;
        this.layout.setConstraints(this.jLabelTTL, c);
        this.jPanelTab.add(this.jLabelTTL);

        c.gridx = 1;
        c.gridy = 1;
        this.layout.setConstraints(this.jLabelResource, c);
        this.jPanelTab.add(this.jLabelResource);

        c.fill = c.NONE;
        c.gridx = 2;
        c.gridy = 0;
        this.layout.setConstraints(this.jSpinnerTTL, c);
        this.jPanelTab.add(this.jSpinnerTTL);
        
        c.fill = c.BOTH;
        c.gridx = 2;
        c.gridy = 1;
        this.layout.setConstraints(this.jTextFieldResource, c);
        this.jPanelTab.add(this.jTextFieldResource);

        c.gridx = 1;
        c.gridy = 2;
        this.layout.setConstraints(this.jCheckBoxMaxResults, c);
        this.jPanelTab.add(this.jCheckBoxMaxResults);
        
        c.fill = c.NONE;
        c.gridx = 2;
        c.gridy = 2;
        this.layout.setConstraints(this.jSpinnerMaxResults, c);
        this.jPanelTab.add(this.jSpinnerMaxResults);
        this.jSpinnerMaxResults.setVisible(false);
        
        c.fill = c.BOTH;
        c.gridx = 0;
        c.gridy = 1;
        c.gridwidth = 4;
        c.ipady = 450;
        c.ipadx = 450;
        this.layout.setConstraints(this.jScrollPaneResults, c);
        this.jPanelResults.add(this.jScrollPaneResults);

        c.gridx = 0;
        c.gridy = 2;
        c.gridwidth = 1;
        c.ipady = 0;
        c.ipadx = 0;
        this.layout.setConstraints(this.buttonBack, c);
        this.jPanelResults.add(this.buttonBack);
        
        
        
        c.gridx = 0;
        c.gridy = 0;
        c.gridwidth = 4;
        c.gridheight = 1;
        c.ipady = 0;
        c.ipadx = 0;
        this.layout.setConstraints(jTextAreaCriterias, c);
        this.jPanelQuery.add(this.jTextAreaCriterias);
        
        c.gridwidth = 1;
        
/////////////////
        JLabel lab = new JLabel();
        c.gridx = 0;
        c.gridy = 1;
        c.ipady = 0;
        c.ipadx = 50;
        this.layout.setConstraints(lab, c);
        this.jPanelQuery.add(lab);
        c.ipadx = 0;

        JLabel lab2 = new JLabel("");
        c.gridx = 0;
        c.gridy = 0;
        c.ipady = 0;
        c.ipadx = 100;
        this.layout.setConstraints(lab2, c);
        this.jPanelTab.add(lab2);
        c.ipadx = 0;        
////////////////
        

        this.jTabbedPane1.addTab("Request Resource", this.jPanelTab);
        this.jTabbedPane1.addTab("Results", this.jPanelResults);
        
        this.jTextAreaCriterias.setEditable(false);
        this.jTextAreaCriterias.setBackground(new java.awt.Color(204, 204, 204));
        this.jTextAreaCriterias.setFont(new Font("Arial",Font.BOLD,16));
        
/*        this.jTextAreaResults.setEditable(false);
        this.jTextAreaResults.setBackground(new java.awt.Color(204, 204, 204));
        this.jTextAreaResults.setFont(new Font("Arial",Font.BOLD,12));*/
        
        /*this.buttonCriteria.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonCriteriaMouseClicked(evt);
            }
        });*/


        this.buttonCriteria.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCriteriaActionPerformed(evt);
            }
        });

        this.buttonCriteria.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                if(evt.getKeyChar()==10){
                    buttonCriteriaKeyTyped(evt);
                }
            }
        });
        
        this.buttonBranches.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonBranchesActionPerformed(evt);
            }
        });

        this.buttonBranches.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                if(evt.getKeyChar()==10){
                    buttonBranchesKeyTyped(evt);
                }
            }
        });
        
        this.buttonClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                try {
                    buttonClearMouseClicked();
                } catch(Exception e) {
                    e.printStackTrace();
                    System.exit(1);
                }
            }
        });

        this.buttonClear.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                if(evt.getKeyChar()==10){
                    try {
                        buttonClearMouseClicked();
                    } catch(Exception e) {
                        e.printStackTrace();
                        System.exit(1);
                    }
                }
            }
        }); 
        
        this.buttonRequest.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                try {
                    buttonRequestMouseClicked();
                } catch(Exception e) {
                    e.printStackTrace();
                    System.exit(1);
                }
            }
        });
        
        this.buttonRequest.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                if(evt.getKeyChar()==10){
                    try {
                        buttonRequestMouseClicked();
                    } catch(Exception e) {
                        e.printStackTrace();
                        System.exit(1);
                    }
                }
            }
        }); 
        
        this.buttonBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                try {
                    buttonClearMouseClicked();
                } catch(Exception e) {
                    e.printStackTrace();
                    System.exit(1);
                }
            }
        });

        this.buttonBack.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                if(evt.getKeyChar()==10){
                    try {
                        buttonClearMouseClicked();
                    } catch(Exception e) {
                        e.printStackTrace();
                        System.exit(1);
                    }
                }
            }
        }); 
        
        this.jCheckBoxMaxResults.addActionListener(new ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent e) {
                setSpinnerMaxResults(jCheckBoxMaxResults.isSelected());
           }
        });
        
        this.jMenuItemExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemExitActionPerformed(evt);
            }
        });

        
        this.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowActivated(java.awt.event.WindowEvent e) {
                focusOnTextField(e);
            }
        });  
        
       
        this.jTabbedPane1.addChangeListener(new javax.swing.event.ChangeListener(){
            public void stateChanged(javax.swing.event.ChangeEvent evt){
                try {
                    clearReq(evt);
                }
                catch(Exception e){
                    e.printStackTrace();
                    System.exit(1);
                }
            }
        
        });

        getContentPane().setLayout(this.layout);
        
        c.gridx = 0;
        c.gridy = 0;
        this.layout.setConstraints(this.jPanelMain, c);
        getContentPane().add(this.jPanelMain);
        setJMenuBar(jMenuBar1);
        getContentPane().setSize(500,540);
        setResizable(false);
        this.setDefaultCloseOperation(this.DISPOSE_ON_CLOSE);
	pack();
        //this.jTextFieldResource.requestFocusInWindow();
    }
    
    public void clearReq(javax.swing.event.ChangeEvent evt){
        if ((this.jTabbedPane1.getSelectedComponent() == this.jPanelTab)&&(!this.control)){
            try{
                buttonClearMouseClicked();
            }
            catch(Exception e){
                e.printStackTrace();
                System.exit(1);
            }
        }
    }
    
    private void focusOnTextField(java.awt.event.WindowEvent e){
        this.jTextFieldResource.requestFocusInWindow();
    }
    
    /**
     * updateInterface
     */
    private void updateInterface(){

        this.jPanelMain.updateUI();
        this.jPanelQuery.updateUI();
        this.jPanelResults.updateUI();
        this.jPanelTab.updateUI();
        this.jTabbedPane1.updateUI();
    }

    /**
     * finishComponents
     */
    private void finishComponents(){

        this.jPanelTab.remove(this.buttonBranches);
        this.jPanelTab.remove(this.buttonCriteria);
        this.jPanelTab.remove(this.jScrollPaneQuery);
        this.jScrollPaneQuery.remove(this.jPanelQuery);
        this.jPanelMain.removeAll();
        this.jMenuBar1.removeAll();
        this.remove(this.jMenuBar1);
        
        this.c = null;
        this.layout = null;
        this.lSon = null;
        
        this.jLabelResource = null;
        this.jLabelTTL = null;
        this.jMenuFile = null;
        this.jMenuHelp = null;
        this.jMenuBar1 = null;
        this.jMenuItemAbout = null;
        this.jMenuItemExit = null;
        this.jPanelMain = null;
        this.jPanelQuery = null;
        this.jPanelResults = null;
        this.jPanelTab = null;
        this.jScrollPaneQuery = null;
        this.jScrollPaneResults = null;
        this.jSpinnerTTL = null;
        this.jTabbedPane1 = null;
        this.jTextAreaCriterias = null;
        this.jTextAreaResults = null;
        this.jTextFieldResource = null;
        this.buttonClear = null;
        this.buttonRequest = null;
        this.bDialog = null;
        this.buttonBranches = null;
        this.buttonCriteria = null;
        this.cDialog = null;
        this.queryB = null;
        this.spinModel = null;

    }

    /**
     * buttonClearMouseClicked
     */
    private void buttonClearMouseClicked() throws Exception {

        finishComponents();
        this.frameInit();
        initComponents();
        this.jTextFieldResource.requestFocusInWindow();

    }
    
    /**
     * buttonBranchesMouseClicked
     */
    private void buttonBranchesMouseClicked(java.awt.event.MouseEvent evt){
        ButtonBranches btn = (ButtonBranches) evt.getComponent();
	this.numBranches=BranchesDialog.getValue(btn.hasBranches);
        processBranches(btn);
    }
    
    private void buttonBranchesActionPerformed(java.awt.event.ActionEvent evt){
        ButtonBranches btn = (ButtonBranches) evt.getSource();
	this.numBranches=BranchesDialog.getValue(btn.hasBranches);
        processBranches(btn);
    }

    private void buttonBranchesKeyTyped(java.awt.event.KeyEvent evt){
        ButtonBranches btn = (ButtonBranches) evt.getComponent();
	this.numBranches=BranchesDialog.getValue(btn.hasBranches);
        processBranches(btn);
    }
    
    
    
    /**
     * buttonCriteriaMouseClicked
     */
    private void buttonCriteriaMouseClicked(java.awt.event.MouseEvent evt){

        ButtonCriteria btn = (ButtonCriteria) evt.getComponent();
	addCriteria(CriteriaDialog.getValue(), btn.getQuery(), btn.getTextArea());
        updateInterface();
    }
    
    private void buttonCriteriaActionPerformed(java.awt.event.ActionEvent evt){

        ButtonCriteria btn = (ButtonCriteria) evt.getSource();
	addCriteria(CriteriaDialog.getValue(), btn.getQuery(), btn.getTextArea());
        updateInterface();
    }

    private void buttonCriteriaKeyTyped(java.awt.event.KeyEvent evt){

        ButtonCriteria btn = (ButtonCriteria) evt.getComponent();
	addCriteria(CriteriaDialog.getValue(), btn.getQuery(), btn.getTextArea());
        updateInterface();
    }
    
    
    /**
     * buttonRequestMouseClicked
     */
    private void buttonRequestMouseClicked(/*java.awt.event.MouseEvent evtjava.awt.event.ActionEvent evt*/) throws Exception {

        this.control = false;

        if (this.jTextFieldResource.getText().equals("")){
            javax.swing.JOptionPane.showMessageDialog(this,"Resource Type cannot be null","Error", javax.swing.JOptionPane.WARNING_MESSAGE);
        }
        else {
            if (this.jCheckBoxMaxResults.isSelected()){
                this.queryB.addMainAttributes(this.jTextFieldResource.getText(), Integer.parseInt(this.jSpinnerTTL.getValue().toString()), Integer.parseInt(this.jSpinnerMaxResults.getValue().toString()));
            }
            else{
                this.queryB.addMainAttributes(this.jTextFieldResource.getText(), Integer.parseInt(this.jSpinnerTTL.getValue().toString()));
            }

            try {
                this.setEnabled(false);
                (new Thread() { 
                    public void run() {
                        try {
                            final XmlElement results = uC.requestResource(queryB);
                            SwingUtilities.invokeLater(new Runnable() {XmlElement x2; {x2 = results;} public void run() { 
                                setEnabled(true);
                                processRequest(results);
                                jTabbedPane1.setSelectedComponent(jPanelResults);
                                jPanelResults.updateUI();}});
                            
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                }).start();
            }
            catch (Exception e){
                e.printStackTrace();
            }
        }
        
        //this.queryB = QueryBuilder.removeMainAtributes(this.queryB);
        //updateInterface();
    }

    /**
     * jMenuItemExitActionPerformed
     */
    private void jMenuItemExitActionPerformed(java.awt.event.ActionEvent evt){

        this.finishComponents();
        try{
            this.finalize();
        }
        catch(java.lang.Throwable throwable){
            throwable.printStackTrace();
        }
        WindowListener[] windowListeners = this.getWindowListeners();
        for (int i=0;i<windowListeners.length;i++){
            this.removeWindowListener(windowListeners[i]);
        }
        this.dispose();
    }

    
    /**
     *setSpinnerMaxResults
     */
    private void setSpinnerMaxResults(boolean setValue){
        this.jSpinnerMaxResults.setEnabled(setValue);
        this.jSpinnerMaxResults.setVisible(setValue);
    }

    
    private void processBranches(ButtonBranches btn){
        if (this.numBranches>0){
            btn.setBranches(true);
            btn.numBranches+=this.numBranches;
            createBranches(btn.getSon(),btn.numBranches, this.numBranches, btn.getQuery());
        }
        updateInterface();
    }
    
    
    
    /**
     * processRequest
     */
    private void processRequest(XmlElement xmlQuery){

        JTextArea results = new JTextArea();
        results.setEditable(false);
        results.setBackground(new java.awt.Color(204, 204, 204));
        results.setFont(new Font("Arial",Font.BOLD,13));
        
        Vector vec = XmlElement.selectByPath(xmlQuery, "/RESOURCE", null);
        
        this.c.gridx = 0;
        this.c.gridy = 0;
        c.fill = c.BOTH;
        JLabel lab = new JLabel("Resources found: "+vec.size());
        lab.setFont(new Font("Arial",Font.BOLD,14));
        this.layout.setConstraints(lab, this.c);
        this.jPanelResults.add(lab);

        this.jScrollPaneResults.setViewportView(results);
        for (int i = 0; i < vec.size(); i++) {
            XmlElement xmlResource = (XmlElement) vec.elementAt(i);

            Vector vec1 = XmlElement.selectByPath(xmlResource, "/NAME", null);
            if (vec1.size()>0){
                XmlElement xmlTypeTmp = (XmlElement) vec1.firstElement();
                results.append((i+1) + ": "+(String)xmlTypeTmp.getContents()+"\n");        
            }
            
            vec1 = XmlElement.selectByPath(xmlResource, "/TYPE", null);
            if (vec1.size()>0){
                XmlElement xmlTypeTmp = (XmlElement) vec1.firstElement();
                results.append("\t"+xmlTypeTmp.getTag()+" = "+(String)xmlTypeTmp.getContents()+"\n");
            }
            
            vec1 = XmlElement.selectByPath(xmlResource, "/DESCRIPTION", null);
            if (vec1.size()>0){
                XmlElement xmlTypeTmp = (XmlElement) vec1.firstElement();
                results.append("\t"+xmlTypeTmp.getTag()+" = "+(String)xmlTypeTmp.getContents()+"\n");        
            }
            
            vec1 = XmlElement.selectByPath(xmlResource, "/URL", null);
            if (vec1.size()>0){
                XmlElement xmlTypeTmp = (XmlElement) vec1.firstElement();
                results.append("\t"+xmlTypeTmp.getTag()+" = "+(String)xmlTypeTmp.getContents()+"\n");        
            }

            vec1 = XmlElement.selectByPath(xmlResource, "/PROPERTIES/PROPERTY", null);
            XmlElement[] xmlQueryProp = new XmlElement[vec1.size()];

            for (int j=0; j < vec1.size(); j++) {
                xmlQueryProp[j] = (XmlElement) vec1.elementAt(j);
                results.append("\t"+xmlQueryProp[j].getAttribute("name","")+" = ");
                results.append(xmlQueryProp[j].getAttribute("value","")+"\n");
            }
        }
    }
    
    /**
     * addCriteria
     */
    private void addCriteria(String[] option, QueryBuilder qBuilder,JTextArea criteria){

        if (option!=null) {
            if (option[1].equals("Equal")){
                    qBuilder.addEqualityCriteria(option[0],option[2]);
                    criteria.append(option[0]+" = "+option[2]+"\n");
            }
            else if(option[1].equals("Inequal")){
                    qBuilder.addInequalityCriteria(option[0],option[2]);
                    criteria.append(option[0]+" != "+option[2]+"\n");
            }
            else if(option[1].equals("Greater")){
                    qBuilder.addGreaterCriteria(option[0],option[2]);
                    criteria.append(option[0]+" > "+option[2]+"\n");
            }
            else if(option[1].equals("GreaterOrEqual")){
                    qBuilder.addGreaterOrEqualCriteria(option[0],option[2]);
                    criteria.append(option[0]+" >= "+option[2]+"\n");
            }
            else if(option[1].equals("Less")){
                    qBuilder.addLessCriteria(option[0],option[2]);
                    criteria.append(option[0]+" < "+option[2]+"\n");
            }
            else if(option[1].equals("LessOrEqual")){
                    qBuilder.addLessOrEqualCriteria(option[0],option[2]);
                    criteria.append(option[0]+" <= "+option[2]+"\n");
            }
            else if(option[1].equals("MultiValue")){
                    String values[] = option[2].split(";");
                    qBuilder.addMultiValueCriteria(option[0], values);
                    for (int i =0; i < (values.length)-1; i++){
                        criteria.append(option[0] + " = " +values[i] + " .or. ");
                    }
                    criteria.append(option[0] + " = " +values[(values.length)-1] + "\n");
            }
            else if(option[1].equals("Range")){
                    String values[] = option[2].split(";");
                    qBuilder.addRangeCriteria(option[0], values[0],values[1]);
                    criteria.append(option[0]+" >= "+values[0]+" .and. "+ option[0]+" <= "+values[1]+"\n");
            }
        }
    }
    

    /**
     * createBranches
     */
    private void createBranches(JPanel father, int numberOfBranches, int branchesToAdd, QueryBuilder queryBuilder){
    	
        int init = numberOfBranches - this.numBranches;
        init*=3;
        init++;
        for (int i = 0; i<branchesToAdd; i++){
            lSon = new GridBagLayout();
            JPanel son = new JPanel();
            son.setLayout(this.layout);

            QueryBuilder qB = queryBuilder.addNewBranch();

            JTextArea text = new JTextArea();
            text.setBackground(new java.awt.Color(204, 204, 204));
            text.setFont(new Font("Arial",Font.BOLD,16));
            text.setEditable(false);
            
            ButtonCriteria btn1 = new ButtonCriteria(father, son, qB, text);
            ButtonBranches btn2 = new ButtonBranches(father, son, qB);

            c.fill = c.NONE;
            c.gridx = 1;
            c.gridy = init;
            this.layout.setConstraints(btn1, c);
            father.add(btn1);

            c.gridx = 2;
            c.gridy = init++;
            c.gridwidth = 1;
            this.layout.setConstraints(btn2, c);
            father.add(btn2);

            c.fill = c.BOTH;
            c.gridx = 1;
            c.gridy = init++;
            c.gridwidth = 4;
            this.layout.setConstraints(text, c);
            father.add(text);

            c.gridx = 2;
            c.gridy = init++;
            c.gridwidth = 1;
            this.layout.setConstraints(son, c);
            father.add(son);
            
            btn1.addKeyListener(new java.awt.event.KeyAdapter() {
                public void keyTyped(java.awt.event.KeyEvent evt) {
                    if(evt.getKeyChar()==10){
                        buttonCriteriaKeyTyped(evt);
                    }
                }
            });


            btn1.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    buttonCriteriaActionPerformed(evt);
                }
            });


            btn2.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    buttonBranchesActionPerformed(evt);
                }
            });

            btn2.addKeyListener(new java.awt.event.KeyAdapter() {
                public void keyTyped(java.awt.event.KeyEvent evt) {
                    if(evt.getKeyChar()==10){
                        buttonBranchesKeyTyped(evt);
                    }
                }
            });
	}
    }
    
    public static void main(String[] args){
    	new VisualUserComponent().show();
    }
}