// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.primos.exec;

import org.isam.exehda.Exehda;
import org.isam.exehda.ObjectId;
import org.isam.exehda.services.ObjectSeed;
import org.isam.exehda.services.ObjectSeed.Activator;


/**
 * Contacts the ObjectSeed for instantiating an OX.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-03-30 12:52:08 -0300 (Wed, 30 Mar 2005) $ $Revision: 666 $
 */
class CreateObjectAction
    implements Runnable
{
    private Class cls;
    private Object[] p;
    private Activator a;
    private ObjectId oxId;
            
    public CreateObjectAction(Class cls, Object[] p, Activator a)
        {
            this.cls = cls;
            this.p = p;
            this.a = a;
            this.oxId = null;
        }

    public void
    run()
        {
            ObjectSeed objectseed = (ObjectSeed)
                Exehda.getService(ObjectSeed.SERVICE_NAME);

            synchronized (this) {
                oxId = objectseed.newInstance(cls, p, a);
            }
        }

    public synchronized ObjectId
    getObjectId() 
        {
            return this.oxId;
        }
}

