// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.HostId;
import org.isam.exehda.ApplicationId;
import org.isam.exehda.services.ObjectSeed.Activator;
import org.isam.exehda.services.ObjectSeed.ObjectHandle;

public interface Executor
{
    public final String SERVICE_NAME = "executor";
    
    public static interface SchedulingHeuristic
    {
        HostId chooseCreationHost(String clsName,
                                  Object[] params,
                                  Object hint,
                                  java.util.Vector avoidedHosts)
            throws VetoedOperationException;
    

//         Object chooseMigrationHost(ObjectAddress obj,
//                                    Object hint,
//                                    java.util.Vector avoidedHosts)
//             throws VetoedOperationException;
    }

    public static class VetoedOperationException
        extends Exception
    {
        public 
        VetoedOperationException( String msg )
            {
                super(msg);
            }
    }
    
//     public void
//     createObject( Class c, Object[] params, Activator a, Object hint);

    public ObjectHandle
    createObject( ApplicationId app, Class c, Object[] params, Activator a, Object hint);

    public void
    startApplication(org.isam.util.xml.XmlElement launchDescriptor);

    public void
    runAction(ApplicationId app, Runnable action);
        
    public ApplicationId
    currentApplication();

//     public void
//     stopApplication();
    
//     public ObjectHandle
//     moveObject( ObjectHandle objHandle, Object hint);

//     public ObjectHandle
//     restoreObject( ObjectHandle objHandle, byte[] objectState, Activator a);

    public void
    setHeuristic( SchedulingHeuristic sh );
}
