package org.isam.exehda.services.dhc;

import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.util.*;


/*
 * XMLContainer - Contains a xml document, parses it and returns new 
 * xml strings acording to parameters
 */

public class XMLContainer {
    Document xml;
    String displayString;


    //creates new xml container and parses xml file
    public XMLContainer(String xmlFile){
	try{
	    DocumentBuilder db = DocumentBuilderFactory.newInstance().newDocumentBuilder();
	    xml = db.parse(xmlFile);
	    
	}catch(Exception e){e.printStackTrace();}
	
	displayString = new String();
    }

    /*generates the string representing this document*/
    /*Adapted from http://www.topxml.com/xml/articles/java_xml_dom/*/
    private void genString(Node node, String indent)

    {
	
	indent = "";

        if (node == null) {
	    
            return;
	    
        }

 

        int type = node.getNodeType();

 

        switch (type) {

            case Node.DOCUMENT_NODE: {

                displayString = indent;

                displayString +=

                   "<?xml version=\"1.0\" encoding=\""+

                   "UTF-8" + "\"?>";

		//displayString += "\n";

                genString(((Document)node).getDocumentElement(), "");

                break;

             }

 

             case Node.ELEMENT_NODE: {

		 displayString += "\n";
                 
		 displayString += indent;

                 displayString += "<";

                 displayString += node.getNodeName();

 

                 int length = (node.getAttributes() != null) ?

                     node.getAttributes().getLength() : 0;

                 Attr attributes[] = new Attr[length];

                 for (int loopIndex = 0; loopIndex < length; loopIndex++) {

                     attributes[loopIndex] =

                     (Attr)node.getAttributes().item(loopIndex);

                 }

 

                 for (int loopIndex = 0; loopIndex < attributes.length;

                     loopIndex++) {

                     Attr attribute = attributes[loopIndex];

                     displayString += " ";

                     displayString +=

                         attribute.getNodeName();

                     displayString+= "=\"";

                     displayString +=

                         attribute.getNodeValue();

                     displayString += "\"";

                 }

                 displayString += ">";

 

                 

 

                 NodeList childNodes = node.getChildNodes();

                 if (childNodes != null) {

                     length = childNodes.getLength();

                     indent += "    ";

                     for (int loopIndex = 0; loopIndex < length; loopIndex++ ) {

                        genString(childNodes.item(loopIndex), indent);

                     }

                 }

                 break;

             }

 

             case Node.CDATA_SECTION_NODE: {

                 displayString += "\n";

		 displayString += indent;

                 displayString += "<![CDATA[";

                 displayString += node.getNodeValue();

                 displayString += "]]>";

                 

                 break;

             }

 

             case Node.TEXT_NODE: {

                 displayString += "\n";

		 displayString += indent;

                 String newText = node.getNodeValue().trim();

                 if(newText.indexOf("\n") < 0 && newText.length() > 0) {

                     displayString += newText;

                     

                 }

                 break;

             }

 

             case Node.PROCESSING_INSTRUCTION_NODE: {

		 displayString += "\n";

		 displayString += indent;

                 displayString += "<?";

                 displayString += node.getNodeName();

                 String text = node.getNodeValue();

                 if (text != null && text.length() > 0) {

                     displayString += text;

                 }

                 displayString += "?>";

                 

                 break;

            }

        }

 

        if (type == Node.ELEMENT_NODE) {

            displayString += "\n";

	    displayString += indent.substring(0,

                indent.length() - 4);

            displayString += "</";

            displayString += node.getNodeName();

            displayString += ">";

            

            indent += "    ";

        }

    }

 


    /*retrieves the string representing this document*/
    public String getString(){
	genString(xml,"");
	displayString = displayString.replaceAll("\n\n","\n");
	return(displayString);
    }

    /*retrieves the string representing this document and replaces wildcards*/
    public String getString(Hashtable hash){
	genString(xml,"");
	String replace;
	String replaced;
	Enumeration e = hash.keys();
	while(e.hasMoreElements()){
	    replaced = ((String)e.nextElement());
	    replace = (String)hash.get(replaced);
	    displayString = displayString.replaceAll("::"+replaced+"::",replace);
	}
	return(displayString);
   }
    
}
