// 
// PRIMOS - Primitives for Object Scheduling 
// 
// Copyright (C) 2002 Luciano Cavalheiro da Silva  <lucc@inf.ufrgs.br> 
//                    Claudio Fernando Resin Geyer <geyer@inf.ufrgs.br> 
// 
// This file is part of PRIMOS. 
// 
// PRIMOS is free software; you can redistribute it and/or 
// modify it under the terms of the GNU General Public License 
// as published by the Free Software Foundation; either version 2 
// of the License, or any later version. 
// 
// PRIMOS is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
// 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
// 

/**
 * @file  SensorData.hh 
 * @brief 
 *
 * @namespace primos::
 * @cvsid $Id: SensorData.hh 172 2004-03-22 17:27:17Z lucc $
 */

#ifndef primos_SensorData_hh
#define primos_SensorData_hh

#ifdef HAVE_CONFIG_H
#  include <acconfig.h>
#endif

#ifdef HAVE_INTTYPES_H
#  include <inttypes.h>
#endif

#ifdef HAVE_STRING
#  include <string>
#endif

namespace primos
{
        /**
         * @class SensorData 
         * @brief 
         *
         */
    class SensorData
    {
    public:
        typedef enum DataTypes { INTEGER_DATA, FLOAT_DATA, STRING_DATA } DataTypes;
        typedef int64_t Integer;
        typedef double Float;
        typedef std::string String;
            // Operations /////////////////////////////////////
    public:
            /**
             * @brief 
             *
             */
        DataTypes
        Type() const
            {
                return type;
            }
            
            /**
             * @brief 
             *
             */
        bool
        isInteger() const
            {
                return (type == INTEGER_DATA);    
            }
            
            /**
             * @brief 
             *
             */
        bool
        isFloat() const
            {
                return (type == FLOAT_DATA);
            }

            /**
             * @brief 
             *
             */
        bool
        isString() const
            {
                return (type == STRING_DATA );
            }

            /**
             * @brief 
             *
             */
        Integer
        intValue() const
            {
                return *static_cast<Integer*>(data);
            }

            /**
             * @brief 
             *
             */
        Float
        floatValue() const
            {
                return *static_cast<Float*>(data);
            }                

            /**
             * @brief 
             *
             */
        const std::string&
        stringValue() const
            {
                return *static_cast<String*>(data);
            }                

            /**
             * @brief 
             *
             * @param out
             */
        virtual void
        toString( std::ostream& out ) const = 0;

    protected:
            /**
             * @brief 
             *
             * @param data
             * @param data
             */            
        SensorData( DataTypes type, void* data )
                : type(type),data(data)
            {}


            // Attributes /////////////////////////////////////
    protected:
        DataTypes type;
        void* data;

            // Associations ///////////////////////////////////

    };// SensorData

    inline std::ostream&
    operator << ( std::ostream& out, const SensorData& data )
    {
        data.toString(out);
        return out;
    }
    
}// namespace primos::kernel
    
#endif
