// Copyright 2002 Rodrigo Araujo Real
//		  Luciano Cavalheiro da Silva
//		  Iara Augustin
//		  Adenauer Correa Yamin
//                Gustavo Frainer
//		  Claudio Fernando Resin Geyer
//
// This file is part of TiPS.
//
// TiPS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// TiPS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with TiPS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Id: TipsLauncher.java 83 2003-12-17 18:04:29Z rreal $
//

package org.isam.exehda.services.tips;

import java.util.*;
import java.io.*;


    /**
    * 
    */
public class TipsLauncher
        extends java.lang.Object
{


    private static Properties prop;
    
        /**
         * TiPS entry point.
         * 
         * @param args Command line arguments
         */
    public static void 
    main(String[] args)
        throws Exception
        {
            start_registry();

            prop = load_properties("tips.properties");
            
            Tips tips = new Tips(prop);
            
            System.out.println("TiPS READY");
        }

    private static void start_registry() 
        {
            try {
                java.rmi.registry.LocateRegistry.createRegistry(1099);
                System.out.println("RMIRegistry criado.");
            } catch (java.rmi.RemoteException re){
                System.out.println("RMIRegistry j existente.");
            }
        }

    private static Properties load_properties(String fname)
        throws Exception
        {
            FileInputStream propStream;
            File f = new File(fname);

            if (!f.exists()) {
                f.createNewFile();
            }
            
            propStream = new FileInputStream(f);                

            
            prop = new Properties();
            prop.load(propStream);
//            prop.list(System.out);
            return(prop);
        }
}
