// Copyright 2002 Rodrigo Araujo Real
//		  Luciano Cavalheiro da Silva
//		  Iara Augustin
//		  Adenauer Correa Yamin
//                Gustavo Frainer
//		  Claudio Fernando Resin Geyer
//
// This file is part of TiPS.
//
// TiPS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// TiPS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with TiPS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Id: UtilityGenImpl2.java 83 2003-12-17 18:04:29Z rreal $
//

/**
 * @file   UtilityGenImpl2.java
 * @author Rodrigo Real
 * @date   Tue Nov 25 17:45:17 2003
 * 
 * @brief  
 * $Id: UtilityGenImpl2.java 83 2003-12-17 18:04:29Z rreal $
 * 
 */

package org.isam.exehda.services.tips;

import java.util.*;

public class UtilityGenImpl2
    implements UtilityGen
{
    private final static int Free=0;
    private final static int Low=1;
    private final static int High=2;
    private final static int Over=3;


    private DataManager dataM;
    
    public UtilityGenImpl2(DataManager dataM)
        {
            System.out.println("Starting UtilityGenImpl2 (CVS $Revision: 83 $) ...");
            this.dataM = dataM;
        }

    
    public void eval(String hostid, Object data) 
        {
            BayesNetworkData2 bnetData = (BayesNetworkData2) data;
            double u;
            
            u = 100*bnetData.getValuefor(Free)*bnetData.getConstancy();
            u += 30*bnetData.getValuefor(Low)*bnetData.getConstancy();
            u += -70*bnetData.getValuefor(High)*bnetData.getConstancy();
            u += -100*bnetData.getValuefor(Over)*bnetData.getConstancy();

            u += 20*bnetData.getValuefor(Free)* (1 - bnetData.getConstancy());
            u += 10*bnetData.getValuefor(Low)* (1 - bnetData.getConstancy());
            u += -40*bnetData.getValuefor(High)*(1 - bnetData.getConstancy());
            u += -90*bnetData.getValuefor(Over)*(1 - bnetData.getConstancy());

            dataM.setUtility(hostid, new Double(u));
        }
}
