// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.worb;

// import org.isam.perv.IsamClassLoader;
// import org.isam.exehda.Exehda;
// import org.isam.exehda.HostId;
// import org.isam.exehda.ApplicationId;
// import org.isam.exehda.ResourceName;
// import org.isam.exehda.services.HttpService;
// import org.isam.exehda.services.Worb;
// import org.isam.exehda.services.Executor;
// import org.isam.exehda.services.Logger.Sev;
// import org.isam.exehda.services.CellInformationBase;
import org.isam.util.codegen.Types;
// import org.isam.util.codegen.proxy.InvocationHandler;
// import org.isam.util.codegen.proxy.Proxy;
import java.util.Hashtable;
import java.lang.reflect.Method;
import java.io.InputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
// import java.io.ObjectInputStream;
// import java.io.ObjectOutputStream;
import java.security.MessageDigest;
import java.security.DigestOutputStream;
// import java.net.URL;
// import java.net.URLConnection;




/**
 * Root of all kinds of WORB service references.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-04-08 15:31:37 -0300 (Fri, 08 Apr 2005) $ $Revision: 738 $
 */
abstract class WorbServiceRef
{
    protected Class serviceInterface;

    protected WorbServiceRef(Class serviceIface)
        {
            this.serviceInterface = serviceIface;
        }

    public abstract Object
    invoke( Long opnum, Method m, Object[] params ) throws Exception;

    protected long
    computeMethodHash(Method m)
        throws java.security.NoSuchAlgorithmException, java.io.IOException
        {
            String methodName = m.getName() + Types.getDescriptor(m);
            
            ByteArrayOutputStream bs = new ByteArrayOutputStream(512);

            MessageDigest md = MessageDigest.getInstance("SHA");

            DataOutputStream ds =
                new DataOutputStream(
                    new DigestOutputStream(bs, md));

            ds.writeUTF(methodName);
            ds.flush();

            byte[] sha = md.digest();

            long hash = 0;
            
            for (int i=0,s=0; i<8; i++,s+=8) {
                hash += ((long) (sha[i] & 0xff)) << s;
            }
            return hash;
        }
}





