// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.perv.protocols.worb;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import org.isam.exehda.services.worb.WorbURLConnection;

/**
 * Stream handler for the "worb:" URL protocol.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-04-12 16:53:58 -0300 (Tue, 12 Apr 2005) $ $Revision: 742 $
 */
public class Handler
    extends java.net.URLStreamHandler
{
    public Handler()
        {
                // empty
        }

    protected URLConnection
    openConnection( URL url )
        throws IOException
        {
            return new WorbURLConnection(url);
        }

    
        /**
         * Overwrite this method if "worb:" URLs dont follow the HTTP syntax.
         *
         * @param url output
         * @param spec string to be parsed
         * @param start position just after the "worb:"
         * @param limit position just before the ref mark '#'
         */
    protected void
    parseURL( URL url, String spec, int start, int limit)
        {
                // save the transport protocol info
            int idx = spec.indexOf('/', start);
            String transp = spec.substring(start, idx);

                // let the default parser do the job
            super.parseURL(url, spec, idx, limit);

                // overwrite the default protocol parsing
            String host = url.getHost();
            int port = url.getPort();
            String file = url.getFile();
            String ref  = url.getRef();;
            
            setURL(url, "worb", transp+host, port, file, ref);
        }
    
}
