package org.isam.exehda.services.dhc;

import java.net.*;

/*
 * UDPServer - Listen for UDP broadcasts and responds with server location
 */

public class UDPServer extends Thread {
    
    String host;
    int length;
    byte[] buf;
    InetAddress group;
    boolean shouldStop;

    MulticastSocket s ;
    
    //creates new UDServer and binds it to "magic" address
    public UDPServer(String host){
	this.host = host;
	length = 5;
	shouldStop = false;

	buf = new byte[1000];
	try{
	    group = InetAddress.getByName("229.5.6.7");
	    s = new MulticastSocket(6789);
	    s.joinGroup(group);
	}catch(Exception e){e.printStackTrace();}
    }

    //sets the flag indicating that the thread should stop
    public void makeStop(){
	shouldStop = true;
    }

    //listens for query messages and responds with host
    public void run(){

	String data;

	DatagramPacket packet = new DatagramPacket(buf, buf.length);
	while(!shouldStop){
	    try{
	
		s.receive(packet);
	    
		data = new String(packet.getData(),0,packet.getLength());
		System.out.println(data+"--"+packet.getLength());
		//if it is a query message...
		if(data.equals("Host Query")){
		    //...responds with host
		    String msg = "Host Query Result:" + host;
		    packet = new DatagramPacket(msg.getBytes(), msg.getBytes().length,group, 6789);
		    s.send(packet);
		}
		
	    }catch(Exception e){e.printStackTrace();}
	}
    }
  
}
