package org.isam.exehda.services.dhc.server;

/*
 * Rule - Maps hostname,ip and mac to a skeleton
 * 
 */

public class Rule {
    int type;
    String expression;
    String skeleton;

    /** creates new rule**/
    public Rule(int type, String expression, String skeleton){
	this.type = type;
	this.expression = expression;
	this.skeleton = skeleton;
    }

    public Rule(String stype, String expression, String skeleton){
	if(stype.equals("ip")){
	    type = 2;
	}else if(stype.equals("hostName")){
	    type = 1;
	} else if(stype=="mac"){
	    type = 3;
	}
	this.expression = expression;
	this.skeleton = skeleton;

	System.out.println(type+"="+expression+"="+skeleton);
    }

    /**verifies if the given machine matches the rule**/
    public boolean match(String hostName, String ipAddr, String mac){
	if(type == 1){//hostname
	    if(hostName.matches(expression))return(true);
	}
	else if (type == 2){//ip
	    if(ipAddr.matches(expression))return(true);
	}
	else if (type == 3){//mac
	    if(mac.matches(expression))return(true);
	}
	return(false);
    }

    /**returns associated skeleton skeleton**/
    public String getSkeleton(){
	return(skeleton);
    }

}
