// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.HostId;

public interface ObjectSeed
{
    public static interface Activator
        extends java.io.Serializable
    {
        void activate( Object obj ) throws Exception;
        void deactivate( Object obj ) throws Exception;
    }

    public static interface Activatable
    {
        void activate() throws Exception;
        void deactivate() throws Exception;
    }
    
    public static class ObjectHandle
        implements java.io.Serializable
    {
        private Object stub;
        
        public ObjectHandle( Object stub )
            {
                this.stub = stub;
            }
        
        public Object getStub()
            {
                return this.stub;
            }
//         Object getActivator();
//         Object getAddress();
    }


    public ObjectHandle
    newInstance(Class cls, Object[] params, Activator a);
}
