// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//



package org.isam.exehda.services.cib;

import org.isam.exehda.services.CellInformationBase.ResourceName;
import org.isam.exehda.services.CellInformationBase.SelectionConstraint;
import org.isam.exehda.services.CellInformationBase.NameSpace;

public interface CibBackEnd
{
    public ResourceName[] select( SelectionConstraint filter, NameSpace ns, int maxResults );

    public ResourceName[] selectByName(String n, NameSpace ns, int maxResults);

    public ResourceName[] selectByType(String t, NameSpace ns, int maxResults);
    
    public String getAttribute(ResourceName r, String a);
    
    public String setAttribute(ResourceName r, String a, String v);
    
    public String[] getAttributes(ResourceName r);
    
    public void addResource(ResourceName r);
    
    public void removeResource(ResourceName r);
}



