// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//


//
// $Id: DataManager.java 611 2005-03-07 10:10:30Z rreal $
//

/**
 * @file   DataManager.java
 * @author Rodrigo Real
 * @date   Fri Aug  1 14:05:48 2003
 * 
 * @brief Interface for building DataManagers for TiPS. DataManagers
 * manages the information that is important to the scheduler.
 * $Id: DataManager.java 611 2005-03-07 10:10:30Z rreal $
 * 
 */


package org.isam.exehda.services.tips;

import java.util.*;

public interface DataManager 
{
        /** 
         * Returns the last received value of the sensor identified by
         * sensorName value for the hostid host
         * 
         * @param sensorName Identification of the sensor
         * 
         * @return an Object which corresponds to the last received data
         */
    public Object getSensorValue(String sensorName);

        /** 
         * Get an object with the history of the readings of the
         * hostid, sensor pair
         * 
         * @param sensorName Identification of the sensor
         * 
         * @return an Object with the history of the received data
         */
    public Object getSensorHistory(String sensorName);
    public void setSensorValue(String sensorName, Object value);

    public boolean hasConstancy(String sensorName);
    public Double getConstancy(String sensorName);
    public void setConstancy(String sensorName, Double value);

    public Double getUtility();
    public void setUtility(Double utility);
//    public Hashtable getUtilityTable();
}

