// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.tips;

import org.isam.exehda.Exehda;
import org.isam.exehda.services.Collector;
import org.isam.exehda.services.Collector.Sensor;
import org.isam.exehda.services.Collector.ConsumerId;
import org.isam.exehda.services.Collector.MonitoringConsumer;
import org.isam.exehda.services.Collector.MonitoringData;
import org.isam.exehda.services.Worb;
import org.isam.exehda.HostId;

public class TipsCellProxy
    implements MonitoringConsumer
{
    
    public TipsCellProxy(String urlTipsBase)
        {
//            System.out.println("==============>>>>>>>>>>>TipsCellProxy");
            thisHost = HostId.getLocalHost();
            
                // obtem referencia para a instacia celular do tips
            Worb worb = (Worb) Exehda.getService(Worb.SERVICE_NAME);
            tipsCell = (CollectUtility)
                worb.lookupService(urlTipsBase, CollectUtility.class);

                // registra-se no collector local e habilita o sensor
            Collector collector = (Collector) Exehda.getService(Collector.SERVICE_NAME);

            this.id = collector.addConsumer(this);
            collector.setSensorEnabled(id, collector.getSensor("utility"), true);
        }

    public void update(long timeStamp, MonitoringData[] data)
        {
//            System.out.println("==============>>>>>>>>>>>TipsCellProxy.update");
            if (data[0] == null)
                return;
            
//            System.out.println(timeStamp + "  " + thisHost  + "  " +  data[0].getDouble());
            tipsCell.updateUtility(timeStamp, thisHost, data[0].getDouble());
            
        }

    private ConsumerId id;
    private HostId     thisHost;
    private CollectUtility tipsCell;
}
