// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

//
// $Id: TipsCellScheduler.java 618 2005-03-10 08:37:45Z rreal $
//

package org.isam.exehda.services.tips;

import org.isam.exehda.HostId;
import org.isam.exehda.ObjectId;
import org.isam.exehda.Exehda;
import org.isam.exehda.services.Scheduler;
import org.isam.exehda.services.AbstractService;
import org.isam.exehda.services.ResourceBroker.ResourceConstraint;
import org.isam.exehda.services.Worb;

import java.rmi.server.UnicastRemoteObject;
import java.lang.reflect.*;
import java.util.*;

public class TipsCellScheduler
    extends AbstractService
    implements Scheduler,CollectUtility
{

    private Hashtable hostTable;
    private TDecMaker decisionM;
    private int test;
    
        /**
         * Describe <code>chooseCreationHost</code> method here.
         *
         * @param c a <code>ResourceConstraints</code> value
         * @return a <code>HostId</code> value
         */
    public HostId chooseCreationHost( ResourceConstraint c ) 
        {
            HostId hi=null;

            
            hi = getBestHostid();
            System.out.println("================= BestHostid " + hi);
            
            return(hi);
        }
    

        /**
         * Describe <code>chooseMigrationHost</code> method here.
         *
         * @param c a <code>ResourceConstraints</code> value
         * @return a <code>HostId</code> value
         */
    public HostId chooseMigrationHost( ResourceConstraint c )
        {
            HostId hi;
            
            hi = getBestHostid();
            
            return(hi);
        }


        /**
         * Describe <code>reschedule</code> method here.
         *
         * @param o an <code>ObjectHandle</code> value
         * @param c a <code>ResourceConstraints</code> value
         * @param auto a <code>boolean</code> value
         */
    public void reschedule( ObjectId o, ResourceConstraint c, boolean auto )
        {
                // fazer a chamada do TiPS mesmo aqui
        }


    public void stop() 
        {}

    public void start()
        throws java.rmi.RemoteException, ClassNotFoundException, InstantiationException,
        IllegalAccessException, InvocationTargetException, NoSuchMethodException
        {
                // Starting the data manager
            hostTable = new Hashtable();

                // Launching the decision maker, which replies to queries for new nodes
//            decisionM = new TDecMakerImpl(hostTable);
            
                // Launching components manager, which permits the substitution of classes
//            CompManager cm = new CompManagerImpl(this);
//            try {
//                java.rmi.Naming.rebind("CompManager", cm);
//            }catch(Exception e){
//                throw new java.rmi.RemoteException("CompManager",e);
                //           }
            
                // exporting the service
            Worb worb = (Worb) Exehda.getService(Worb.SERVICE_NAME);

                // exporta o servio escalonador
            worb.exportService(this,
                               Scheduler.class,
                               TipsCellScheduler.SERVICE_NAME);

                // export o servio "collect utility"
            worb.exportService(this,
                               CollectUtility.class,
                               "TipsCollectUtility");
            
            test=0;

        }

    public void updateUtility(long timeStamp, HostId src, double utility) 
        {
            hostTable.put(src,new Double(utility));
            System.out.println("TipsCellScheduler.updateUtility: timestamp = " + timeStamp + "   host = " + src + "  utility = " + utility);

                //Apenas para testes do metodo que busca o melhor nodo
//             test++;
//             if (test==5) {
//                 getBestHostid();
//                 test=0;
//             }
            
        }

    public HostId getBestHostid()
        {
            System.out.println("########## UOUOUOUOUOUO ################");
    
            HostId hi = null;

            double maxut = -200;
            HostId bestHostid = null;
            
            Set hostidSet = hostTable.keySet();
            Iterator hostIt = hostidSet.iterator();
            while(hostIt.hasNext()) {
                hi = (HostId) hostIt.next();
                if ( maxut <  ((Double)hostTable.get(hi)).doubleValue()) {
                    maxut = ((Double)hostTable.get(hi)).doubleValue();
                }                
            }

                // code for randomly getting the best node
            hostIt = hostidSet.iterator();
            double hostVal;
            Vector alternatives = new Vector();
            while(hostIt.hasNext()) {
                hi = (HostId) hostIt.next();
                hostVal = ((Double)hostTable.get(hi)).doubleValue();
                if ( hostVal > (maxut - 0.5) ) {
                    alternatives.add(hi);
                }                
            }

            if (alternatives.size() > 0) 
                bestHostid = (HostId) alternatives.get( (new Random()).nextInt(alternatives.size()) );
            else
                bestHostid = null;
            

            System.out.println("Choice: " + bestHostid);
            
            
            return(bestHostid);
        } 
}
