// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//


//
// $Id: TipsMonitor.java 611 2005-03-07 10:10:30Z rreal $
//


// Olhar exemplo em ~/ucpel/exehda-dev/src/primos/src/org/isam/exehda/services/primos/NativeMonitor.java

package org.isam.exehda.services.tips;

import org.isam.exehda.services.Collector.Monitor;
import org.isam.exehda.services.Collector.Sensor;
import org.isam.exehda.services.Collector.SensorParameter;
import org.isam.exehda.services.Collector.MonitoringData;
import org.isam.exehda.services.CellInformationBase.ResourceName;
import org.isam.exehda.services.CellInformationBase.NameSpace;
import java.util.Hashtable;


public class TipsMonitor
    implements Monitor
{
    private final String MONITOR_NAME = "TipsMonitor";
    private ResourceName name;
    private Sensor utility;
    private double utilityValue;
    private boolean enabled;

    private DataManager dataM;
    
    
    public TipsMonitor()
        {
            this(null);
        }

    public TipsMonitor(DataManager dataM)
        {
            name = new ResourceName("monitor","tips");
                // FIX ME: replace the key by a meaningful value
            utility = new Sensor(new ResourceName("sensor","utility"),
                                 Double.TYPE,
                                 new Integer(7890));
            enabled=false;
            this.dataM=dataM;
            
            System.out.println("Starting TipsMonitor (CVS $Revision: 611 $) ...");
        }
    

    public ResourceName
    getName()
        {
            return this.name;
        }

    
    public Sensor[]
    getSensors()
        {
            return  new Sensor[] { utility };
        }
    
    public Sensor
    getSensor( String name )
        {
            if (name.equals("utility")) {
                return utility;
            } else {
                return null;
            }
        }
                
        
    public Object getSensorParameter( SensorParameter p )
        {
            throw new NullPointerException("No such sensor parameter.");
        }

    public SensorParameter[] getSensorParameters( Sensor s )
        {
//            throw new NullPointerException("No such sensor parameter.");
            return new SensorParameter[0];
            
        }
    
    
    public void setSensorParameter( SensorParameter p, Object v )
        {
            throw new NullPointerException("No such sensor parameter.");
        }

    public void setSensorEnabled( Sensor s, boolean enable )
        {
            this.enabled=enable;
        }

    public boolean isSensorEnabled( Sensor s )
        {
            return this.enabled;
        }

    public MonitoringData probeSensor( Sensor s, MonitoringData d )
        {

            if (utility.equals(s)) {
	        MonitoringData mon = (d != null) ? d :new MonitoringData(s.getName());
                mon.setDouble(utilityValue);
                    // pegar o valor atual do sensor
                return mon;
            }
            throw new NullPointerException("No such sensor.");
        }

    public void installSensor( String name, String impl, Hashtable params )
        {
                // TO DO: 
            throw new NullPointerException("Operation not supported.");
        }

    public void
    quantumExpired()
        {
            try {
                utilityValue = dataM.getUtility().doubleValue();
//                System.out.println("quantumExpired");
            } catch(Exception e) {
                e.printStackTrace();
            }

        }

}
