// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
package org.isam.exehda.services;

import org.isam.exehda.services.ContextManager.ContextListener;

public interface AdaptEngine
{
    public static final String SERVICE_NAME = "adaptengine";
    
    public static interface ContextInfo
    {
            /**
             * Operation
             *
             * @param ctxName
             * @return String
             */
        public String getContext ( String ctxName );
    }

    public static interface CodeAdaptHeuristic
    {
            /**
             * Operation
             *
             * @param ctxInfo
             * @param baseType
             * @return String
             */
        public String chooseImpl ( ContextInfo ctxInfo, String baseType );
    }
    
        /**
         * Operation
         *
         * @param baseType
         * @return Object
         */
    public Object getInstance ( String baseType );
    
        /**
         * Operation
         *
         * @param ctxName
         * @return String
         */
    public String checkContextState ( String ctxName );
    
        /**
         * Operation
         *
         * @param ctxState
         */
    public void waitForContext ( String ctxState );
    
        /**
         * Operation
         *
         * @param action
         * @param ctxState
         */
    public void runOnContext ( Runnable action, String ctxState );
    
        /**
         * Operation
         *
         * @param l
         * @param ctxName
         */
    public void addContextListener ( ContextListener l, String ctxName );
    
        /**
         * Operation
         *
         * @param l
         */
    public void removeContextListener ( ContextListener l );
}

