// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;



/**
 * Describe interface <code>AvuService</code> here.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2004-11-01 23:21:37 -0300 (Mon, 01 Nov 2004) $ $Revision: 352 $
 */
public interface AvuService
{
    public static final String SERVICE_NAME = "avu";
    public static final int MODE_READ = 1;
    public static final int MODE_WRITE = 2;
    public static final int MODE_APPEND = 4;
    public static final int MODE_CREATE = 8;
    
    public static class AvuDescriptor
    {
            /**
             * Operation
             *
             * @return String
             */
        public String getName() {
            throw new NullPointerException("Not yet implemented");
        }
            /**
             * Operation
             *
             * @return Object
             */
        public Object getKey() {
            throw new NullPointerException("Not yet implemented");
        }
            /**
             * Operation
             *
             * @return int
             */
        public int getModeFlags() {
            throw new NullPointerException("Not yet implemented");
        }
            /**
             * Operation
             *
             * @return java.io.InputStream
             */
        public java.io.InputStream getInputStream() {
            throw new NullPointerException("Not yet implemented");
        }
            /**
             * Operation
             *
             * @return java.io.OutputStream
             */
        public java.io.OutputStream getOutputStream() {
            throw new NullPointerException("Not yet implemented");
        }
    }

        /**
         * Operation
         *
         * @param avuURL
         * @param modeFlags
         */
    public void prefetch ( String avuURL, int modeFlags );
    
        /**
         * Operation
         *
         * @param avuURL
         */
    public void release ( String avuURL );
    
        /**
         * Operation
         *
         * @param avuURL
         */
    public void remove ( String avuURL );
    
        /**
         * Operation
         *
         * @param oldURL
         * @param newURL
         */
    public void move ( String oldURL, String newURL );
    
        /**
         * Operation
         *
         * @param avuPathURL
         * @param recourse
         * @return String[]
         */
    public String[] list ( String avuPathURL, boolean recourse );
    
        /**
         * Operation
         *
         * @param avuURL
         * @param modeFlags
         * @return AvuDescriptor
         */
    public AvuDescriptor open ( String avuURL, int modeFlags );
    
        /**
         * Operation
         *
         * @param desc
         */
    public void close ( AvuDescriptor desc );
    
        /**
         * Operation
         *
         * @param desc
         * @param buff
         * @param offs
         * @param len
         * @return byte[]
         */
    public byte[] read ( AvuDescriptor desc, byte[] buff, int offs, int len );
    
        /**
         * Operation
         *
         * @param desc
         * @param buff
         * @param offs
         * @param len
         * @return int
         */
    public int write ( AvuDescriptor desc, byte[] buff, int offs, int len );
    
        /**
         * Operation
         *
         * @param desc
         * @param pos
         */
    public void seek ( AvuDescriptor desc, long pos );
    
}
    



