// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.cib.backend.ldap;



/**
 * A buffer specialized for efficient building of LDAP DN (Distiguished Names).
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-03-27 11:28:44 -0300 (Sun, 27 Mar 2005) $ $Revision: 655 $
 */
class DnBuffer
{
    public DnBuffer()
        {
            this.buff = null;
        }

    public DnBuffer
    append(String type, String value)
        {
            if ( buff == null ) {
                buff = new StringBuffer();
            }
            else {
                buff.append(',');
            }
            buff.append(type);
            buff.append('=');
            buff.append(value);

            return this;
        }

    public void
    clear()
        {
            this.buff = null;
        }

    public String
    toString()
        {
            return (buff != null) ? buff.toString() : null;
        }

    private StringBuffer buff;
}
