// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

//
// $Id: UtilityGenImpl2.java 611 2005-03-07 10:10:30Z rreal $
//

/**
 * @file   UtilityGenImpl2.java
 * @author Rodrigo Real
 * @date   Tue Nov 25 17:45:17 2003
 * 
 * @brief  
 * $Id: UtilityGenImpl2.java 611 2005-03-07 10:10:30Z rreal $
 * 
 */

package org.isam.exehda.services.tips;

import java.util.*;

public class UtilityGenImpl2
    implements UtilityGen
{
    private final static int Free=0;
    private final static int Low=1;
    private final static int High=2;
    private final static int Over=3;


    private DataManager dataM;
    
    public UtilityGenImpl2(DataManager dataM)
        {
            System.out.println("Starting UtilityGenImpl2 (CVS $Revision: 611 $) ...");
            this.dataM = dataM;
        }

    
    public void eval(Object data) 
        {
            Vector uv = (Vector) data;
            double u;
            double constancy = dataM.getConstancy("CPU_OCCUP_IDLE").doubleValue();
            
            
             u = 100*((Double)uv.get(Free)).doubleValue()*constancy;
            
             u += 30*((Double)uv.get(Low)).doubleValue()*constancy;
             u += -70*((Double)uv.get(High)).doubleValue()*constancy;
             u += -100*((Double)uv.get(Over)).doubleValue()*constancy;

             u += 20*((Double)uv.get(Free)).doubleValue()* (1 - constancy);
             u += 10*((Double)uv.get(Low)).doubleValue()* (1 - constancy);
             u += -40*((Double)uv.get(High)).doubleValue()*(1 - constancy);
             u += -90*((Double)uv.get(Over)).doubleValue()*(1 - constancy);

            dataM.setUtility(new Double(u));
        }
}
