// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.ApplicationId;


public interface SessionManager
{
    public static final String SERVICE_NAME = "sessionmanager";

    public static class SessionDescriptor
        implements java.io.Serializable
    {
            /**
             * Creates a new <code>SessionDescriptor</code> instance.
             *
             * @param sessionName a <code>String</code> value
             */
        public SessionDescriptor( String sessionName )
            {
                throw new NullPointerException("Not yet implemented.");
            }
        
            /**
             * Describe <code>list</code> method here.
             *
             * @return an <code>ApplicationId[]</code> value
             */
        public ApplicationId[] list()
            {
                throw new NullPointerException("Not yet implemented.");
            }
        
            /**
             * Describe <code>remove</code> method here.
             *
             * @param app an <code>ApplicationId</code> value
             */
        public void remove( ApplicationId app )
            {
                throw new NullPointerException("Not yet implemented.");
            }
        
            /**
             * Describe <code>add</code> method here.
             *
             */
        public void add(  ApplicationId app )
            {
                throw new NullPointerException("Not yet implemented.");
            }
        
            /**
             * Describe <code>getName</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getName()
            {
                throw new NullPointerException("Not yet implemented.");
            }
    }
    
        /**
         * Describe <code>saveSession</code> method here.
         *
         * @param s a <code>SessionDescriptor</code> value
         */
    public void saveSession( SessionDescriptor s );
    
        /**
         * Describe <code>currentSession</code> method here.
         *
         * @return a <code>SessionDescriptor</code> value
         */
    public SessionDescriptor currentSession();
    
        /**
         * Describe <code>listSessions</code> method here.
         *
         * @return a <code>SessionDescriptor[]</code> value
         */
    public SessionDescriptor[] listSessions();
    
        /**
         * Describe <code>enterSession</code> method here.
         *
         * @param s a <code>SessionDescriptor</code> value
         */
    public void enterSession( SessionDescriptor s );
    
        /**
         * Describe <code>leaveSession</code> method here.
         *
         */
    public void leaveSession();
}

