// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import java.io.PrintStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;

public interface StdStreams
{
    public static final String SERVICE_NAME = "stdstreams";

    public static interface Console
    {
            /**
             * Describe <code>close</code> method here.
             *
             */
        public void close();
        
            /**
             * Describe <code>getStdIn</code> method here.
             *
             * @return an <code>InputStream</code> value
             */
        public InputStream getStdIn();
        
            /**
             * Describe <code>getStdOut</code> method here.
             *
             * @return a <code>PrintStream</code> value
             */
        public PrintStream getStdOut();
        
            /**
             * Describe <code>getStdErr</code> method here.
             *
             * @return a <code>PrintStream</code> value
             */
        public PrintStream getStdErr();
        
            /**
             * Describe <code>getStdInContactAddress</code> method here.
             *
             * @return an <code>URL</code> value
             */
        public URL getStdInContactAddress();
        
            /**
             * Describe <code>getStdOutContactAddress</code> method here.
             *
             * @return an <code>URL</code> value
             */
        public URL getStdOutContactAddress();
        
            /**
             * Describe <code>getStdErrContactAddress</code> method here.
             *
             * @return an <code>URL</code> value
             */
        public URL getStdErrContactAddress();
        
            /**
             * Describe <code>getStdInName</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getStdInName();
        
            /**
             * Describe <code>getStdOutName</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getStdOutName();
        
            /**
             * Describe <code>getStdErrName</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getStdErrName();
    }
 
        /**
         * Describe <code>redirectStreams</code> method here.
         *
         * @param inURL a <code>String</code> value
         * @param outURL a <code>String</code> value
         * @param errURL a <code>String</code> value
         */
    public void redirectStreams ( String inURL, String outURL, String errURL );
 
        /**
         * Describe <code>setConsole</code> method here.
         *
         * @param c a <code>Console</code> value
         */
    public void setConsole ( Console c );
 
        /**
         * Describe <code>setMasterConsole</code> method here.
         *
         * @param c a <code>Console</code> value
         */
    public void setMasterConsole ( Console c );
}


