package org.isam.exehda.services.dhc.server;

import org.isam.exehda.services.dhc.*;
import java.util.*;

/*
 * Skeleton - skeleton for the generation of primos-d.propreties
 */

public class Skeleton{
    /*Name*/
    String fileName;
    /*Parameters*/
    Hashtable params;
    /*Sensors*/
    List sensors;
    /*Hash of previously seen hosts*/
    Hashtable hosts;
    /*object that generates string from xml*/
    XMLContainer skeleton;

    public Skeleton(String fileName){
	this.fileName = fileName;
	makeFromFile();
	params = new Hashtable();
	hosts = new Hashtable();
    }

    /*makes skeleton from file*/
    protected void makeFromFile(){
	skeleton = new XMLContainer(fileName);
    }

    /*set dynamic params*/
    public void setDynamicParams(String hostName, String ipAddr){
	String lastNumber = ipAddr.substring(ipAddr.lastIndexOf(".")+1);
	String lastNumberHex = Integer.toHexString(Integer.parseInt(lastNumber));
	params.put("hostname",ipAddr);
	params.put("hostid",lastNumberHex);
    }

    /*Genertes new configuration*/
    public String genConfig(String hostName,String ipAddr,String mac){
	String conf = (String)hosts.get(mac);
	if (conf == null){
	    setDynamicParams(hostName,ipAddr);
	    conf = skeleton.getString(params);
	    hosts.put(mac,conf);
	}
	return(conf);
    }

}
