// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.primos.objseed;

import org.isam.exehda.Exehda;
import org.isam.exehda.services.Logger;
import org.isam.exehda.services.Logger.Sev;
import org.isam.exehda.services.ObjectSeed.Activator;


abstract class AbstractActivator
    implements Activator
{
        //
        // XXX: do we really need all these log() variants?
        //
    protected void
    log(int sev, String mtd, String msg, Object[] params)
        {
            final Logger logger = (Logger) Exehda.getService("logger");

            logger.log(sev, getClass().getName(), mtd, msg, params);
        }

    protected void
    log(int sev, String mtd, Throwable t)
        {
            final Logger logger = (Logger) Exehda.getService("logger");

            logger.log(sev, getClass().getName(), mtd, t);
        }

    protected void
    log(int sev, String mtd, String msg)
        {
            log(sev, mtd, msg, (Object[]) null);
        }
    
    protected void
    log(int sev, String mtd, String msg, Object p1)
        {
            synchronized (params1) {
                params1[0] = p1;
                log(sev, mtd, msg, (Object[]) params1);
            }
        }

    protected void
    log(int sev, String mtd, String msg, Object p1, Object p2)
        {
            synchronized (params2) {
                params2[0] = p1;
                params2[1] = p2;
                log(sev, mtd, msg, (Object[]) params2);
            }
        }

    protected void
    log(int sev, String mtd, String msg, Object p1, Object p2, Object p3)
        {
            synchronized (params3) {
                params3[0] = p1;
                params3[1] = p2;
                params3[2] = p3;
                log(sev, mtd, msg, (Object[]) params3);
            }
        }

    private Object[] params1 = new Object[1];
    private Object[] params2 = new Object[2];
    private Object[] params3 = new Object[3];
}
