// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda;


/**
 * Matches resources that are of a given type,i.e. whose <code>TYPE</code> attribute matches the
 * given restricted regular-expression.
 *
 * @see AttributeSimpleMatchConstraint
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-05-04 10:27:21 -0300 (Wed, 04 May 2005) $ $Revision: 846 $
 */
public class ResourceTypeConstraint
    extends AttributeSimpleMatchConstraint
{
        /**
         * Creates a new <code>ResourceTypeConstraint</code> instance.
         *
         * @param rexp the restricted regexp used in matching the value of the
         * <code>TYPE</code> attribute.
         */
    public ResourceTypeConstraint( String rexp )
        {
            super("TYPE", rexp);
        }
}
