// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;


public interface BdaService
{
    final String SERVICE_NAME = "bda";

    
        /**
         * Operation
         *
         * @param bdaURL
         * @return byte[]
         */
    public byte[] fetch ( String bdaURL );
    
        /**
         * Operation
         *
         * @param bdaURL
         * @param cls
         * @param deps
         * @return byte[]
         */
    public byte[] fetch ( String bdaURL, String[] cls, boolean deps );
    
        /**
         * Operation
         *
         * @param localURL
         */
    public void install ( String localURL );
    
        /**
         * Operation
         *
         * @param bdaURL
         */
    public void remove ( String bdaURL );
    
        /**
         * Operation
         *
         * @param bdaURL
         * @return String
         */
    public String getDescriptor ( String bdaURL );
    
        /**
         * Operation
         *
         * @param bdaURL
         * @param xmlDesc
         */
    public void setDescriptor ( String bdaURL, String xmlDesc );
    
        /**
         * Operation
         *
         * @param bdaURL
         * @return String[]
         */
    public String[] listCathegories ( String bdaURL );
    
        /**
         * Operation
         *
         * @param bdaURL
         * @param cathegory
         * @return String[]
         */
    public String[] list ( String bdaURL, String cathegory );
    
}
    
