// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;


/**
 * Describe interface <code>Logger</code> here.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2004-11-01 23:21:37 -0300 (Mon, 01 Nov 2004) $ $Revision: 352 $
 */
public interface Logger
{
    public static final String SERVICE_NAME = "logger";
    
    public static interface Sev
    {
        public final int CRITICAL = 1000;
        public final int ERROR = 2000;
        public final int WARNING = 3000;
        public final int INFO = 4000;
        public final int DEBUG = 5000;
        public final int TRACE = 6000;
    }
    
        /**
         * Describe <code>log</code> method here.
         *
         * @param sev an <code>int</code> value
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param msg a <code>String</code> value
         * @param params an <code>Object[]</code> value
         */
    public void log ( int sev, String cls, String mtd, String msg, Object[] params );
 
        /**
         * Describe <code>log</code> method here.
         *
         * @param sev an <code>int</code> value
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param t a <code>Trowable</code> value
         */
    public void log ( int sev, String cls, String mtd, Throwable t );
    
        /**
         * Describe <code>critical</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param msg a <code>String</code> value
         * @param params an <code>Object[]</code> value
         */
    public void critical ( String cls, String mtd, String msg, Object[] params );
    
        /**
         * Describe <code>critical</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param t a <code>Trowable</code> value
         */
    public void critical ( String cls, String mtd, Throwable t );
    
        /**
         * Describe <code>error</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param msg a <code>String</code> value
         * @param params an <code>Object[]</code> value
         */
    public void error ( String cls, String mtd, String msg, Object[] params );
    
        /**
         * Describe <code>error</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param t a <code>Trowable</code> value
         */
    public void error ( String cls, String mtd, Throwable t );
    
        /**
         * Describe <code>warning</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param msg a <code>String</code> value
         * @param params an <code>Object[]</code> value
         */
    public void warning ( String cls, String mtd, String msg, Object[] params );
    
        /**
         * Describe <code>warning</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param t a <code>Throwable</code> value
         */
    public void warning ( String cls, String mtd, Throwable t );
    
        /**
         * Describe <code>info</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param msg a <code>String</code> value
         * @param params an <code>Object</code> value
         */
    public void info ( String cls, String mtd, String msg, Object[] params );
    
        /**
         * Describe <code>info</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param t a <code>Throwable</code> value
         */
    public void info ( String cls, String mtd, Throwable t );
    
        /**
         * Describe <code>debug</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param msg a <code>String</code> value
         * @param params an <code>Object[]</code> value
         */
    public void debug ( String cls, String mtd, String msg, Object[] params );
    
        /**
         * Describe <code>debug</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param t a <code>Throwable</code> value
         */
    public void debug ( String cls, String mtd, Throwable t );
    
        /**
         * Describe <code>trace</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param msg a <code>String</code> value
         * @param params an <code>Object</code> value
         */
    public void trace ( String cls, String mtd, String msg, Object[] params );
    
        /**
         * Describe <code>trace</code> method here.
         *
         * @param cls a <code>String</code> value
         * @param mtd a <code>String</code> value
         * @param t a <code>Throwable</code> value
         */
    public void trace ( String cls, String mtd, Throwable t );
    
//     public void log( int severity, String className, String method, String msg, Object[] params );

//     public void log( int severity, String className, String method, Throwable t );
}
