// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.avu;

import org.isam.exehda.Exehda;
import org.isam.exehda.services.Logger;

public class AvuImplClient
    implements org.isam.exehda.services.Service
{
    final static String SERVICE_NAME = "avu";
    
    public void
    start()
        {
            final String CLS = getClass().getName();
            final String MTD = "start()";
            
            String avuHost = Exehda.getServiceProperty(SERVICE_NAME,
                                                       "avuHost",
                                                       "localhost");
                // used by avu: protocol handler
            System.getProperties().put("isam.avuHost", avuHost);

            ((Logger) Exehda.getService(Logger.SERVICE_NAME))
                .info(CLS, MTD, "Set avuHost to \"{0}\"", new Object[]{ avuHost });
        }

    public void
    stop()
        {
        }
}
