// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.cib;

import org.isam.exehda.Exehda;
import org.isam.exehda.HostId;
import org.isam.exehda.ApplicationId;
import org.isam.exehda.ResourceName;
import org.isam.exehda.ResourceName.NameSpace;
import org.isam.exehda.ResourceConstraint;
import org.isam.exehda.services.AbstractService;
import org.isam.exehda.services.CellInformationBase;
import org.isam.exehda.services.Worb;
import java.util.Hashtable;


/**
 * Describe class <code>CibImplClient</code> here.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-04-25 02:49:19 -0300 (Mon, 25 Apr 2005) $ $Revision: 803 $
 */
public class CibImplClient
    extends AbstractService
    implements CellInformationBase
{
    final static String PROP_CIB_URI = "contactAddress";
    private CellInformationBase cibCell;

    public CibImplClient()
        {
        }
    
    public void
    start() throws Exception
        {
            Worb worb = (Worb) Exehda.getService(Worb.SERVICE_NAME);

            String cibCellUri = Exehda.getServiceProperty(CellInformationBase.SERVICE_NAME,
                                                          PROP_CIB_URI,
                                                          null);

            if ( cibCellUri != null ) {
                
            cibCell = (CellInformationBase)
                worb.lookupService(cibCellUri, CellInformationBase.class);

            }
            else {
                throw new NullPointerException("Missing cellular CIB contact address in current profile");
            }
            
                //
                // TODO: perhaps, monitor should do node registering
                //
                // register this node
//             cibCell.addHost(
//                 HostId.getLocalHost(),
//                 "//"+HostId.getLocalHost().getInetAddress().getHostAddress()+":1980");

//            ResourceName thisNode = new ResourceName("host:"+HostId.getLocalHost().toString());
//            cibCell.addResource(thisNode);
//            cibCell.setAttribute(thisNode,
//                                 "contactAddress",
//                                 "//"+HostId.getLocalHost().getInetAddress().getHostAddress()+":1980");
        }

    public void
    stop()
        {
                //
                // TODO: unexport service
                //
        }


    
    public ResourceName[]
    select(ResourceConstraint sc, NameSpace ns, int maxResults)
        {
            return cibCell.select(sc, ns, maxResults);
        }
    
//     public ResourceName[]
//     select( SelectionConstraint sc, int maxResults )
//         {
//             return cibCell.select(sc, maxResults);
//         }

//     public ResourceName[]
//     select(ResourceConstraint sc, NameSpace[] ns, int maxResults){
//         return cibCell.select(sc, ns,maxResults);
//     }

    public ResourceName[]
    selectByName(String n, NameSpace ns, int maxResults)
        {
            return cibCell.selectByName(n,ns,maxResults);
        }
    
    public ResourceName[]
    selectByType(String t, NameSpace ns, int maxResults)
        {
            return cibCell.selectByType(t,ns,maxResults);
        }
    
    public String
    getAttribute(ResourceName r, String a)
        {
            return cibCell.getAttribute(r,a);
        }
    
    public String
    setAttribute(ResourceName r, String a, String v)
        {
            return cibCell.setAttribute(r,a,v);
        }
    
    public String[]
    getAttributes(ResourceName r)
        {
            return cibCell.getAttributes(r);
        }
    
    public void addResource(ResourceName r)
        {
            cibCell.addResource(r);
        }
    
    public void removeResource(ResourceName r)
        {
            cibCell.removeResource(r);
        }
    
    
//     public void
//     addHost(HostId h, String contactAddr)
//         {
//             cibCell.addHost(h, contactAddr);
//         }
    
//     public void
//     removeHost(HostId h)
//         {
//             cibCell.removeHost(h);
//         }
    
//     public String
//     getHostAttribute(HostId h, String attrName)
//         {
//             return cibCell.getHostAttribute(h, attrName);
//         }
    
//     public void
//     setHostAttribute(HostId h, String attrName, String attrValue)
//         {
//             cibCell.setHostAttribute(h, attrName, attrValue);
//         }

//     public void
//     addApplication(ApplicationId app, String codeBase)
//         {
//             cibCell.addApplication(app, codeBase);
//         }
    
//     public String
//     getAppAttribute(ApplicationId app, String attrName)
//         {
//             return cibCell.getAppAttribute(app, attrName);
//         }
}
