// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//



package org.isam.exehda.services.cib.backend;

import org.isam.exehda.ResourceName;
import org.isam.exehda.ResourceConstraint;
import org.isam.exehda.ResourceName.NameSpace;



/**
 * Cell Information base storage back-end interface.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-02-25 04:02:15 -0300 (Fri, 25 Feb 2005) $ $Revision: 598 $
 */
public interface CibBackEnd
{
    public void
    init( CibBackEndConf conf )
        throws CibBackEndException;
    
    public ResourceName[]
    select( ResourceConstraint filter, NameSpace ns, int maxResults )
        throws CibBackEndException;
    
    public String
    getAttribute(ResourceName r, String a)
        throws CibBackEndException;
    
    public String
    setAttribute(ResourceName r, String a, String v)
        throws CibBackEndException;
    
    public String[]
    getAttributes(ResourceName r)
        throws CibBackEndException;
    
    public void
    addResource(ResourceName r)
        throws CibBackEndException;
    
    public void
    removeResource(ResourceName r)
        throws CibBackEndException;
}



