// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.cib.backend;

/**
 * Wrapper exception for exceptions raised in back-end specific components.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-04-01 15:38:06 -0300 (Fri, 01 Apr 2005) $ $Revision: 679 $
 */
public class CibBackEndException
    extends java.lang.Exception
{
    public CibBackEndException(String msg, Throwable t)
        {
            super(msg);
            this.cause = t;
        }

    public Throwable getCause()
        {
            return this.cause;
        }

    public String
    toString()
        {
            return super.getMessage()
                + "\nCaused by:"
                + ((cause!=null) ? cause.toString() : "");
        }

    private Throwable cause;
}

