/*
 * DiscovererClientImpl.java
 *
 * Created on February 17, 2005, 10:15 AM
 */

package org.isam.exehda.services.discoverer;
import org.isam.exehda.services.AbstractService;
import org.isam.exehda.services.Worb;
import org.isam.exehda.Exehda;

/**
 *
 * @author  frainer
 */
public class DiscovererClientImpl extends AbstractService implements Discoverer {
    final static String PROP_DISCOVERER_URI = "contactAddress";
    
    private Discoverer cellDiscoverer;
    
    /** Creates a new instance of DiscovererClientImpl */
    public DiscovererClientImpl() {
    }
    
    public void start() throws java.lang.Exception {
         Worb worb = (Worb) Exehda.getService(Worb.SERVICE_NAME);

         //find ou contact addres of the cell instance of the discoverer service
         // and look it up
         String discovererCellUri = Exehda.getServiceProperty(Discoverer.SERVICE_NAME,
                                                          PROP_DISCOVERER_URI,
                                                          "//localhost:1980/discoverer");

         cellDiscoverer = (Discoverer)
                worb.lookupService(discovererCellUri, Discoverer.class);
    }
    
    public void stop() throws java.lang.Exception {
    }
    
    /**
    * Finds a resource that matches the given query.
    *
    * @param q a <code>Query</code> containing the query
    * @return a array of <code>ResourceDescriptor</code>, representing the matching resources found.
    */
    public ResourceDescriptor[] find(Query q) {
        return(cellDiscoverer.find(q));
    }
    
    /**
    * Registers a new resource that is equivalent to the one
    * described in the xml passed as a parameter.
    *
    * @param xmlDesc a <code>String</code> containing a xml document that describes the attributes of a resource
    * @return a new <code>ResourceName</code> that represents the resource added.
    */
    public ResourceDescriptor register(String xmlDesc) {
        return(cellDiscoverer.register(xmlDesc));
    }
    
    /**
    * Removes a previously added resource.
    *
    * @param r a <code>ResourceDescriptor</code> that represents the resource that is to be removed
    * @return void
    */
    public void remove(ResourceDescriptor r) {
        cellDiscoverer.remove(r);
    }
    
    /**
    * Renews a previously added resource.
    *
    * @param r a <code>ResourceDescriptor</code> that represents the resource that is to be renewed
    * @return void
    */
    public void renew(ResourceDescriptor r) {
        cellDiscoverer.renew(r);
    }
    
   
    
}
