/*
 * ResourceLease.java
 *
 * Created on February 15, 2005, 12:27 PM
 */

package org.isam.exehda.services.discoverer;

/**
 *
 * @author  frainer
 */
public class ResourceLease implements java.io.Serializable {
    Object key;
    long expirationTime;
    
    /** Creates a new instance of ResourceLease */
    public ResourceLease(Object key) {
        this.key = key;
        expirationTime = System.currentTimeMillis() + 120000;
    }
    
    /**
    * Recovers the expiration time of this lease
    *
    * @return  a <code>long</code> representing the millisecond when the lease expires
    */    
    public long getExpirationTime(){
        return(expirationTime);
    }
    
    /**
    * Recovers the key to this lease
    *
    * @return  a <code>Object</code> that is the key to this lease
    */   
    public Object getKey(){
        return(key);
    }
    
     /**
    * Sets a new expiration time for this lease
    *
    * @return  a <code>long</code> with the new expiration time for this lease
    */   
    public long setExpirationTime(){
        expirationTime = System.currentTimeMillis() + 120000;
        return(expirationTime);
    }
    
}
