// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.worb;


import org.isam.util.codegen.Types;
import java.util.Hashtable;
import java.lang.reflect.Method;
import java.io.InputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.security.MessageDigest;
import java.security.DigestOutputStream;


class WSServerRef
    extends WorbServiceRef
{
    private final Object serviceImpl;
    private Hashtable methodsByHash;
    
    public WSServerRef( Object impl, Class iface)
        {
            super(iface);
            serviceImpl = impl;
            methodsByHash = null;
        }
    
    public Object
    invoke( Long opnum, Method m, Object[] params )
        throws Exception
        {
            m = loadMethod(opnum);

            return m.invoke(serviceImpl, params);
        }
    
    
    private final synchronized Method
    loadMethod(Long opnum)
        throws java.security.NoSuchAlgorithmException, java.io.IOException
        {
                // delay method loading until the first invocation
            if (methodsByHash == null ) {
                methodsByHash = new Hashtable();

                Method[] methods = serviceInterface.getMethods();
                for ( int m=0; m < methods.length; m++ ) {
                        // register the given method
                    methodsByHash.put(
                        new Long(computeMethodHash(methods[m])),
                        methods[m]);
                }
            }
            return (Method) methodsByHash.get(opnum);
        }
}
