// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.worb;

import java.net.ServerSocket;
import java.net.Socket;
import java.io.IOException;


/**
 * A server socket that accepts WorbSocket connections.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-04-08 15:31:37 -0300 (Fri, 08 Apr 2005) $ $Revision: 738 $
 */
class WorbServerSocket
    extends ServerSocket
{
    WorbServerSocket( int port )
        throws IOException
        {
            super(port);
        }
    
    public Socket
    accept() throws IOException
        {
            WorbSocket ws = new WorbSocket();

            implAccept(ws);
            
            ws.doHostHandshake();
            
            return ws;
        }
}
