package dimi.gui.simple;

import dimi.channel.connection.DisseminationUnitConnection;

import java.util.Timer;
import java.util.TimerTask;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * Um frame para visualizacao de uma conexao
 * @author mauricio
 */
public class ConnectionIFrame extends javax.swing.JInternalFrame {
    
    private Timer timer = new Timer();
    private Updater updater = new Updater();

    private DisseminationUnitConnection connection = null;
    
    private int TARGET_NAME_PROPERTIES_LIST_INDEX = 0;
    private void putTargetNameOnPropertiesList(){
        propertiesListModel.add(TARGET_NAME_PROPERTIES_LIST_INDEX, "Target Name: " + connection.getDisseminatorName());
    }
    private int DIRECTION_TYPE_PROPERTIES_LIST_INDEX = 1;
    private void putDirectionTypeOnPropertiesList(){
        propertiesListModel.add(DIRECTION_TYPE_PROPERTIES_LIST_INDEX, "Direction: " + (connection.isInput()?"input":"output") );
    }
    private int PROCESS_FILTER_PROPERTIES_LIST_INDEX = 2;
    private void putProcessFilterOnPropertiesList(){
        propertiesListModel.add(PROCESS_FILTER_PROPERTIES_LIST_INDEX, "Process Filter: " + connection.isProcessFilter());
    }
    private int MODE_PROPERTIES_LIST_INDEX = 3;
    private void putModeOnPropertiesList(){
        propertiesListModel.add(MODE_PROPERTIES_LIST_INDEX, "Mode: " + (connection.isInDisconnectedOperation()?"Disconnected":"Connected"));
    }
    private int NUMBER_OF_LAST_RECEIVED_TRANSMITED_PROPERTIES_LIST_INDEX = 4;
    private void putNumberOfLastMessageReceivedOnPropertiesList(){
        propertiesListModel.add(NUMBER_OF_LAST_RECEIVED_TRANSMITED_PROPERTIES_LIST_INDEX, "Number of Last Message: " + connection.getNumberOfLastRealMessageReceived());
    }
    private int TIME_OF_LAST_RECEIVED_TRANSMITED_PROPERTIES_LIST_INDEX = 5;
    private void putTimeOfLastMessageReceivedOnPropertiesList(){
        propertiesListModel.add(NUMBER_OF_LAST_RECEIVED_TRANSMITED_PROPERTIES_LIST_INDEX, "Time of Last Message: " + connection.getTimeOfLastRealMessageReceived());
    }
    
    private DefaultListModel propertiesListModel = new DefaultListModel();
    private DefaultListModel messageBufferListModel = new DefaultListModel();
    /**
     * Creates new form ConnectionIFrame
     * @param connection a conexao a ser visualizada
     */
    public ConnectionIFrame(DisseminationUnitConnection connection) {
        initComponents();
        this.connection = connection;
        //
        this.propertiesList.setModel(propertiesListModel);
        this.messageBufferList.setModel(messageBufferListModel);
        //
        disseminatorNameLabel.setText(connection.getDisseminatorName().toString());
        //
        putTargetNameOnPropertiesList();
        putDirectionTypeOnPropertiesList();
        putProcessFilterOnPropertiesList();
        putModeOnPropertiesList();
        putNumberOfLastMessageReceivedOnPropertiesList();
        putTimeOfLastMessageReceivedOnPropertiesList();
    }
    
    class Updater extends TimerTask{
        public void run(){
            if(!connection.isActive()){
                dispose();
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel14 = new javax.swing.JPanel();
        JPanel911 = new javax.swing.JPanel();
        JScrollPane908 = new javax.swing.JScrollPane();
        propertiesList = new javax.swing.JList();
        JPanel913 = new javax.swing.JLabel();
        JPanel912 = new javax.swing.JPanel();
        peersSPane4 = new javax.swing.JScrollPane();
        messageBufferList = new javax.swing.JList();
        peersLabel4 = new javax.swing.JLabel();
        JPanel914 = new javax.swing.JPanel();
        getOutChannelButton1 = new javax.swing.JButton();
        disseminatorNameLabel = new javax.swing.JLabel();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        jPanel14.setLayout(new java.awt.GridLayout(1, 0));

        jPanel14.setBorder(new javax.swing.border.EtchedBorder());
        JPanel911.setLayout(new java.awt.BorderLayout());

        propertiesList.setFont(new java.awt.Font("Default", 0, 10));
        propertiesList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_INTERVAL_SELECTION);
        JScrollPane908.setViewportView(propertiesList);

        JPanel911.add(JScrollPane908, java.awt.BorderLayout.CENTER);

        JPanel913.setFont(new java.awt.Font("Serif", 2, 12));
        JPanel913.setText("Properties:");
        JPanel911.add(JPanel913, java.awt.BorderLayout.NORTH);

        jPanel14.add(JPanel911);

        JPanel912.setLayout(new java.awt.BorderLayout());

        messageBufferList.setFont(new java.awt.Font("Default", 0, 10));
        messageBufferList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_INTERVAL_SELECTION);
        peersSPane4.setViewportView(messageBufferList);

        JPanel912.add(peersSPane4, java.awt.BorderLayout.CENTER);

        peersLabel4.setFont(new java.awt.Font("Serif", 2, 12));
        peersLabel4.setText("Buffer:");
        JPanel912.add(peersLabel4, java.awt.BorderLayout.NORTH);

        jPanel14.add(JPanel912);

        getContentPane().add(jPanel14, java.awt.BorderLayout.CENTER);

        JPanel914.setLayout(new java.awt.BorderLayout());

        getOutChannelButton1.setText("Close This Connection!");
        JPanel914.add(getOutChannelButton1, java.awt.BorderLayout.CENTER);

        getContentPane().add(JPanel914, java.awt.BorderLayout.SOUTH);

        disseminatorNameLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        disseminatorNameLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        disseminatorNameLabel.setText("DISSEMINATOR NAME");
        getContentPane().add(disseminatorNameLabel, java.awt.BorderLayout.NORTH);

        pack();
    }//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel JPanel911;
    private javax.swing.JPanel JPanel912;
    private javax.swing.JLabel JPanel913;
    private javax.swing.JPanel JPanel914;
    private javax.swing.JScrollPane JScrollPane908;
    private javax.swing.JLabel disseminatorNameLabel;
    private javax.swing.JButton getOutChannelButton1;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JList messageBufferList;
    private javax.swing.JLabel peersLabel4;
    private javax.swing.JScrollPane peersSPane4;
    private javax.swing.JList propertiesList;
    // End of variables declaration//GEN-END:variables
    
}
