package dimi.message.buffer;

import dimi.message.Message;
import dimi.message.buffer.MessageBufferImpl;
import java.util.Iterator;
import dimi.DisseminationUnitImpl;

/**
 * Segundo a politica de bufferizacao 'last drop', caso se queira inserir uma
 * mensagem que estoura a capacidade do buffer, nao e possivel inserir a mensagem.
 * @author mcmoraes
 */
public class LastDropDisseminationUnitMessageBuffer extends DisseminationUnitMessageBuffer{
    
    /**
     * Creates a new instance of LastDropDisseminatorMessageBuffer
     * @param disseminator o disseminador dono do buffer
     * @param maximumSize o tamanho maximo do buffer (em bytes)
     */
    public LastDropDisseminationUnitMessageBuffer(DisseminationUnitImpl disseminationUnitImpl, long maximumSize) {
        super(disseminationUnitImpl,maximumSize);
    }
    
    /**
     * Adiciona uma mensagem ao buffer.
     * @param message a mensagem a ser adicionada
     */    
    public void add(Message message){
        long messageSize = message.getHeader().getContentSize();
        if(messageSize + currentSize < maximumSize){
            add(message);
        }
    }
    
}
