// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

//
// $Id: UtilityGenImpl.java 611 2005-03-07 10:10:30Z rreal $
//

/**
 * @file   UtilityGenImpl.java
 * @author Rodrigo Real
 * @date   Sat Aug  2 15:18:01 2003
 * 
 * @brief  
 * $Id: UtilityGenImpl.java 611 2005-03-07 10:10:30Z rreal $
 * 
 */

package org.isam.exehda.services.tips;

import java.util.*;

public class UtilityGenImpl
    implements UtilityGen
{
    private DataManager dataM;
    
    public UtilityGenImpl(DataManager dataM)
        {
            System.out.println("Starting UtilityGen (CVS $Revision: 611 $) ...");
            this.dataM = dataM;
        }
    
    public void eval(Object data) 
        {
            Vector uv = (Vector) data;
            double u;
            
            u = 100*((Double)uv.get(0)).doubleValue();
            u+= 50*((Double)uv.get(1)).doubleValue();
            u+= (-50)*((Double)uv.get(2)).doubleValue();
            u+= (-100)*((Double)uv.get(3)).doubleValue();
            dataM.setUtility(new Double(u));
        }
}
