// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda;

public final class ApplicationId
    implements java.io.Serializable
{
    private HostId host;
        // TODO: stronger unique id
    private long   timeStamp;

    public String
    toString()
        {
            return Long.toHexString(timeStamp)+"@"+host;
        }

    public ApplicationId() throws java.net.UnknownHostException
        {
            host = HostId.getLocalHost();
            timeStamp = System.currentTimeMillis();
        }

    public boolean
    equals(Object o)
        {
            if ( o instanceof ApplicationId ) {
                ApplicationId aid = (ApplicationId) o;

                System.out.println("ApplicationId.equals() this="+this+",o="+aid);
                return host.equals(aid.host)
                    && (timeStamp == aid.timeStamp);
            }

            return false;
        }

    public int
    hashCode()
        {
            return (int) timeStamp ^ host.hashCode();
        }
}
