// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.ApplicationId;
import org.isam.exehda.services.CellInformationBase.ResourceName;
import java.util.Hashtable;

public interface Collector
{
    public static final String SERVICE_NAME = "collector";

    public static class Sensor
        implements java.io.Serializable
    {
            /**
             * Describe <code>getName</code> method here.
             *
             * @return a <code>ResourceName</code> value
             */
        public ResourceName getName() {
            throw new NullPointerException("Not yet implemented");
        }
 
            /**
             * Describe <code>getType</code> method here.
             *
             * @return a <code>Class</code> value
             */
        public Class getType() {
            throw new NullPointerException("Not yet implemented");
        }
 
            /**
             * Describe <code>getKey</code> method here.
             *
             * @return an <code>Object</code> value
             */
        public Object getKey() {
            throw new NullPointerException("Not yet implemented");
        }
    }

    public static class SensorParameter
        implements java.io.Serializable
    {    
            /**
             * Describe <code>getName</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getName (  ){
            throw new NullPointerException("Not yet implemented");
        }
            
            /**
             * Describe <code>getType</code> method here.
             *
             * @return a <code>Class</code> value
             */
        public Class getType (  ){
            throw new NullPointerException("Not yet implemented");
        }
            
            /**
             * Describe <code>getSensor</code> method here.
             *
             * @return a <code>Sensor</code> value
             */
        public Sensor getSensor (  ){
            throw new NullPointerException("Not yet implemented");
        }
    }

    public static interface Monitor
    {
            /**
             * Describe <code>getName</code> method here.
             *
             * @return a <code>ResourceName</code> value
             */
        public ResourceName getName();

            /**
             * Describe <code>getSensors</code> method here.
             *
             * @return a <code>Sensor[]</code> value
             */
        public Sensor[] getSensors();
        
            /**
             * Describe <code>getSensor</code> method here.
             *
             * @param name a <code>String</code> value
             * @return a <code>Sensor</code> value
             */
        public Sensor getSensor( String name );
        
            /**
             * Describe <code>getSensorParameters</code> method here.
             *
             * @param s a <code>Sensor</code> value
             * @return a <code>SensorParameter[]</code> value
             */
        public SensorParameter[] getSensorParameters( Sensor s );
        
            /**
             * Describe <code>getSensorParameter</code> method here.
             *
             * @param p a <code>SensorParameter</code> value
             * @return an <code>Object</code> value
             */
        public Object getSensorParameter( SensorParameter p );
        
            /**
             * Describe <code>setSensorParameter</code> method here.
             *
             * @param p a <code>SensorParameter</code> value
             * @param v an <code>Object</code> value
             */
        public void setSensorParameter( SensorParameter p, Object v );
        
            /**
             * Describe <code>setSensorEnabled</code> method here.
             *
             * @param s a <code>Sensor</code> value
             * @param enable a <code>boolean</code> value
             */
        public void setSensorEnabled( Sensor s, boolean enable );
        
            /**
             * Describe <code>isSensorEnabled</code> method here.
             *
             * @param s a <code>Sensor</code> value
             * @return a <code>boolean</code> value
             */
        public boolean isSensorEnabled( Sensor s );
        
            /**
             * Describe <code>probeSensor</code> method here.
             *
             * @param s a <code>Sensor</code> value
             * @param d a <code>MonitoringData</code> value
             * @return a <code>MonitoringData</code> value
             */
        public MonitoringData probeSensor( Sensor s, MonitoringData d );
        
            /**
             * Describe <code>installSensor</code> method here.
             *
             * @param name a <code>String</code> value
             * @param impl a <code>String</code> value
             * @param params a <code>Hashtable</code> value
             */
        public void installSensor( String name, String impl, Hashtable params );
        
            /**
             * Describe <code>quantumExpired</code> method here.
             *
             */
        public void quantumExpired();
    }

    public static abstract class AppMonitor
        implements Monitor
    {
            /**
             * Describe <code>getName</code> method here.
             *
             * @return a <code>ResourceName</code> value
             */
        public ResourceName getName(){
            throw new NullPointerException("Not yet implemented");
        }
        
            /**
             * Creates a new <code>AppMonitor</code> instance.
             *
             * @param app an <code>ApplicationId</code> value
             */
        public AppMonitor( ApplicationId app ){
            throw new NullPointerException("Not yet implemented");
        }
            
            /**
             * Describe <code>defineSensor</code> method here.
             *
             * @param s an <code>AppSensor</code> value
             */
        public void defineSensor( AppSensor s ){
            throw new NullPointerException("Not yet implemented");
        }
            
            /**
             * Describe <code>removeSensor</code> method here.
             *
             * @param s an <code>AppSensor</code> value
             */
        public void removeSensor( AppSensor s ){
            throw new NullPointerException("Not yet implemented");
        }
    }

    public static interface AppSensor
    {
            /**
             * Describe <code>getName</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getName();
        
            /**
             * Describe <code>probe</code> method here.
             *
             * @return an <code>Object</code> value
             */
        public Object probe();
            
            /**
             * Describe <code>getParameters</code> method here.
             *
             * @return a <code>Hashtable</code> value
             */
        public Hashtable getParameters();
            
            /**
             * Describe <code>setParameters</code> method here.
             *
             * @param params a <code>Hashtable</code> value
             */
        public void setParameters( Hashtable params );
    }
    
    public static interface MonitoringConsumer
    {
            /**
             * Describe <code>update</code> method here.
             *
             * @param timestamp a <code>long</code> value
             * @param data a <code>MonitoringData[]</code> value
             */
        public void update ( long timestamp, MonitoringData[] data );
    }

        // TODO: Serializable -> Externalizable
    public static class MonitoringData
        implements java.io.Serializable
    {
            /**
             * Describe <code>getSensor</code> method here.
             *
             * @return a <code>ResourceName</code> value
             */
        public ResourceName getSensor(){
            throw new NullPointerException("Not yet implemented");
        }

            /**
             * Describe <code>getTimeStamp</code> method here.
             *
             * @return a <code>long</code> value
             */
        public long getTimeStamp(){
            throw new NullPointerException("Not yet implemented");
        }

            /**
             * Describe <code>getInt</code> method here.
             *
             * @return an <code>int</code> value
             */
        public int getInt(){
            throw new NullPointerException("Not yet implemented");
        }

            /**
             * Describe <code>getLong</code> method here.
             *
             * @return a <code>long</code> value
             */
        public long getLong(){
            throw new NullPointerException("Not yet implemented");
        }

            /**
             * Describe <code>getDouble</code> method here.
             *
             * @return a <code>double</code> value
             */
        public double getDouble(){
            throw new NullPointerException("Not yet implemented");
        }

            /**
             * Describe <code>getString</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getString(){
            throw new NullPointerException("Not yet implemented");
        }

            /**
             * Describe <code>setTimeStamp</code> method here.
             *
             */
        public void setTimeStamp(){
            throw new NullPointerException("Not yet implemented");
        }

            /**
             * Creates a new <code>setInt</code> instance.
             *
             * @param v an <code>int</code> value
             */
        public void setInt ( int v ){
            throw new NullPointerException("Not yet implemented");
        }

            /**
             * Creates a new <code>setLong</code> instance.
             *
             * @param v a <code>long</code> value
             */
        public void setLong ( long v ){
            throw new NullPointerException("Not yet implemented");
        }

            /**
             * Creates a new <code>setDouble</code> instance.
             *
             * @param v a <code>double</code> value
             */
        public void setDouble ( double v ){
            throw new NullPointerException("Not yet implemented");
        }

            /**
             * Creates a new <code>setString</code> instance.
             *
             * @param s a <code>String</code> value
             */
        public void setString ( String s ){
            throw new NullPointerException("Not yet implemented");
        }
    }

    public static class ConsumerId
        implements java.io.Serializable
    {    
            /**
             * Describe <code>getKey</code> method here.
             *
             * @return an <code>Object</code> value
             */
        public Object getKey (){
            throw new NullPointerException("Not yet implemented");
        }   
            /**
             * Describe <code>getCollector</code> method here.
             *
             * @return a <code>ResourceName</code> value
             */
        public ResourceName getCollector(){
            throw new NullPointerException("Not yet implemented");
        }    
            /**
             * Describe <code>getMulticastChannel</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getMulticastChannel(){
            throw new NullPointerException("Not yet implemented");
        }
    }
    
        /**
         * Describe <code>getName</code> method here.
         *
         * @return a <code>ResourceName</code> value
         */
    public ResourceName getName();
    
        /**
         * Describe <code>getSensors</code> method here.
         *
         * @return a <code>Sensor[]</code> value
         */
    public Sensor[] getSensors();

        /**
         * Describe <code>getSensor</code> method here.
         *
         * @param name a <code>String</code> value
         * @return a <code>Sensor</code> value
         */
    public Sensor getSensor( String name );

        /**
         * Describe <code>getSensorParameters</code> method here.
         *
         * @param s a <code>Sensor</code> value
         * @return a <code>SensorParameter[]</code> value
         */
    public SensorParameter[] getSensorParameters( Sensor s );

        /**
         * Describe <code>getSensorParameter</code> method here.
         *
         * @param p a <code>SensorParameter</code> value
         * @return an <code>Object</code> value
         */
    public Object getSensorParameter( SensorParameter p );

        /**
         * Describe <code>setSensorParameter</code> method here.
         *
         * @param c a <code>ConsumerId</code> value
         * @param p a <code>SensorParameter</code> value
         * @param v an <code>Object</code> value
         */
    public void setSensorParameter( ConsumerId c, SensorParameter p, Object v );

        /**
         * Describe <code>setSensorEnabled</code> method here.
         *
         * @param c a <code>ConsumerId</code> value
         * @param s a <code>Sensor</code> value
         * @param enable a <code>boolean</code> value
         */
    public void setSensorEnabled( ConsumerId c, Sensor s, boolean enable );

        /**
         * Describe <code>isSensorEnabled</code> method here.
         *
         * @param c a <code>ConsumerId</code> value
         * @param s a <code>Sensor</code> value
         * @return a <code>boolean</code> value
         */
    public boolean isSensorEnabled( ConsumerId c, Sensor s );

        /**
         * Describe <code>probeSensor</code> method here.
         *
         * @param c a <code>ConsumerId</code> value
         * @param s a <code>Sensor</code> value
         * @param d a <code>MonitoringData</code> value
         * @return a <code>MonitoringData</code> value
         */
    public MonitoringData probeSensor( ConsumerId c, Sensor s, MonitoringData d );

        /**
         * Describe <code>installSensor</code> method here.
         *
         * @param c a <code>ConsumerId</code> value
         * @param name a <code>String</code> value
         * @param impl a <code>String</code> value
         * @param params a <code>Hashtable</code> value
         */
    public void installSensor( ConsumerId c, String name, String impl, Hashtable params );

        /**
         * Describe <code>addMonitor</code> method here.
         *
         * @param m a <code>Monitor</code> value
         */
    public void addMonitor( Monitor m );

        /**
         * Describe <code>removeMonitor</code> method here.
         *
         * @param m a <code>Monitor</code> value
         */
    public void removeMonitor( Monitor m );

        /**
         * Describe <code>addConsumer</code> method here.
         *
         * @param c a <code>MonitoringConsumer</code> value
         * @return a <code>ConsumerId</code> value
         */
    public ConsumerId addConsumer( MonitoringConsumer c );

        /**
         * Describe <code>removeConsumer</code> method here.
         *
         * @param c a <code>ConsumerId</code> value
         */
    public void removeConsumer( ConsumerId c );
}

