// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.ApplicationId;

public interface ContextManager
{
    public static final String SERVICE_NAME = "ctxmanager";

    
    public static class Context
    {
            /**
             * Describe <code>getName</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getName(){
            throw new NullPointerException("Not yet implemented");
        }
            
            /**
             * Describe <code>getScope</code> method here.
             *
             * @return an <code>ApplicationId</code> value
             */
        public ApplicationId getScope(){
            throw new NullPointerException("Not yet implemented");
        }
            
            /**
             * Describe <code>getDefinition</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getDefinition(){
            throw new NullPointerException("Not yet implemented");
        }
            
            /**
             * Describe <code>getStateInstance</code> method here.
             *
             * @param state a <code>String</code> value
             * @return a <code>ContextState</code> value
             */
        public ContextState getStateInstance( String state ){
            throw new NullPointerException("Not yet implemented");
        }
        
            /**
             * Creates a new <code>Context</code> instance.
             *
             * @param name a <code>String</code> value
             * @param scope an <code>ApplicationId</code> value
             * @param def a <code>String</code> value
             * @param states a <code>String[]</code> value
             */
        Context( String name, ApplicationId scope, String def, String[] states ){
            throw new NullPointerException("Not yet implemented");
        }
    }

    public static class ContextState
    {
            /**
             * Describe <code>getType</code> method here.
             *
             * @return a <code>Context</code> value
             */
        public Context getType()
            {
                throw new NullPointerException("Not yet implemented");
            }

            /**
             * Describe <code>getValue</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getValue()
            {
                throw new NullPointerException("Not yet implemented");
            }
    }

    public static interface ContextListener
    {
            /**
             * Describe <code>contextChanged</code> method here.
             *
             * @param prev a <code>ContextState</code> value
             * @param curr a <code>ContextState</code> value
             */
        public void contextChanged( ContextState prev, ContextState curr );
    }
    
        /**
         * Describe <code>createContext</code> method here.
         *
         * @param xmlDesc a <code>String</code> value
         * @return a <code>Context</code> value
         */
    public Context createContext( String xmlDesc );
    
        /**
         * Describe <code>releaseContext</code> method here.
         *
         * @param ctx a <code>Context</code> value
         */
    public void releaseContext( Context ctx );
    
        /**
         * Describe <code>addContextListener</code> method here.
         *
         * @param l a <code>ContextListener</code> value
         * @param ctx a <code>Context</code> value
         */
    public void addContextListener( ContextListener l, Context ctx );
    
        /**
         * Describe <code>removeContextListener</code> method here.
         *
         * @param l a <code>ContextListener</code> value
         * @param ctx a <code>Context</code> value
         */
    public void removeContextListener( ContextListener l, Context ctx );
}

