// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.services.CellInformationBase.ResourceName;
import java.util.Date;


public interface Discoverer
{
    public static final String SERVICE_NAME = "discoverer";

    public static class ResourceDescriptor
    {
            /**
             * Creates a new <code>ResourceDescriptor</code> instance.
             *
             * @param r a <code>ResourceName</code> value
             * @param lease a <code>ResourceLease</code> value
             */
        public ResourceDescriptor( ResourceName r, ResourceLease lease )
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Describe <code>getName</code> method here.
             *
             * @return a <code>ResurceName</code> value
             */
        public ResourceName getName()
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getLease</code> method here.
             *
             * @return a <code>ResourceLease</code> value
             */
        public ResourceLease getLease()
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getAttribute</code> method here.
             *
             * @param a a <code>String</code> value
             * @param defaultValue a <code>String</code> value
             * @return a <code>String</code> value
             */
        public String getAttribute( String a, String defaultValue )
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Creates a new <code>setAttribute</code> instance.
             *
             * @param a a <code>String</code> value
             * @param v a <code>String</code> value
             */
        public void setAttribute( String a, String v )
            {
                throw new NullPointerException("Not yet implemented");
            }
    }

    public static class ResourceLease
    {
            /**
             * Creates a new <code>ResourceLease</code> instance.
             *
             * @param key an <code>Object</code> value
             * @param perms a <code>String[]</code> value
             */
        public ResourceLease ( Object key, String[] perms )
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Describe <code>checkPermission</code> method here.
             *
             * @param p a <code>String</code> value
             * @return a <code>boolean</code> value
             */
        public boolean checkPermission ( String p )
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Describe <code>getExpirationTime</code> method here.
             *
             * @return a <code>Date</code> value
             */
        public Date getExpirationTime()
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Describe <code>getKey</code> method here.
             *
             * @return an <code>Object</code> value
             */
        public Object getKey()
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Describe <code>setExpirationTime</code> method here.
             *
             * @return a <code>Date</code> value
             */
        public Date setExpirationTime()
            {
                throw new NullPointerException("Not yet implemented");
            }
    }
    
        /**
         * Describe <code>register</code> method here.
         *
         * @param xmlDesc a <code>String</code> value
         * @return a <code>ResourceDescriptor</code> value
         */
    public ResourceDescriptor register( String xmlDesc );
    
        /**
         * Describe <code>remove</code> method here.
         *
         * @param r a <code>ResourceDescriptor</code> value
         */
    public void remove( ResourceDescriptor r );
    
        /**
         * Describe <code>renew</code> method here.
         *
         * @param r a <code>ResourceDescriptor</code> value
         */
    public void renew( ResourceDescriptor r );
    
        /**
         * Describe <code>find</code> method here.
         *
         * @param xmlQuery a <code>String</code> value
         * @return a <code>ResourceDescriptor[]</code> value
         */
    public ResourceDescriptor[] find( String xmlQuery );
}

