// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.ApplicationId;
import org.isam.exehda.HostId;
import org.isam.exehda.services.CellInformationBase.ResourceName;


public interface Dispatcher
{
    public static final String SERVICE_NAME = "dispatcher";

        // TODO: implement Externalizable
    public static class Port
        implements java.io.Serializable
    {
            /**
             * Creates a new <code>Port</code> instance.
             *
             * @param desc a <code>PortDescriptor</code> value
             */
        public Port ( PortDescriptor desc )
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getDescriptor</code> method here.
             *
             * @return a <code>PortDescriptor</code> value
             */
        public PortDescriptor getDescriptor()
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>send</code> method here.
             *
             * @param m a <code>Message</code> value
             */
        public void send( Message m )
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Describe <code>receive</code> method here.
             *
             * @return a <code>Message</code> value
             */
        public Message receive()
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>setDescriptor</code> method here.
             *
             */
        protected void setDescriptor()
            {
                throw new NullPointerException("Not yet implemented");
            }
    }

    public static class PortDescriptor
        implements java.io.Serializable
    {
            /**
             * Creates a new <code>PortDescriptor</code> instance.
             *
             * @param key an <code>Object</code> value
             * @param addr a <code>PortAddress</code> value
             */
        public PortDescriptor( Object key, PortAddress addr )
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Describe <code>getAddress</code> method here.
             *
             * @return a <code>PortAddress</code> value
             */
        public PortAddress getAddress()
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Describe <code>getKey</code> method here.
             *
             * @return an <code>Object</code> value
             */
        public Object getKey()
            {
                throw new NullPointerException("Not yet implemented");
            }
    }

    public static class PortAddress
        implements java.io.Serializable
    {
            /**
             * Creates a new <code>PortAddress</code> instance.
             *
             * @param id a <code>long</code> value
             * @param app an <code>ApplicationId</code> value
             * @param owner a <code>ResourceName</code> value
             */
        public PortAddress ( long id, ApplicationId app, ResourceName owner )
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getId</code> method here.
             *
             * @return a <code>long</code> value
             */
        public long getId()
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getApplication</code> method here.
             *
             * @return an <code>ApplicationId</code> value
             */
        public ApplicationId getApplication()
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getOnwer</code> method here.
             *
             * @return a <code>ResourceName</code> value
             */
        public ResourceName getOnwer()
            {
                throw new NullPointerException("Not yet implemented");
            }
    }

    public static class Message
//        implements java.io.DataInput, java.io.DataOutput
    {
        
            /**
             * Creates a new <code>Message</code> instance.
             *
             * @param src a <code>Port</code> value
             * @param tgt a <code>PortAddress</code> value
             */
        public Message( Port src, PortAddress tgt, int flags)
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Creates a new <code>Message</code> instance.
             *
             * @param src a <code>PortAddress</code> value
             * @param tgt a <code>Port</code> value
             * @param content a <code>MessageBuffer</code> value
             */
        public Message( PortAddress src, Port tgt, MessageBuffer content )
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>append</code> method here.
             *
             */
        public void append (  MessageBuffer buf )
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getInputStream</code> method here.
             *
             * @return a <code>java.io.InputStream</code> value
             */
        public java.io.InputStream getInputStream()
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getOutputStream</code> method here.
             *
             * @return a <code>java.io.OutputStream</code> value
             */
        public java.io.OutputStream getOutputStream()
            {
                throw new NullPointerException("Not yet implemented");
            }
    }

    public static interface MessageFlags
    {
        public static final int PRIO_MASK = 0x0F ;
        public static final int PRIO_LOW = 0x01;
        public static final int PRIO_NORMAL = 0x02;
        public static final int PRIO_HIGH = 0x03;
        public static final int PRIO_DEFAULT = 0x00;
        public static final int PRIV_MASK = 0xF0;
        public static final int PRIV_LOW = 0x10;
        public static final int PRIV_NORMAL = 0x20;
        public static final int PRIV_HIGH = 0x30;
        public static final int PRIV_DEFAULT = 0x00;
    }

    public static interface MessageBuffer
    {        
            /**
             * Describe <code>getLength</code> method here.
             *
             * @return a <code>long</code> value
             */
        public long getLength();
        
            /**
             * Describe <code>getOffset</code> method here.
             *
             * @return a <code>long</code> value
             */
        public long getOffset();
        
            /**
             * Describe <code>write</code> method here.
             *
             * @param b an <code>int</code> value
             */
        public void write( int b );
        
            /**
             * Describe <code>write</code> method here.
             *
             * @param b a <code>byte[]</code> value
             * @return an <code>int</code> value
             */
        public int write( byte[] b );
        
            /**
             * Describe <code>read</code> method here.
             *
             * @return an <code>int</code> value
             */
        public int read();
        
            /**
             * Describe <code>read</code> method here.
             *
             * @param buff a <code>byte[]</code> value
             * @param offs an <code>int</code> value
             * @param len an <code>int</code> value
             * @return an <code>int</code> value
             */
        public int read( byte[] buff, int offs, int len );
        
            /**
             * Describe <code>skip</code> method here.
             *
             * @param nbytes a <code>long</code> value
             */
        public void skip ( long nbytes );
        
            /**
             * Describe <code>getSourceAddress</code> method here.
             *
             * @return a <code>PortAddress</code> value
             */
        public PortAddress getSourceAddress();
        
            /**
             * Describe <code>getDestinationAddress</code> method here.
             *
             * @return a <code>PortAddress</code> value
             */
        public PortAddress getDestinationAddress();
        
            /**
             * Describe <code>getFlags</code> method here.
             *
             * @param mask an <code>int</code> value
             * @return an <code>int</code> value
             */
        public int getFlags( int mask );
    }
    
        /**
         * Describe <code>createPort</code> method here.
         *
         * @param id an <code>int</code> value
         * @return a <code>Port</code> value
         */
    public Port createPort( int id );
    
        /**
         * Describe <code>lookupPort</code> method here.
         *
         * @param id an <code>int</code> value
         * @param app an <code>ApplicationId</code> value
         * @param host a <code>HostId</code> value
         * @return a <code>PortAddress</code> value
         */
    public PortAddress lookupPort( int id, ApplicationId app, HostId host );
    
        /**
         * Describe <code>releasePort</code> method here.
         *
         * @param p a <code>Port</code> value
         */
    public void releasePort( Port p );
    
        /**
         * Describe <code>suspendPort</code> method here.
         *
         * @param p a <code>Port</code> value
         */
    public void suspendPort( Port p );
    
        /**
         * Describe <code>resumePort</code> method here.
         *
         * @param p a <code>Port</code> value
         */
    public void resumePort( Port p );
    
        /**
         * Describe <code>redirectPort</code> method here.
         *
         * @param local a <code>PortDescriptor</code> value
         * @param remote a <code>PortDescriptor</code> value
         */
    public void redirectPort( PortDescriptor local, PortDescriptor remote );
    
        /**
         * Describe <code>allocBuffer</code> method here.
         *
         * @param port a <code>Port</code> value
         * @param tgt a <code>PortAddress</code> value
         * @param size a <code>long</code> value
         * @return a <code>MessageBuffer</code> value
         */
    public MessageBuffer allocBuffer( Port port, PortAddress tgt, long size, int flags);
    
        /**
         * Describe <code>releaseBuffer</code> method here.
         *
         * @param mb a <code>MessageBuffer</code> value
         */
    public void releaseBuffer( MessageBuffer mb );
    
        /**
         * Describe <code>send</code> method here.
         *
         * @param p a <code>Port</code> value
         * @param m a <code>MessageBuffer</code> value
         */
    public void send( Port p, MessageBuffer m );
    
        /**
         * Describe <code>receive</code> method here.
         *
         * @param p a <code>Port</code> value
         * @param timeoutMillis a <code>long</code> value
         * @return a <code>MessageBuffer</code> value
         */
    public MessageBuffer receive( Port p, long timeoutMillis );
}

