// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.ObjectId;
import org.isam.exehda.HostId;


public interface OXManager
{
    public static final String SERVICE_NAME = "oxmanager";
    
    public static final byte ATT_READ = 0;
    public static final byte ATT_WRITE = 1;


    public static abstract class OXHandle
    {
            /**
             * Describe <code>getId</code> method here.
             *
             * @return an <code>ObjectId</code> value
             */
        public ObjectId getId()
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getOwner</code> method here.
             *
             * @return a <code>HostId</code> value
             */
        abstract public HostId getOwner ();
        
            /**
             * Describe <code>getAttribute</code> method here.
             *
             * @param attr a <code>String</code> value
             * @return an <code>Object</code> value
             */
        abstract public Object getAttribute ( String attr );
        
        
            /**
             * Describe <code>setAttribute</code> method here.
             *
             * @param attr a <code>String</code> value
             * @param val an <code>Object</code> value
             */
        abstract public void setAttribute ( String attr, Object val );
        
            /**
             * Creates a new <code>OXHandle</code> instance.
             *
             * @param oid an <code>ObjectId</code> value
             */
//         OXHandle( ObjectId oid )
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
    }

    public class HomeOXHandle
        extends OXHandle
    {
        
            /**
             * Describe <code>getId</code> method here.
             *
             * @return an <code>ObjectId</code> value
             */
        public ObjectId getId()
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Describe <code>getOwner</code> method here.
             *
             * @return a <code>HostId</code> value
             */
        public HostId getOwner()
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getAttribute</code> method here.
             *
             * @param attr a <code>String</code> value
             * @return an <code>Object</code> value
             */
        public Object getAttribute( String attr )
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Describe <code>setAttribute</code> method here.
             *
             * @param attr a <code>String</code> value
             * @param val an <code>Object</code> value
             */
        public void setAttribute( String attr, Object val )
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Creates a new <code>HomeOXHandle</code> instance.
             *
             * @param ox an <code>ObjectId</code> value
             */
        HomeOXHandle ( ObjectId ox )
            {
                throw new NullPointerException("Not yet implemented");
            }
    }

    public class MasterOXHandle
        extends OXHandle
    {
            /**
             * Describe <code>getId</code> method here.
             *
             * @return an <code>ObjectId</code> value
             */
        public ObjectId getId()
            {
                throw new NullPointerException("Not yet implemented");
            }

            /**
             * Describe <code>getOwner</code> method here.
             *
             * @return a <code>HostId</code> value
             */
        public HostId getOwner (  )
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>getAttribute</code> method here.
             *
             * @param attr a <code>String</code> value
             * @return an <code>Object</code> value
             */
        public Object getAttribute ( String attr )
            {
                throw new NullPointerException("Not yet implemented");
            }
        
            /**
             * Describe <code>setAttribute</code> method here.
             *
             * @param attr a <code>String</code> value
             * @param val an <code>Object</code> value
             */
        public void setAttribute ( String attr, Object val )
            {
                throw new NullPointerException("Not yet implemented");
            }
            
            /**
             * Creates a new <code>MasterOXHandle</code> instance.
             *
             * @param ox an <code>ObjectId</code> value
             */
        MasterOXHandle ( ObjectId ox )
            {
                throw new NullPointerException("Not yet implemented");
            }
    }

    public static class RmiOXHandle
    {
            /**
             * Describe <code>getStub</code> method here.
             *
             * @param ox an <code>OXHandle</code> value
             * @return a <code>java.rmi.Remote</code> value
             */
        public static java.rmi.Remote getStub ( OXHandle ox )
            {
                throw new NullPointerException("Not yet implemented");
            }
  
            /**
             * Describe <code>setStub</code> method here.
             *
             * @param ox an <code>OXHandle</code> value
             * @param stub a <code>java.rmi.Remote</code> value
             */
        public static void setStub ( OXHandle ox, java.rmi.Remote stub )
            {
                throw new NullPointerException("Not yet implemented");
            }
    }

    public static interface OXAttributeOps
    {
        public static final byte READ = 0;
        public static final byte WRITE = 1;
        public static final byte SET_RO = 2;
        public static final byte CLR_RO = 4;
    }
    
        /**
         * Describe <code>createHandle</code> method here.
         *
         * @param oid an <code>ObjectId</code> value
         * @return an <code>OXHandle</code> value
         */
    public OXHandle createHandle ( ObjectId oid );
    
        /**
         * Describe <code>releaseHandle</code> method here.
         *
         * @param ox an <code>OXHandle</code> value
         */
    public void releaseHandle ( OXHandle ox );
    
        /**
         * Describe <code>grantOwnership</code> method here.
         *
         * @param ox an <code>OXHandle</code> value
         * @return an <code>OXHandle</code> value
         */
    public OXHandle grantOwnership ( OXHandle ox );
    
        /**
         * Describe <code>requestOwnership</code> method here.
         *
         * @param ox an <code>OXHandle</code> value
         * @return an <code>OXHandle</code> value
         */
    public OXHandle requestOwnership ( OXHandle ox );
    
        /**
         * Describe <code>updateAttributes</code> method here.
         *
         * @param ox an <code>OXHandle</code> value
         * @param att a <code>String[]</code> value
         * @param op a <code>byte[]</code> value
         * @return an <code>OXHandle</code> value
         */
    public OXHandle updateAttributes ( OXHandle ox, String[] att, byte[] op );
}

