// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.ApplicationId;
import org.isam.exehda.HostId;

/**
 * Webservices ORB
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2004-08-06 16:22:32 -0300 (Fri, 06 Aug 2004) $ $Revision: 262 $
 */
public interface Worb
{
    public static final String SERVICE_NAME = "worb";

    public static class WorbException
//        extends XXX
    {}

    public static interface WorbProxy
    {
            /**
             * Describe <code>getServiceContactAddress</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getServiceContactAddress();
        
            /**
             * Describe <code>setServiceContactAddress</code> method here.
             *
             * @param ca a <code>String</code> value
             */
        public void setServiceContactAddress( String ca );
        
            /**
             * Describe <code>setExceptionHandler</code> method here.
             *
             * @param h a <code>WorbExceptionHandler</code> value
             */
        public void setExceptionHandler( WorbExceptionHandler h );
    }

    public static interface WorbExceptionHandler
    {
            /**
             * Describe <code>handleException</code> method here.
             *
             * @param proxy a <code>WorbProxy</code> value
             * @param e a <code>WorbException</code> value
             * @return a <code>Throwable</code> value
             */
        public Throwable handleException ( WorbProxy proxy, WorbException e );
    }

    public static abstract class AutoRetryHandler
        implements WorbExceptionHandler
    {
//         public AutoRetryHandler ( int ntimes, long delayMillis ){
//         }
//         public Throwable handleException ( WorbProxy proxy, WorbException e ){
//         }
    }
    
        /**
         * Describe <code>exportService</code> method here.
         *
         * @param o an <code>Object</code> value
         * @param iface a <code>Class</code> value
         * @param name a <code>String</code> value
         */
    public void exportService ( Object o, Class iface, String name );

        /**
         * Describe <code>unexportService</code> method here.
         *
         * @param o an <code>Object</code> value
         * @param name a <code>String</code> value
         */
    public void unexportService ( Object o, String name );
    
        /**
         * Describe <code>lookupService</code> method here.
         *
         * @param name a <code>String</code> value
         * @param iface a <code>Class</code> value
         * @return an <code>Object</code> value
         */
    public Object lookupService ( String name, Class iface );
    
        /**
         * Describe <code>getClientHost</code> method here.
         *
         * @return a <code>HostId</code> value
         */
    public HostId getClientHost();
    
        /**
         * Describe <code>setExceptionHandler</code> method here.
         *
         * @param proxy an <code>Object</code> value
         * @param handler a <code>WorbExceptionHandler</code> value
         */
    public void setExceptionHandler ( Object proxy, WorbExceptionHandler handler );
    
}
