package dimi.example;

import dimi.configuration.ChannelConfiguration;
import dimi.DisseminationService;
import dimi.message.MessageListener;
import dimi.message.MessageContent;
import dimi.ProducerEntryPoint;
import dimi.ConsumerEntryPointImpl;
import dimi.name.ChannelName;

import dimi.ConsumerEntryPoint;

import java.net.InetAddress;
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.util.Timer;
import java.util.TimerTask;

import java.io.PipedOutputStream;
import java.io.PipedInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.io.InputStream;

public class ConsumerExample {

    private ConsumerEntryPoint consumerEntryPoint = null;
    private ConsumerEntryPointGUIExample consumerEntryPointGUIExample = null;
    private InputStream inputStream = null;
    
    public ConsumerExample(ConsumerEntryPoint consumerEntryPoint, InputStream inputStream) throws RemoteException{
        this.consumerEntryPoint = consumerEntryPoint;
        this.inputStream = inputStream;
        consumerEntryPointGUIExample = new ConsumerEntryPointGUIExample(consumerEntryPoint);
        (new Thread(new OutputReader())).start();
    }
    
    public void show(){
        consumerEntryPointGUIExample.show();
    }
    
    class OutputReader implements Runnable{
        public void run(){
            byte[] barray = new byte[1];
            while(true){
                try{
                    inputStream.read(barray);
                    consumerEntryPointGUIExample.getTextArea().append(new String(barray));
                }
                catch(IOException ioe){ioe.printStackTrace();}
            }
        }
    }

    public static void main(String[] args) {
        
System.out.println("main - STARTING");
        
        try{

            DisseminationService service = (DisseminationService)Naming.lookup("//"+InetAddress.getLocalHost().getHostName()+"/disseminator"+args[0]);
System.out.println("service name: "+service.getServiceName());
            PipedOutputStream pipedOutputStream = null;
            PipedInputStream pipedInputStream = null;
            try{
                pipedOutputStream = new PipedOutputStream();
                pipedInputStream = new PipedInputStream(pipedOutputStream);
            }catch(IOException ioe){
                ioe.printStackTrace();
            }
            ConsumerEntryPoint consumerEntryPoint = service.enterChannel(new ChannelName("//"+InetAddress.getLocalHost().getHostName()+"/disseminator"+args[1]+"/channel"+args[2]),1,new SimpleMessageListener(new PrintStream(pipedOutputStream,true)));
System.out.println("receiving data from consumer entry point: " + consumerEntryPoint.getName());
            ConsumerExample consumer = new ConsumerExample(consumerEntryPoint,pipedInputStream);
            consumer.show();
        }
        catch(Exception exc){
            exc.printStackTrace();
        }

    }
    
}
