package dimi.example;

import dimi.name.ChannelName;

import java.rmi.RemoteException;

import dimi.ProducerEntryPoint;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import java.io.*;

/**
 *
 * @author  mauricio
 */
public class ProducerEntryPointGUIExample extends javax.swing.JFrame {
    
    private ProducerEntryPoint producerEntryPoint = null;
    
    static Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    
    static int DISSEMINATION_UNIT_TAB_INDEX = 0;
    static int OUTPUT_TAB_INDEX = 1;
    static int OUTPUT_ERROR_TAB_INDEX = 2;

    /** Creates new form ProducerGUI */
    public ProducerEntryPointGUIExample(ProducerEntryPoint producerEntryPoint) throws RemoteException{
        initComponents();
        this.producerEntryPoint = producerEntryPoint;
        this.producerEntryPointTPane.setTitleAt(0, "Output");
        this.producerEntryPointTPane.addTab("Error Output",errorPanel);
        this.setTitle("Producer Example");
        //ajuste de dimensoes
        setBounds(0, 0, (screenSize.width/2)-100, (screenSize.height/2)-100);
        ChannelName producerEntryPointName = (ChannelName)producerEntryPoint.getName();
        producerEntryPointNameLabel.setText(producerEntryPointName.toString());
        disseminationUnitNameLabel.setText("@"+producerEntryPointName.getDisseminationUnitName().toString());
    }
    
    public JTextArea getTextArea(){
        return outputTextArea;
    }
    
    private PipedOutputStream pipedOutputStream = null;
    private PipedInputStream pipedInputStream = null;
    class OutputReader implements Runnable{
        public void run(){
            while(true){
                try{
                    pipedOutputStream = new PipedOutputStream();
                    pipedInputStream = new PipedInputStream(pipedOutputStream);
                }catch(IOException ioe){
                    ioe.printStackTrace();
                }
                System.setOut(new PrintStream(pipedOutputStream,true));
                byte[] barray = new byte[1];
                try{
                    while(true){
                        pipedInputStream.read(barray);
                        outputTextArea.append(new String(barray));
                    }
                }
                catch(IOException ioe){}
            }
        }
    }

    private PipedOutputStream pipedErrorOutputStream = null;
    private PipedInputStream pipedErrorInputStream = null;
    class ErrorReader implements Runnable{
        public void run(){
            while(true){
                try{
                    pipedErrorOutputStream = new PipedOutputStream();
                    pipedErrorInputStream = new PipedInputStream(pipedErrorOutputStream);
                }catch(IOException ioe){
                    ioe.printStackTrace();
                }
                System.setErr(new PrintStream(pipedErrorOutputStream,true));
                byte[] barray = new byte[1];
                try{
                    while(true){
                        pipedErrorInputStream.read(barray);
                        errorTextArea.append(new String(barray));
                        producerEntryPointTPane.setSelectedIndex(OUTPUT_ERROR_TAB_INDEX);
                    }
                }
                catch(IOException ioe){}
            }
        }
    }

    public void show(){
        super.show();
        Thread outputReaderThread = new Thread(new OutputReader());
        outputReaderThread.start();
        Thread errorReaderThread = new Thread(new ErrorReader());
        errorReaderThread.start();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        errorPanel = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        errorTextArea = new javax.swing.JTextArea();
        jPanel1 = new javax.swing.JPanel();
        terminateProductionButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        producerEntryPointTPane = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        outputTextArea = new javax.swing.JTextArea();
        jPanel3 = new javax.swing.JPanel();
        producerEntryPointNameLabel = new javax.swing.JLabel();
        disseminationUnitNameLabel = new javax.swing.JLabel();

        errorPanel.setLayout(new java.awt.BorderLayout());

        jScrollPane3.setViewportView(errorTextArea);

        errorPanel.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel1.setLayout(new java.awt.BorderLayout());

        terminateProductionButton.setText("Terminate Production!");
        terminateProductionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                terminateProductionButtonActionPerformed(evt);
            }
        });

        jPanel1.add(terminateProductionButton, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.BorderLayout());

        producerEntryPointTPane.setFont(new java.awt.Font("Serif", 2, 12));
        outputTextArea.setFont(new java.awt.Font("Default", 0, 10));
        jScrollPane1.setViewportView(outputTextArea);

        producerEntryPointTPane.addTab("tab1", jScrollPane1);

        jPanel2.add(producerEntryPointTPane, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel3.setFont(new java.awt.Font("Dialog", 1, 12));
        producerEntryPointNameLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        producerEntryPointNameLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        producerEntryPointNameLabel.setText("Name");
        jPanel3.add(producerEntryPointNameLabel, java.awt.BorderLayout.NORTH);

        disseminationUnitNameLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        disseminationUnitNameLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        disseminationUnitNameLabel.setText("@");
        jPanel3.add(disseminationUnitNameLabel, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel3, java.awt.BorderLayout.NORTH);

        pack();
    }//GEN-END:initComponents

    private void terminateProductionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_terminateProductionButtonActionPerformed
        try{
            producerEntryPoint.destroy();
            getTextArea().append("\n ** PRODUCTION TERMINATED! ** \n");
        }
        catch(RemoteException re){
            re.printStackTrace();
        }
    }//GEN-LAST:event_terminateProductionButtonActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel disseminationUnitNameLabel;
    private javax.swing.JPanel errorPanel;
    private javax.swing.JTextArea errorTextArea;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextArea outputTextArea;
    private javax.swing.JLabel producerEntryPointNameLabel;
    private javax.swing.JTabbedPane producerEntryPointTPane;
    private javax.swing.JButton terminateProductionButton;
    // End of variables declaration//GEN-END:variables
    
}
