package dimi.message;


import dimi.message.Message;
import java.rmi.RemoteException;
import java.rmi.Remote;

/**
 * Interface a ser implementada pelos usuarios consumidores para
 * realizar o que deve ser feito com as mensagens que chegarem pelo
 * canal.
 * @author mcmoraes
 */
public interface MessageListener extends Remote{

    /**
     * Metodo chamado toda vez que houver uma nova mensagem em um canal.
     * @param message a nova mensagem
     * @throws RemoteException indicate that either a communication failure or a protocol error has occurred
     */    
    public void onMessage(Message message) throws RemoteException;

}
