package dimi.message;

import dimi.message.MessageListener;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.io.Serializable;

/**
 * Implementacao da interface MessageListener.
 * @author mcmoraes
 */
public abstract class MessageListenerImpl extends UnicastRemoteObject implements MessageListener,Serializable{
    
    /**
     * Creates a new instance of MessageListenerImpl
     * @throws RemoteException indicate that either a communication failure or a protocol error has occurred
     */    
    public MessageListenerImpl() throws RemoteException{
        super();
    }
    
    /**
     * Metodo chamado toda vez que chegar uma nova mensagem pelo canal.
     * @param message a nova mensagem
     * @throws RemoteException indicate that either a communication failure or a protocol error has occurred
     */    
    abstract public void onMessage(Message message) throws RemoteException;
    
}
