package dimi.message.buffer;

import dimi.message.Message;
import dimi.message.buffer.MessageBufferImpl;
import java.util.Iterator;
import dimi.DisseminationUnitImpl;

/**
 * Segundo a politica de bufferizacao 'first drop', caso se queira inserir uma
 * mensagem que estoura a capacidade do buffer, a mensagem mais antiga e
 * descartada.
 * @author mcmoraes
 */
public abstract class FirstDropDisseminationUnitMessageBuffer extends DisseminationUnitMessageBuffer{
    
    /**
     * Creates a new instance of BoundedFifo
     * @param disseminator o disseminador dono do buffer
     * @param maximumSize o tamanho maximo do buffer (em bytes)
     */
    public FirstDropDisseminationUnitMessageBuffer(DisseminationUnitImpl disseminationUnitImpl, long maximumSize) {
        super(disseminationUnitImpl,maximumSize);
    }

    /**
     * Adiciona uma mensagem ao buffer.
     * @param message a mensagem a ser adicionada
     */    
    public abstract void add(Message message);
    
}
