package dimi.name;

/**
 * Um nome de canal
 * @author mcmoraes
 */
public class ChannelName extends DimiName{
    
    protected String channelLocalName = null;
    private DisseminationUnitName disseminationUnitName = null;
    
    /**
     * Creates a new instance of ChannelName.
     * @param name o nome desejado para o canal
     * @throws BadformedDimiNameException se o nome dado nao estiver bem-formado.
     */
    public ChannelName(String name) throws BadformedDimiNameException{
        super(name);
        // '//host:port/dissemination-unit_base/dissemination-unit_node/channel'
        int index_aux;
        if((index_aux= name.indexOf("/", 2))<0){
            throw new BadformedDimiNameException();
        }
        if((index_aux = name.indexOf("/", (index_aux+1)))<0){
            throw new BadformedDimiNameException();
        }
        int index_aux2 = index_aux; 
        if((index_aux2 = name.indexOf("/", (index_aux+1)))<0){
            disseminationUnitName = new DBaseName(name.substring(0,index_aux));
        }
        else{
            disseminationUnitName = new DNodeName(name.substring(0,index_aux));
            index_aux = index_aux2;
        }
        if((index_aux=name.indexOf("/", (index_aux+1))) > 0){
            throw new BadformedDimiNameException();
        }
        channelLocalName = name.substring(index_aux+1);
    }
    
    /**
     * Getter for property channelLocalName.
     * @return Value of property channelLocalName.
     */
    public final String getChannelLocalName() {
        return channelLocalName;
    }
    
    /**
     * Getter for property disseminationUnitName.
     * @return Value of property disseminationUnitName.
     */
    public DisseminationUnitName getDisseminationUnitName() {
        return disseminationUnitName;
    }

}
