// 
// PRIMOS - Primitives for Object Scheduling 
// 
// Copyright (C) 2002 Luciano Cavalheiro da Silva  <lucc@inf.ufrgs.br> 
//                    Claudio Fernando Resin Geyer <geyer@inf.ufrgs.br> 
// 
// This file is part of PRIMOS. 
// 
// PRIMOS is free software; you can redistribute it and/or 
// modify it under the terms of the GNU General Public License 
// as published by the Free Software Foundation; either version 2 
// of the License, or any later version. 
// 
// PRIMOS is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
// 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
// 

/**
* @file  MonitorImpl.hh 
* @brief interface MonitorImpl 
*
* @namespace primos::kernel::
* @cvsid $Id: MonitorImpl.hh 170 2004-03-19 20:13:46Z lucc $
*/

#ifndef primos_kernel_MonitorImpl_hh
#define primos_kernel_MonitorImpl_hh

#ifdef HAVE_CONFIG_H
#  include <acconfig.h>
#endif

#ifdef HAVE_INTTYPES_H
#  include <inttypes.h>
#endif

#ifdef HAVE_STRING
#  include <string>
#endif

#include "Sensor.hh"

namespace primos
{        
        /**
         * @class MonitorImpl 
         * @brief Interface of raw monitor implementations.
         *
         * @stereotype interface
         */
    class MonitorImpl
    {
            // Operations /////////////////////////////////////
    public:
            /**
             * @brief
             *
             */
        virtual
        ~MonitorImpl()
            {}
            
            /**
             * @brief
             *
             */
        virtual void
        quantumExpired() = 0;

            /**
             * @brief
             *
             */
        virtual const SensorSet&
        availableSensors() = 0;

        
        static MonitorImpl*
        newInstance();
            
            // Attributes /////////////////////////////////////

            // Associations ///////////////////////////////////

    };// MonitorImpl
    
}// namespace primos::kernel

#endif
