// Copyright 2002 Rodrigo Araujo Real
//		  Luciano Cavalheiro da Silva
//		  Iara Augustin
//		  Adenauer Correa Yamin
//                Gustavo Frainer
//		  Claudio Fernando Resin Geyer
//
// This file is part of TiPS. TiPS is a Probabilistic Scheduler
//
// TiPS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// TiPS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with TiPS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Id: TipsNodeScheduler.java 283 2004-10-15 20:19:08Z rreal $
//

package org.isam.exehda.services.tips;

import org.isam.exehda.Exehda;
import org.isam.exehda.HostId;
import org.isam.exehda.ObjectId;
import org.isam.exehda.services.Worb;
import org.isam.exehda.services.Scheduler;
import org.isam.exehda.services.AbstractService;
import org.isam.exehda.services.ResourceBroker.ResourceConstraint;


public class TipsNodeScheduler
    extends AbstractService
    implements Scheduler
{    

    private TipsCellScheduler tipsCell;
    final static String PROP_SCHEDULER_URI = "contactAddress";    

/**
         * Describe <code>chooseCreationHost</code> method here.
         *
         * @param c a <code>ResourceConstraints</code> value
         * @return a <code>HostId</code> value
         */
    public HostId chooseCreationHost( ResourceConstraint c ) 
        {
            return(tipsCell.chooseCreationHost(c));
        }
    

        /**
         * Describe <code>chooseMigrationHost</code> method here.
         *
         * @param c a <code>ResourceConstraints</code> value
         * @return a <code>HostId</code> value
         */
    public HostId chooseMigrationHost( ResourceConstraint c )
        {
            return(tipsCell.chooseMigrationHost(c));
        }


        /**
         * Describe <code>reschedule</code> method here.
         *
         * @param o an <code>ObjectHandle</code> value
         * @param c a <code>ResourceConstraints</code> value
         * @param auto a <code>boolean</code> value
         */
    public void reschedule( ObjectId o, ResourceConstraint c, boolean auto )
        {
                //repassar o retorno do TipsCellScheduler
        }


    public void stop() 
        {}

    public void start()
        throws Exception
        {
            Worb worb = (Worb) Exehda.getService(Worb.SERVICE_NAME);

            String tipsCellUri = Exehda.getServiceProperty(TipsCellScheduler.SERVICE_NAME,
                                                          PROP_SCHEDULER_URI,
                                                          "//localhost:1980/scheduler");

            tipsCell = (TipsCellScheduler)
                worb.lookupService(tipsCellUri, TipsCellScheduler.class);
        }
    
}
