
package exehda.mw;


/**
 * Generic job
 * 
 */
public abstract class Job
    implements java.io.Serializable, Runnable
{
    protected long timeGoal    = 0;
    protected String workerName = null;
    protected long elapsedTime = 0;

    abstract public int 
	getExitCode();

    abstract public boolean
    hasNext();

    abstract public void
    next();

    abstract public Object
    getParams();

    abstract public void
    init();

    abstract public void
    run();
    
    public void
    setWorkerName(String name) { workerName = name; }

    public String
    getWorkerName(String name) { return workerName; }

    public void
    setTimeGoal(long timegoal) { timeGoal = timegoal; }

    public long  
    getTimeGoal() { return timeGoal; }

    public void  
    setElapsedTime(long elapsedTime) { this.elapsedTime = elapsedTime; }

    public long  
    getElapsedTime() { return elapsedTime;}

    public String
    toString()
        {
            return "Worker <"+workerName+"> completed with exitcode "+getExitCode()+
                " elapsed time "+elapsedTime+"/"+timeGoal+"ms ";            
        }
}



