
package org.isam.perv.protocols.avu;


/**
 * Handler for the 'avu:' URL protocol.
 *
 * @author last modified by $Author: lucc $
 * @version $Revision: 990 $
 */
public class Handler
    extends java.net.URLStreamHandler
{

    static transient String avuHost = null;
    static transient int    avuPort;
    
    public Handler() 
        {
        }

    public static void config(String h, int port)
        {
            if ( avuHost == null ) {
                avuHost = h;
                avuPort = port;
            }
        }
    
    protected java.net.URLConnection
    openConnection( java.net.URL url ) throws java.io.IOException
        {
                // create a custom URLConnection and return it

                // by now use the default HttpURLConnection
                // need to setup avu host and replace the avu: protocol
                // by http:

            String user = url.toString().substring(6,url.toString().indexOf("@"));

            java.net.URL httpurl = new java.net.URL(
                "http",
                avuHost,
                avuPort,
                (url.getFile().startsWith("/") ? "" : "/") +url.getFile());

                        
            java.net.URLConnection avuConn =  httpurl.openConnection();
            avuConn.setDoOutput(true);
            avuConn.setRequestProperty("Isam-Avu-Operation","read");
            avuConn.setRequestProperty("Isam-User",user+"@"+url.getHost());
            
            return avuConn;
        }

    public static void
    main(String[] args) throws Exception
        {
            System.setProperty("java.protocol.handler.pkgs",
                               "org.isam.perv.protocols");

            java.net.URLConnection bdaConn =
                (new java.net.URL("avu://isam@gppd/WalkEd4.txt")).openConnection();
            bdaConn.setRequestProperty("Isam-Avu-Operation","write");

            System.out.println(bdaConn);
	    
                //testing

            java.io.BufferedWriter bw = new java.io.BufferedWriter(new java.io.OutputStreamWriter(bdaConn.getOutputStream()));

            bw.write("Teste teste");
            bw.newLine();
            bw.flush();
            bw.close();
	  

            java.io.BufferedReader br = new java.io.BufferedReader(new java.io.InputStreamReader(bdaConn.getInputStream()));
            int s;
	  
            while((s=br.read())!=-1){
                System.out.println(s);
            }
            br.close();

            if (args.length != 0 ) {
                System.out.println(
                    (new java.net.URL(args[0])).openConnection());
            }
        }
}
