// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.bda;

import org.isam.exehda.Exehda;
import org.isam.exehda.services.Service;
import org.isam.exehda.services.Logger;
import org.isam.perv.protocols.bda.Handler;

public class BdaImplClient
    implements Service
{
    final static String SERVICE_NAME = "bda";
    final static int DEFAULT_PORT = 1978;
    final static String DEFAULT_HOST = "localhost";

    public BdaImplClient()
        {
        }
    
    public void
    start() throws Exception
        {
            final String CLS = getClass().getName();
            final String MTD = "start()";
            
            String bdaHost = Exehda.getServiceProperty(
                SERVICE_NAME, "bdaHost", DEFAULT_HOST);
            
            int bdaPort = Exehda.getServiceProperty(
                SERVICE_NAME, "bdaPort", DEFAULT_PORT);
            
                // configure bda: protocol handler
            Handler.config(bdaHost, bdaPort);

            ((Logger) Exehda.getService(Logger.SERVICE_NAME))
                .info(CLS, MTD, "Set bdaHost to \"{0}\"", new Object[]{ bdaHost });
        }

    public void
    stop() throws Exception
        {
        }
}
