
package org.isam.perv.protocols.bda;


import java.net.URL;

/**
 * Handler for the 'bda:' URL protocol.
 *
 * @author lucc
 * @version $Date: 2005-07-14 14:53:05 -0300 (Thu, 14 Jul 2005) $ $Revision: 990 $ 
 */
public class Handler
    extends java.net.URLStreamHandler
{
    static transient String bdaHost = null;
    static transient int    bdaPort;
    
    public Handler() 
        {
        }

    public static void config(String h, int port)
        {
            if ( bdaHost == null ) {
                bdaHost = h;
                bdaPort = port;
            }
        }
    
    protected java.net.URLConnection
    openConnection( java.net.URL url ) throws java.io.IOException
        {
                // create a custom URLConnection and return it

                // by now use the default HttpURLConnection
                // need to setup bda host, replace the bda: protocol
                // by http:, also need to set operation to read
            String resourcePath = ( url.getHost().equals("") )
                ? url.getFile()
                : "/" + url.getHost() + "/" + url.getFile();

            java.net.URLConnection bdaConn =
                new java.net.URL("http", bdaHost, bdaPort, resourcePath)
                .openConnection();
            bdaConn.setDoOutput(true);
            bdaConn.setRequestProperty("Isam-Bda-Operation","read");
            return(bdaConn);
        }

    public static void
    main(String[] args) throws Exception
        {
            System.setProperty("java.protocol.handler.pkgs",
                               "org.isam.perv.protocols");
            System.getProperties().put("isam.bdaHost","localhost");

            java.net.URLConnection bdaConn =
                (new java.net.URL("bda://gppd/WalkEd?version=32")).openConnection();

                //testing
	    

            bdaConn.setDoOutput(true);
	    
            bdaConn.setRequestProperty("Isam-User","marky@ramones");
            bdaConn.setRequestProperty("Isam-Bda-Operation","read");

            System.out.println(bdaConn);

                // java.io.OutputStreamWriter ow = new java.io.OutputStreamWriter(bdaConn.getOutputStream());
// 	    ow.write("Contents");
// 	    ow.flush();
// 	    ow.close();

            java.io.BufferedReader br = new java.io.BufferedReader(new java.io.InputStreamReader(bdaConn.getInputStream()));
            String s;
	  
            while((s=br.readLine())!=null){
                System.out.println(s);
            }
            br.close();
                //done testing

            System.out.println(bdaConn);

	   
            if (args.length != 0 ) {
                System.out.println(
                    (new java.net.URL(args[0])).openConnection());
            }
        }
}
