// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.ctxm;

import org.isam.exehda.services.ContextManager.Context;

/**
 * Abstract class representing a filter that produces context information from raw sensor
 * data.
 *
 * ContextChains are built through the <code>getInstance()</code> which expects as
 * parameter a context element definition in XML.
 *
 * @todo specify the XML context defition format.
 *
 * @author last modified by $Author: lucc $
 * @version $Date: 2005-06-10 10:44:21 -0300 (Fri, 10 Jun 2005) $ $Revision: 883 $
 */
public abstract class ContextFilter
{
//         /**
//          * Installs a new chain factory.
//          *
//          * @param f a non-null <code>ContextChainFactory</code> value
//          */
//     public static void
//     setChainFactory ( ContextChainFactory f )
//         {
//             if ( f == null ) {
//                 throw new IllegalArgumentException("Factory must be non-null.");
//             }
//             ContextChain.factory = f;
//         }
    
//         /**
//          * Creates a new ContextChain.
//          *
//          * This is done by invoking <code>createChain()</code> in the currently
//          * configured factory.
//          *
//          * @param ctx defines allowed states for the context
//          * @param def defines how the context information should be produced
//          * @return a <code>ContextChain</code> value
//          */
//     public static ContextChain
//     getInstance ( Context ctx )
//         {
//             return factory.createChain(ctx);
//         }
    
//         /**
//          * Lists the underlaying sensors this chain depends on.
//          *
//          * @return a <code>String[]</code> value
//          */
//     public abstract String[]
//     getSensors();


//     static {
//         factory = new SingleSensorChainFactory();
//     }
//     private static ContextChainFactory factory;

        /**
         * Filters raw state data read from given <code>Environment</code>
         * object and processes it order to produce an abstract value (an String)
         * describing the state some high-level context element whose the definition was
         * used to create this filter.
         *
         * <p>Upon the first call to this method, it is expected that the current filter
         * implementation requests the <code>Environment</code> to enable the underling
         * sensor it needs to produce the context information.
         *
         * @param env State (raw) of current execution environment.
         * @return an String describing the state of the high-level context element
         * related to this filter.
         */
    public abstract String
    filter ( Environment env );

    
        //////////////////////////////////////////////////////////////
        // PROTECTED STUFF
        //////////////////////////////////////////////////////////////
    
    protected ContextFilter( String def )
        {
            this.def = def;
        }

    protected String def;
}

