package dimi;

import java.rmi.Remote;
import java.rmi.RemoteException;

import dimi.message.Message;
import dimi.name.DimiName;
import dimi.exception.CantFindChannelException;

/**
 * Interface de um disseminador.
 * @author mcmoraes
 */
public interface Disseminator extends Remote {

    /**
     * Dissemina uma mensagem em um canal.
     * @param message a mensagem a ser disseminada
     * @throws CantFindChannelException se nao for possivel encontrar o canal
     * @throws RemoteException indicate that either a communication failure or a protocol error has occurred
     */    
    public void disseminate(Message message) throws RemoteException,CantFindChannelException;

    /**
     * Obtem o nome do disseminador.
     * @throws RemoteException if failed to export object
     * @return o nome do disseminador
     */    
    public DimiName getName() throws RemoteException;
}
