package dimi.channel.neighbour;

import java.util.Comparator;

/**
 * Realiza a comparacao entre dois ponteiros para vizinhos em um canal.
 * @author mcmoraes
 */
public class NeighbourPointerComparator implements Comparator{
    
    /**
     * Realiza a comparacao entre dois ponteiros para vizinhos.
     * O ponteiro mais proximo e aquele que tiver a menor distancia.
     * @param o1 um ponteiro para vizinho
     * @param o2 um ponteiro para vizinho
     * @return 0 se tiverem a mesma distancia;
     * 1 se distancia(o1)>distancia(o2);
     * -1 se distancia(o2)>distancia(o1).
     */    
    public int compare(Object o1, Object o2) {
        NeighbourPointer neighbourPointer1 = (NeighbourPointer)o1;
        NeighbourPointer neighbourPointer2 = (NeighbourPointer)o2;
        
        long d1 = neighbourPointer1.getDistance();
        long d2 = neighbourPointer2.getDistance();
        
        if(d1 == d2){
            return 0;
        }
        else if(d1 > d2){
            return 1;
        }
        return -1;

    }
    
}
