package dimi.example;

import java.rmi.RemoteException;

import dimi.ConsumerEntryPoint;
import dimi.name.ConsumerEntryPointName;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import java.io.*;

/**
 *
 * @author  mauricio
 */
public class ConsumerEntryPointGUIExample extends javax.swing.JFrame {
    
    private ConsumerEntryPoint consumerEntryPoint = null;
    
    static Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    
    static int DISSEMINATION_UNIT_TAB_INDEX = 0;
    static int OUTPUT_TAB_INDEX = 1;
    static int OUTPUT_ERROR_TAB_INDEX = 2;
    
    /** Creates new form ConsumerGUI */
    public ConsumerEntryPointGUIExample(ConsumerEntryPoint consumerEntryPoint) throws RemoteException{
        initComponents();
        this.consumerEntryPoint = consumerEntryPoint;
        this.consumerEntryPointTPane.setTitleAt(0, "Output");
        this.consumerEntryPointTPane.addTab("Error Output",errorPanel);
        this.setTitle("Consumer Example");
        //ajuste de dimensoes
        setBounds(0, 0, (screenSize.width/2)-100, (screenSize.height/2)-100);
        ConsumerEntryPointName consumerEntryPointName = (ConsumerEntryPointName)consumerEntryPoint.getName();
        consumerEntryPointNameLabel.setText(consumerEntryPointName.toString());
        disseminationUnitNameLabel.setText("@"+consumerEntryPointName.getChannelName().getDisseminationUnitName().toString());
    }
    
    public JTextArea getTextArea(){
        return outputTextArea;
    }
    
    private PipedOutputStream pipedOutputStream = null;
    private PipedInputStream pipedInputStream = null;
    class OutputReader implements Runnable{
        public void run(){
            while(true){
                try{
                    pipedOutputStream = new PipedOutputStream();
                    pipedInputStream = new PipedInputStream(pipedOutputStream);
                }catch(IOException ioe){
                    ioe.printStackTrace();
                }
                System.setOut(new PrintStream(pipedOutputStream,true));
                byte[] barray = new byte[1];
                try{
                    while(true){
                        pipedInputStream.read(barray);
                        outputTextArea.append(new String(barray));
                    }
                }
                catch(IOException ioe){}
            }
        }
    }

    private PipedOutputStream pipedErrorOutputStream = null;
    private PipedInputStream pipedErrorInputStream = null;
    class ErrorReader implements Runnable{
        public void run(){
            while(true){
                try{
                    pipedErrorOutputStream = new PipedOutputStream();
                    pipedErrorInputStream = new PipedInputStream(pipedErrorOutputStream);
                }catch(IOException ioe){
                    ioe.printStackTrace();
                }
                System.setErr(new PrintStream(pipedErrorOutputStream,true));
                byte[] barray = new byte[1];
                try{
                    while(true){
                        pipedErrorInputStream.read(barray);
                        errorTextArea.append(new String(barray));
                        consumerEntryPointTPane.setSelectedIndex(OUTPUT_ERROR_TAB_INDEX);
                    }
                }
                catch(IOException ioe){}
            }
        }
    }

    public void show(){
        super.show();
        Thread outputReaderThread = new Thread(new OutputReader());
        outputReaderThread.start();
        Thread errorReaderThread = new Thread(new ErrorReader());
        errorReaderThread.start();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        errorPanel = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        errorTextArea = new javax.swing.JTextArea();
        jPanel1 = new javax.swing.JPanel();
        terminateConsumptionButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        consumerEntryPointTPane = new javax.swing.JTabbedPane();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        outputTextArea = new javax.swing.JTextArea();
        jPanel4 = new javax.swing.JPanel();
        disseminationUnitNameLabel = new javax.swing.JLabel();
        consumerEntryPointNameLabel = new javax.swing.JLabel();

        errorPanel.setLayout(new java.awt.BorderLayout());

        jScrollPane3.setViewportView(errorTextArea);

        errorPanel.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel1.setLayout(new java.awt.BorderLayout());

        terminateConsumptionButton.setText("Terminate Consumption!");
        terminateConsumptionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                terminateConsumptionButtonActionPerformed(evt);
            }
        });

        jPanel1.add(terminateConsumptionButton, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.BorderLayout());

        consumerEntryPointTPane.setFont(new java.awt.Font("Dialog", 2, 12));
        jPanel3.setLayout(new java.awt.BorderLayout());

        outputTextArea.setFont(new java.awt.Font("Default", 0, 10));
        jScrollPane1.setViewportView(outputTextArea);

        jPanel3.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        consumerEntryPointTPane.addTab("tab1", jPanel3);

        jPanel2.add(consumerEntryPointTPane, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        jPanel4.setLayout(new java.awt.BorderLayout());

        disseminationUnitNameLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        disseminationUnitNameLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        disseminationUnitNameLabel.setText("@");
        jPanel4.add(disseminationUnitNameLabel, java.awt.BorderLayout.CENTER);

        consumerEntryPointNameLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        consumerEntryPointNameLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        consumerEntryPointNameLabel.setText("Name");
        jPanel4.add(consumerEntryPointNameLabel, java.awt.BorderLayout.NORTH);

        getContentPane().add(jPanel4, java.awt.BorderLayout.NORTH);

        pack();
    }//GEN-END:initComponents

    private void terminateConsumptionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_terminateConsumptionButtonActionPerformed
        try{
            consumerEntryPoint.destroy();
            getTextArea().append("\n ** CONSUMPTION TERMINATED! ** \n");
        }
        catch(RemoteException re){
            re.printStackTrace();
        }
    }//GEN-LAST:event_terminateConsumptionButtonActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel consumerEntryPointNameLabel;
    private javax.swing.JTabbedPane consumerEntryPointTPane;
    private javax.swing.JLabel disseminationUnitNameLabel;
    private javax.swing.JPanel errorPanel;
    private javax.swing.JTextArea errorTextArea;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextArea outputTextArea;
    private javax.swing.JButton terminateConsumptionButton;
    // End of variables declaration//GEN-END:variables
    
}
