package dimi.message.buffer;

import dimi.message.Message;

/**
 * Interface do mediador vista pelo buffer de mensagens de conexao.
 * @author mcmoraes
 */
public interface ConnectionMessageBufferMediator extends MessageBufferMediator{
    
    /**
     * Adiciona a mensagem ao buffer do conexao.
     * @param buffer o buffer que deve receber a mensagem
     * @param message a mensagem a ser adicionada
     */    
    public void addToConnectionMessageBuffer(ConnectionMessageBuffer buffer,Message message);
    /**
     * Remove a mensagem do buffer do disseminador.
     * @param buffer o buffer do qual deve ser removida a mensagem
     * @param message a mensagem a ser removida
     */    
    public void removeFromConnectionMessageBuffer(ConnectionMessageBuffer buffer,Message message);
    
}
