package dimi.name;

/**
 * Um nome de unidade de disseminacao
 * @author mcmoraes
 */
public class DBaseName extends DisseminationUnitName{
    
    private String host = null;
    private String port = null;
    private String dbaseLocalName = null;
    
    /**
     * Creates a new instance of DisseminationUnitName
     * @param name o nome desejado para a unidade de disseminacao
     * @throws BadformedDimiNameException se o nome nao for bem-formado
     */
    public DBaseName(String name) throws BadformedDimiNameException{
        super(name);
        // '//host:port/disseminator_base'
        if(!name.startsWith("//")){
            throw new BadformedDimiNameException();
        }
        int index_aux;
        if((index_aux = name.indexOf("/", 2))<0){
            throw new BadformedDimiNameException();
        }
        int colonIndex;
        if((colonIndex = name.indexOf(":")) >= 0){
            port = name.substring(colonIndex,index_aux);
            try{
                Integer.valueOf(port);
            }catch(NumberFormatException nfe){
                throw new BadformedDimiNameException();
            }
            host = name.substring(2, colonIndex);
        }
        else{
            host = name.substring(2,index_aux);
        }
        if(name.indexOf("/", (index_aux+1))>0){
            throw new BadformedDimiNameException();
        }
        dbaseLocalName = name.substring(index_aux+1);
    }
    
    /**
     * Getter for property host.
     * @return Value of property host.
     */
    public String getHost() {
        return host;
    }
    
    /**
     * Getter for property port.
     * @return Value of property port.
     */
    public String getPort() {
        return port;
    }
    
    /**
     * Getter for property dbaseLocalName.
     * @return Value of property dbaseLocalName.
     */
    public java.lang.String getDbaseLocalName() {
        return dbaseLocalName;
    }
    
}
