package dimi.name;

/**
 * Um nome de unidade de disseminacao
 * @author mcmoraes
 */
public class DNodeName extends DisseminationUnitName{
    
    private DBaseName dbaseName = null;
    private String dnodeLocalName = null;
    
    /**
     * Creates a new instance of DisseminationUnitName
     * @param name o nome desejado para a unidade de disseminacao
     * @throws BadformedDimiNameException se o nome nao for bem-formado
     */
    public DNodeName(String name) throws BadformedDimiNameException{
        super(name);
        // '//host:port/dissemination-unit_base/dissemination-unit_node'
        int index_aux;
        if((index_aux= name.indexOf("/", 2))<0){
            throw new BadformedDimiNameException();
        }
        if((index_aux = name.indexOf("/", (index_aux+1)))<0){
            throw new BadformedDimiNameException();
        }
        dbaseName = new DBaseName(name.substring(0,index_aux));
        if((index_aux=name.indexOf("/", (index_aux+1))) > 0){
            throw new BadformedDimiNameException();
        }
        dnodeLocalName = name.substring(index_aux+1);
    }
    
    /**
     * Getter for property disseminationUnitLocalName.
     * @return Value of property disseminationUnitLocalName.
     */
    public String getDNodeLocalName() {
        return dnodeLocalName;
    }
    
    /**
     * Getter for property dbaseName.
     * @return Value of property dbaseName.
     */
    public DBaseName getDbaseName() {
        return dbaseName;
    }
    
}
