/*
 * ResourceComponent.java
 *
 * Created on 20 de Maio de 2004, 14:11
 */

package org.isam.exehda.services.perdis;

import org.isam.exehda.services.DiscovererService;
import org.isam.exehda.services.Logger;
import org.isam.exehda.services.Worb;
import org.isam.exehda.Exehda;
import org.isam.exehda.ResourceName;
import org.isam.util.xml.XmlElement;
import java.io.FileReader;
import java.io.IOException;
import java.util.Vector;
import java.util.Date;


/**
 *
 * @author  egon
 */
public class ResourceComponent {

    private String descriptorFileName;
    private XmlElement xmlResourceDescriptor;
    private ResourceName rn;
        
    private DiscovererService discoverer;
    private Logger logger;
    
    private LeaseRenewer leaseRenewer;
      

    /**
     * Creates a new instance of ResourceComponent
     */
    public ResourceComponent(String descriptorFileName) throws Exception {

        this.descriptorFileName = descriptorFileName;
        this.xmlResourceDescriptor = XmlElement.parse(new FileReader(descriptorFileName));
        
        this.discoverer = (DiscovererService) Exehda.getService(DiscovererService.SERVICE_NAME);
        this.logger = (Logger) Exehda.getService(Logger.SERVICE_NAME);
                                  
        this.rn = this.registerResource();
    }


    /**
     * registerResource
     */
    public ResourceName registerResource() throws Exception {

        ResourceName rn = this.discoverer.registerResource(this.xmlResourceDescriptor);
        
        //Create lease renewer
        this.leaseRenewer = new LeaseRenewer(this.discoverer, this.descriptorFileName, rn);
        this.leaseRenewer.start();
        
        return rn;
    }

    /**
     * removeResource
     */
    public void removeResource() {
        
        this.leaseRenewer.stopLeaseRenewer();  
        this.discoverer.removeResource(this.rn);
    }
       
    /**
     * main
     */
    public static void main(String args[]) throws Exception {

       //verify the correct number of parameters
        if (args.length != 1) {
            throw new Exception("Invalid number of arguments: you must provide a descriptorFileName");
        }
        
        //Testing register
               
        ResourceComponent resourceComponent = new ResourceComponent(args[0]);
        
        while(true) { }
    }
}
