// 
// PRIMOS - Primitives for Object Scheduling 
// 
// Copyright (C) 2002 Luciano Cavalheiro da Silva  <lucc@inf.ufrgs.br> 
//                    Claudio Fernando Resin Geyer <geyer@inf.ufrgs.br> 
// 
// This file is part of PRIMOS. 
// 
// PRIMOS is free software; you can redistribute it and/or 
// modify it under the terms of the GNU General Public License 
// as published by the Free Software Foundation; either version 2 
// of the License, or any later version. 
// 
// PRIMOS is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
// 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
// 

/**
* @file  SensorParameter.hh 
* @brief 
*
* @namespace primos::kernel::
* @cvsid $Id: SensorParameter.hh 170 2004-03-19 20:13:46Z lucc $
*/

#ifndef primos_SensorParameter_hh
#define primos_SensorParameter_hh

#ifdef HAVE_CONFIG_H
#  include <acconfig.h>
#endif

#ifdef HAVE_STRING
#  include <string>
#else
#  error "Missing C++ header: <string>"
#endif

#ifdef HAVE_SET
#  include <set>
#else
#  error "Missing C++ header: <set>"
#endif


namespace primos
{
    
        /**
         * @class SensorParameter 
         * @brief 
         *
         */
    class SensorParameter
    {
            // Operations /////////////////////////////////////
    public:
            /**
             * @brief 
             *
             */
        SensorParameter( const std::string name, const std::string type )
                : name(name),type(type)
            {}
            
            /**
             * @brief 
             *
             */
        const std::string&
        Name() const
            {
                return name;
            }

            /**
             * @brief 
             *
             */
        const std::string&
        Type() const
            {
                return type;
            }

        bool
        operator <(SensorParameter& sp ) 
            {
                return this->name < sp.name;
            }

        friend struct PtrComparator 
        {
            bool
            operator ()(const SensorParameter* sp1, const SensorParameter* sp2)
                {
                    return sp1->name < sp2->name;
                }
        };
            
            // Attributes /////////////////////////////////////
    private:
        std::string name;
        std::string type;

            // Associations ///////////////////////////////////

    };// SensorParameter



    typedef std::set<SensorParameter*, SensorParameter::PtrComparator> SensorParameterSet;

}// namespace primos
    
#endif
