// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.primos.objseed;

import org.isam.exehda.ObjectId;
import org.isam.exehda.services.ObjectSeed.MarshaledOX;
import org.isam.exehda.services.Logger.Sev;

class ThreadActivator
    extends AbstractActivator
{
    private final int THR_SHUTDOWN_TIMEOUT_MS = 150;
    
    public void activate( ObjectId oxID, Object obj, MarshaledOX extState )
        {
            log(Sev.DEBUG, "activate()", "Activating thread object...");
            Thread t = (Thread) obj;
            t.start();
        }
    
    public void deactivate( ObjectId oxID, Object obj, MarshaledOX oxState )
        {
            log(Sev.DEBUG, "deactivate()", "Deactivating thread object...");
            Thread t = (Thread) obj;
            t.interrupt();
            
            try {
                Thread.sleep(THR_SHUTDOWN_TIMEOUT_MS);
            }
            catch (InterruptedException ie) {}

            t.stop();
        }
}
