/*
 * JobMasterImpl.java
 *
 * Created on June 3, 2005, 1:21 PM
 */

package exehda.mw;

import org.isam.exehda.Exehda;
import org.isam.exehda.HostId;
import org.isam.exehda.ApplicationId;
import org.isam.exehda.services.Executor;
import org.isam.exehda.ObjectId;
import org.isam.exehda.services.ObjectSeed.Activator;
import org.isam.exehda.services.Worb;
// import org.isam.exehda.services.primos.objseed.*;


/**
 *
 * @author frainer
 */

class WorkerCreationThread extends Thread{
    JobMasterImpl jm;
    WorkerCreator wc;
    boolean die;
    int numInitialSlaves;
    boolean keepCreatingSlaves;
    
    public WorkerCreationThread(JobMasterImpl jm, int numInitialSlaves, boolean keepCreatingSlaves){
        this.jm = jm;
        wc = new WorkerCreator();
        die = false;
        this.numInitialSlaves = numInitialSlaves;
        this.keepCreatingSlaves = keepCreatingSlaves;
    }
    
    public void run(){
        //create the initial slaves
        wc.createWorkers(numInitialSlaves,jm.getContactAddress(),jm.getJobCriteria());
        if(keepCreatingSlaves == true){
            while(!die){
                //wait the time especified by the jobmaster
                try{
                    Thread.sleep(jm.getTimeBetweenCreation());
                }catch(java.lang.InterruptedException e){e.printStackTrace();}
                //create one worker
                wc.createWorkers(1,jm.getContactAddress(),jm.getJobCriteria());

            }
        }
    }
    
    public void kill(){
        die = true;
    }
    
}


public class JobMasterImpl implements JobMaster{
    WorkSplitter ws;
    WorkJoiner wj;
    WorkerCreationThread wcThread;
    volatile long timeBetweenCreation;
    String jobCriteria;
    String contactAddress;
    int numInitialSlaves;
    boolean keepCreatingSlaves;
      
    /** Creates a new instance of JobMasterImpl */
    public JobMasterImpl(WorkSplitter ws, WorkJoiner wj, String jobCriteria, int numInitialSlaves, boolean keepCreatingSlaves) {
        this.ws = ws;
        this.wj = wj;
        this.jobCriteria = jobCriteria;
        timeBetweenCreation = 10000;  
        this.numInitialSlaves = numInitialSlaves;
        this.keepCreatingSlaves = keepCreatingSlaves;
        //startWorkerCreation();
    }
    
    public Job
    getJob(Object params) throws java.rmi.RemoteException{
        
        //if it is an creation status message...
        if(params instanceof WorkerCreationStatus){
            WorkerCreationStatus wcs = (WorkerCreationStatus)params;
            if(wcs.hasSuceeded()){
                System.out.println("UHUUUUUUUUUUUUUUUUUUUUUJJJUUUUUUUUUUUUUUUU ---- SUcesso!!@!!!!!!!!");
                //decrease the time between worker creation
                timeBetweenCreation -= 1000;
                if(timeBetweenCreation < 5000){
                    timeBetweenCreation = 5000;
                }
            }
            else{
                System.out.println("UHUUUUUUUUUUUUUUUUUUUUUJJJUUUUUUUUUUUUUUUU ---- Fracasso!!@!!!!!!!!");
                //increase the time between worker creation so that we don't create a bunch of useless workers
                timeBetweenCreation += 2000;
            }
            return(null);
        }
        
        Job j = ws.getJob(params);
        //if there are no more jobs then don't create any more workers
        if(j == null){
            wcThread.kill();
        }
        
        return(j);
    }
    
    public void
    publishResult(Job job) throws java.rmi.RemoteException{
        wj.publishResult(job);
    }

    public void startWorkerCreation(){
        
        //export the master to the worb
        Worb worb = (Worb)Exehda.getService("worb");
        
        contactAddress = worb.exportService(this, JobMaster.class, "JobMaster");
        
        //start worker creation thead passing this as the parameter
        wcThread = new WorkerCreationThread(this,numInitialSlaves,keepCreatingSlaves);
        
        //start thread with the correct APPID
        ApplicationId APPID;
        APPID = ((Executor) Exehda.getService(Executor.SERVICE_NAME))
	    .currentApplication();
        
        ((Executor) Exehda.getService(Executor.SERVICE_NAME))
	    .runAction(APPID,wcThread);
    }
    
    public String getContactAddress(){
        return(contactAddress);
    }
    
    public String getJobCriteria(){
        return(jobCriteria);
    }
    
    public long getTimeBetweenCreation(){
        return(timeBetweenCreation);
    }
    
    
}
